/*
   BrightnessProfileUnit.h

   hlavikov soubor okna pro zobrazen jasovho profilu dku, i sloupce

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/	
//---------------------------------------------------------------------------
#ifndef BrightnessProfileUnitH
#define BrightnessProfileUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "Headers\bmp_handler.h"
#include "Headers\image_grey.h"
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include "PERFGRAP.h"
#include <Menus.hpp>
#include <Dialogs.hpp>
//---------------------------------------------------------------------------
class TBrightnessProfileForm : public TForm
{
__published:	// IDE-managed Components
        TMainMenu *MainMenu1;
        TMenuItem *Type1;
        TMenuItem *Rows;
        TMenuItem *Columns;
        TMenuItem *N1;
        TMenuItem *Close1;
        TPanel *Panel1;
        TStatusBar *StatusBar1;
        TImage *Image1;
        TMenuItem *Save;
        TSaveDialog *SaveDialog;
        void __fastcall Close1Click(TObject *Sender);
        void __fastcall RowsClick(TObject *Sender);
        void __fastcall ColumnsClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall SaveClick(TObject *Sender);
private:	// User declarations
        BMPHandler* profile_handler;
        GreyImage* original_image;
        int max_points, last_x, last_y;
        TPoint points[1024];
        AnsiString file_path;
public:		// User declarations
        __fastcall TBrightnessProfileForm(TComponent* Owner);
        __fastcall ~TBrightnessProfileForm();
        void __fastcall ShowAxes();
        void __fastcall ShowGraph(int x, int y);
        bool __fastcall IfFileExistsThenOverWrite(AnsiString _path);
};
//---------------------------------------------------------------------------
extern PACKAGE TBrightnessProfileForm *BrightnessProfileForm;
//---------------------------------------------------------------------------
#endif
