/*
   BrightnessUnit.cpp

   definin soubor okna pro korekci jasu

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/	
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "BrightnessUnit.h"
#include "Headers\scale.h"
#include "PictureUnit.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TBrightnessForm *BrightnessForm;
//---------------------------------------------------------------------------
__fastcall TBrightnessForm::TBrightnessForm(TComponent* Owner)
        : TForm(Owner)
{
   Top = PictureForm->Top+30;
   Left = PictureForm->Left + PictureForm->Width - 30 - Width;

   original_image = new GreyImage();
   sized_image = new GeometricImage();
   bright_image = new GreyImage();
   bright_handler = new BMPHandler(*(PictureForm->GetBMPHandler()));
   bright_handler->Set(*original_image);
   Scale scale(*original_image, *sized_image, Image1->Width);

   if (sized_image->Cols() > sized_image->Rows()){
     Image2->Top=Image2->Top + (sized_image->Cols()-sized_image->Rows())/2;
   }else if (sized_image->Rows() > sized_image->Cols()){
     Image2->Left=Image2->Left + (sized_image->Rows()-sized_image->Cols())/2;
   }

   bright_handler->Assign(*sized_image);
   brightness = new Brightness(*sized_image, *bright_image);
   bright_handler->Show(Image1);
   bright_handler->Show(Image2);
}
//---------------------------------------------------------------------------
__fastcall TBrightnessForm::~TBrightnessForm()
{
   delete (bright_handler);
   delete (sized_image);
   delete (bright_image);
   delete (brightness);
   delete (original_image);
}
//---------------------------------------------------------------------------
void __fastcall TBrightnessForm::TrackBarChange(TObject *Sender)
{
   brightness -> AdjImageBrightness((short)TrackBar -> Position, 0, 0,
                                    sized_image->Cols(), sized_image->Rows());
   bright_handler->Assign(*bright_image);
   bright_handler->Show(Image2);
   PositionEdit->Text = TrackBar -> Position;
}
//---------------------------------------------------------------------------


void __fastcall TBrightnessForm::ResetButtonClick(TObject *Sender)
{
   TrackBar -> Position = 0;
   brightness -> AdjImageBrightness((short)TrackBar -> Position, 0, 0,
                                    sized_image->Cols(), sized_image->Rows());
   bright_handler->Assign(*bright_image);
   bright_handler->Show(Image2);
}
//---------------------------------------------------------------------------
void __fastcall TBrightnessForm::OKBitBtnClick(TObject *Sender)
{
   brightness = new Brightness(*original_image, *bright_image);
   brightness -> AdjImageBrightness((short)TrackBar -> Position, 0,0,
                        original_image->Cols(), original_image->Rows());
   PictureForm->AssignList(bright_image);
   Close();
}
//---------------------------------------------------------------------------

void __fastcall TBrightnessForm::CancelBitBtnClick(TObject *Sender)
{
   Close();
}
//---------------------------------------------------------------------------

void __fastcall TBrightnessForm::FormClose(TObject *Sender,
      TCloseAction &Action)
{
   Release();
}
//---------------------------------------------------------------------------

