/*
   BrightnessUnit.h

   hlavikov soubor okna pro korekci jasu

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef BrightnessUnitH
#define BrightnessUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include "Headers\bmp_handler.h"
#include "Headers\geometric_image.h"
#include "Headers\image_grey.h"
#include "Headers\brightness.h"
#include <Buttons.hpp>
//---------------------------------------------------------------------------
class TBrightnessForm : public TForm
{
__published:	// IDE-managed Components
        TPanel *Panel1;
        TButton *ResetButton;
        TBitBtn *OKBitBtn;
        TBitBtn *CancelBitBtn;
        TBevel *Bevel1;
        TStatusBar *StatusBar1;
        TPanel *Panel5;
        TPanel *Panel6;
        TImage *Image1;
        TImage *Image2;
        TPanel *Panel4;
        TLabel *Label2;
        TEdit *PositionEdit;
        TTrackBar *TrackBar;
        void __fastcall TrackBarChange(TObject *Sender);
        void __fastcall ResetButtonClick(TObject *Sender);
        void __fastcall OKBitBtnClick(TObject *Sender);
        void __fastcall CancelBitBtnClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
private:	// User declarations
        BMPHandler* bright_handler;
        GeometricImage* sized_image;
        GreyImage* bright_image;
        GreyImage* original_image;
        Brightness* brightness;
public:		// User declarations
        __fastcall TBrightnessForm(TComponent* Owner);
        __fastcall ~TBrightnessForm();
};
//---------------------------------------------------------------------------
extern PACKAGE TBrightnessForm *BrightnessForm;
//---------------------------------------------------------------------------
#endif
