/*
   CircleProfileUnit.h

   hlavikov soubor okna pro zobrazen profilu po krunici

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef CircleProfileUnitH
#define CircleProfileUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include "Headers\in_out.h"
#include "Headers\bmp_handler.h"
#include "Headers\image_grey.h"
#include "Headers\geometric_image.h"
#include <Graphics.hpp>
#include <Dialogs.hpp>
//---------------------------------------------------------------------------
class TCircleProfileForm : public TForm
{
__published:	// IDE-managed Components
        TPanel *Panel1;
        TBitBtn *OKBitBtn;
        TPanel *Panel2;
        TImage *Image1;
        TStatusBar *StatusBar1;
        TPanel *Panel4;
        TLabel *Label2;
        TPanel *Panel5;
        TLabel *Label4;
        TImage *Image3;
        TUpDown *UpDown2;
        TUpDown *UpDown3;
        TUpDown *UpDown1;
        TPanel *Panel3;
        TImage *Image2;
        TBitBtn *BitBtn1;
        TSaveDialog *SaveDialog;
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall OKBitBtnClick(TObject *Sender);
        void __fastcall ComputeGraph(GreyImage* image, int r, int c, int rad);
        void __fastcall ShowAxes();
        void __fastcall ShowGraph(int new_r, int new_c, int new_rad);
        void __fastcall UpDown1Click(TObject *Sender, TUDBtnType Button);
        void __fastcall UpDown2Click(TObject *Sender, TUDBtnType Button);
        void __fastcall UpDown3Click(TObject *Sender, TUDBtnType Button);
        void __fastcall RecountLimits();
        void __fastcall ShowCircle();
        void __fastcall BitBtn1Click(TObject *Sender);
        bool __fastcall IfFileExistsThenOverWrite(AnsiString _path);
private:	// User declarations
        int CircleCentreR, CircleCentreC, CircleRadius, MaxCol, MaxRow;
        int max_r, max_c, max_rad;
        float RS; // ReduceSize
        VInOut* file_txt;
        
        BMPHandler* handler;
        GreyImage* original_image;
        GreyImage* sized_image;
        GreyImage* circle_image;
        GreyImage* graph_image;

        int last_c, last_r, last_rad;
        TPoint points[360];
        AnsiString file_path;
public:		// User declarations
        __fastcall TCircleProfileForm(TComponent* Owner);
        __fastcall ~TCircleProfileForm();
};
//---------------------------------------------------------------------------
extern PACKAGE TCircleProfileForm *CircleProfileForm;
//---------------------------------------------------------------------------
#endif
