/*
   LineProfileUnit.h

   hlavikov soubor okna pro zobrazen profilu po sece

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef LineProfileUnitH
#define LineProfileUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include "Headers\in_out.h"
#include "Headers\bmp_handler.h"
#include "Headers\image_grey.h"
#include "Headers\geometric_image.h"
#include <Dialogs.hpp>
//---------------------------------------------------------------------------
class TLineProfileForm : public TForm
{
__published:	// IDE-managed Components
        TStatusBar *StatusBar1;
        TPanel *Panel1;
        TBitBtn *OKBitBtn;
        TPanel *Panel2;
        TImage *Image1;
        TPanel *Panel3;
        TImage *Image2;
        TGroupBox *GroupBox1;
        TUpDown *UpDown2;
        TUpDown *UpDown1;
        TGroupBox *GroupBox2;
        TUpDown *UpDown4;
        TUpDown *UpDown3;
        TBitBtn *BitBtn1;
        TSaveDialog *SaveDialog;
        void __fastcall ShowLine();
        void __fastcall ShowAxes();
        void __fastcall ShowGraph(int new_p1r, int new_p1c, int new_p2r, int new_p2c);
        void __fastcall ComputeGraph(GreyImage* image, int r1, int c1, int r2, int c2);
        void __fastcall UpDown1Click(TObject *Sender, TUDBtnType Button);
        void __fastcall UpDown2Click(TObject *Sender, TUDBtnType Button);
        void __fastcall UpDown3Click(TObject *Sender, TUDBtnType Button);
        void __fastcall UpDown4Click(TObject *Sender, TUDBtnType Button);
        void __fastcall BitBtn1Click(TObject *Sender);
        bool __fastcall IfFileExistsThenOverWrite(AnsiString _path);
private:	// User declarations
        int P1r, P1c, P2r, P2c, MaxCol, MaxRow;
        int last_p1r, last_p1c, last_p2r, last_p2c;
        float RS; // ReduceSize
        VInOut* file_txt;
        AnsiString ext, file_name;

        BMPHandler* handler;
        GreyImage* original_image;
        GreyImage* sized_image;
        GreyImage* line_image;
        GreyImage* graph_image;

        TPoint points[360];
        AnsiString file_path;
public:		// User declarations
        __fastcall TLineProfileForm(TComponent* Owner);
        __fastcall ~TLineProfileForm();
};
//---------------------------------------------------------------------------
extern PACKAGE TLineProfileForm *LineProfileForm;
//---------------------------------------------------------------------------
#endif
