/*
   CentroidUnit.h

   hlavikov soubor okna pro vpoet tit obrazu - centroidu

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef CentroidUnitH
#define CentroidUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include "Headers\bmp_handler.h"
#include "Headers\geometric_image.h"
#include "Headers\image_grey.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
class TCentroidForm : public TForm
{
__published:	// IDE-managed Components
        TStatusBar *StatusBar1;
        TPanel *Panel1;
        TPanel *Panel2;
        TBitBtn *BitBtn1;
        TLabel *Label1;
        TEdit *Edit1;
        TEdit *Edit2;
        TImage *Image1;
        TLabel *Label2;
        TPanel *Panel3;
        TLabel *Label3;
        TEdit *Edit3;
        TUpDown *PercentUpDown;
        void __fastcall BitBtn1Click(TObject *Sender);
        void __fastcall Edit3Change(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall PercentUpDownClick(TObject *Sender,
          TUDBtnType Button);
private:	// User declarations
         GreyImage* centroid_image;
         GreyImage* sized_image;
         BMPHandler* centroid_handler;
         int x_position;
         int y_position;
         int object_value;
         int object_area;
         int x_coordinate;
         int y_coordinate;
         float x_rate; // (x_new_size/x_original_size)
         float y_rate; // (y_new_size/y_original_size)
public:		// User declarations
        __fastcall TCentroidForm(TComponent* Owner);
        __fastcall ~TCentroidForm();
        void __fastcall ComputeCentre();
};
//---------------------------------------------------------------------------
extern PACKAGE TCentroidForm *CentroidForm;
//---------------------------------------------------------------------------
#endif
