/*
   SnrPsnrUnit.h

   hlavikov soubor okna pro vpoet parametr SNR/PSNR

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef SnrPsnrUnitH
#define SnrPsnrUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include "..\Headers\frame_image.h"
#include "..\Headers\bmp_handler.h"
#include "..\Headers\image_grey.h"
#include "..\Headers\scale.h"
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>
//---------------------------------------------------------------------------
class TSnrPsnrForm : public TForm
{
__published:	// IDE-managed Components
        TStatusBar *StatusBar1;
        TPanel *Panel1;
        TLabel *Label1;
        TLabel *Label2;
        TLabel *Label3;
        TPanel *Panel2;
        TImage *Image1;
        TPanel *Panel4;
        TImage *Image3;
        TBitBtn *BitBtn1;
        TBitBtn *BitBtn2;
        TButton *Button1;
        TPanel *Panel3;
        TImage *Image2;
        TOpenDialog *OpenDialog;
        TLabel *Label4;
        TLabel *Label5;
        TEdit *Edit1;
        TEdit *Edit2;
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall Button1Click(TObject *Sender);
        void __fastcall ComputeAndShowErrorImage();
        void __fastcall ComputeSNR();
        void __fastcall ComputePSNR();
        void __fastcall BitBtn1Click(TObject *Sender);
        void __fastcall BitBtn2Click(TObject *Sender);
private:	// User declarations
        // handlers
        BMPHandler* handler;

        // full images
        GreyImage* reconstructed_image;
        GreyImage* original_image;
        GreyImage* error_image;

        // sized images
        GreyImage* sized_reconstructed_image;
        GreyImage* sized_original_image;
        GreyImage* sized_error_image;

        // other
        float SNR, PSNR, point1, point2, point_diff;
        AnsiString original_file_name;

public:		// User declarations
        __fastcall TSnrPsnrForm(TComponent* Owner);
        __fastcall ~TSnrPsnrForm();
};
//---------------------------------------------------------------------------
extern PACKAGE TSnrPsnrForm *SnrPsnrForm;
//---------------------------------------------------------------------------
#endif
