/*
   StatisticsUnit.h

   hlavikov soubor okna pro vpoet statistickch veliin

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef StatisticsUnitH
#define StatisticsUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include "Headers\bmp_handler.h"
#include "Headers\geometric_image.h"
#include "Headers\image_grey.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
class TStatisticsForm : public TForm
{
__published:	// IDE-managed Components
        TStatusBar *StatusBar1;
        TPanel *Panel1;
        TBitBtn *BitBtn1;
        TPanel *Panel2;
        TImage *Image1;
        TLabel *Label2;
        TLabel *Label1;
        TLabel *Label4;
        TEdit *Edit1;
        TEdit *Edit2;
        TEdit *Edit3;
        TLabel *Label3;
        TEdit *Edit4;
        TEdit *Edit5;
        TEdit *Edit6;
        TLabel *Label5;
        TLabel *Label6;
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
private:	// User declarations
         GreyImage* statistics_image;
         GreyImage* sized_image;
         BMPHandler* statistics_handler;
         float mean, dispersion, deviation, entropy;
public:		// User declarations
        __fastcall TStatisticsForm(TComponent* Owner);
        __fastcall ~TStatisticsForm();
        void __fastcall ComputeMean(GreyImage* image);
        void __fastcall ComputeDispersion(GreyImage* image);
        void __fastcall ComputeEntropy(GreyImage* image);
};
//---------------------------------------------------------------------------
extern PACKAGE TStatisticsForm *StatisticsForm;
//---------------------------------------------------------------------------
#endif
