/*
   CMYToolUnit.h

   hlavikov soubor okna pro pravu jednotlivch kanl v CMYK modelu

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef CMYToolUnitH
#define CMYToolUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include "Headers\image.h"
#include "Headers\image_grey.h"
#include "Headers\image_const.h"
#include "Headers\image_color.h"
#include "Headers\image_float.h"
#include "Headers\bmp.h"
#include "Headers\bmp_handler.h"
#include "Headers\bmp_handler_color.h"
#include "Headers\scale.h"
#include "Headers\scale_color.h"
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
class TCMYToolForm : public TForm
{
__published:	// IDE-managed Components
        TStatusBar *StatusBar1;
        TPanel *Panel1;
        TPanel *Panel5;
        TImage *Image1;
        TBitBtn *BitBtn1;
        TBitBtn *BitBtn2;
        TPanel *Panel3;
        TTrackBar *TrackBar1;
        TTrackBar *TrackBar3;
        TTrackBar *TrackBar2;
        TEdit *Edit1;
        TEdit *Edit2;
        TEdit *Edit3;
        TButton *Button1;
        TTimer *Timer1;
        TLabel *Label4;
        TLabel *Label5;
        TLabel *Label6;
        TPanel *Panel6;
        TImage *Image2;
        void __fastcall BitBtn2Click(TObject *Sender);
        void __fastcall TrackBar1Change(TObject *Sender);
        void __fastcall TrackBar2Change(TObject *Sender);
        void __fastcall TrackBar3Change(TObject *Sender);
        void __fastcall Timer1Timer(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall Button1Click(TObject *Sender);
        void __fastcall BitBtn1Click(TObject *Sender);
private:	// User declarations
        BMPHandlerColor* color_handler;

        ColorImage* color_image;
        ColorImage* scaled_color_image;
        ColorImage* CMY_scale;

        FloatImage* c_image;
        FloatImage* m_image;
        FloatImage* y_image;

        FloatImage* c_image_temp;
        FloatImage* m_image_temp;
        FloatImage* y_image_temp;

        FloatImage* c_scale;
        FloatImage* m_scale;
        FloatImage* y_scale;

        FloatImage* c_scale_temp;
        FloatImage* m_scale_temp;
        FloatImage* y_scale_temp;

        short scale;
        bool change_c, change_m, change_y;

public:		// User declarations
        __fastcall TCMYToolForm(TComponent* Owner);
        __fastcall ~TCMYToolForm();
         void __fastcall Change(FloatImage* old_values, FloatImage* new_values,float _f);
         void __fastcall Show_Scale();
};
//---------------------------------------------------------------------------
extern PACKAGE TCMYToolForm *CMYToolForm;
//---------------------------------------------------------------------------
#endif
