/*
   GreyScaleUnit.cpp

   definin soubor okna pro pevod barevnho obrazu do edotnov stupnice

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "GreyScaleUnit.h"
#include "PictureUnit.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TGreyScaleForm *GreyScaleForm;
//---------------------------------------------------------------------------
// constructor
__fastcall TGreyScaleForm::TGreyScaleForm(TComponent* Owner)
        : TForm(Owner)
{
   type_conversion = 1;
   Top = PictureForm->Top+30;
   Left = PictureForm->Left + PictureForm->Width - 30 - Width;

   color_handler = new BMPHandlerColor(*(PictureForm->GetBMPHandlerColor()));
   color_image = new ColorImage();
   color_handler->Set(*color_image);
   scaled_color_image = new ColorImage();
   Scale_color scale1(*color_image, *scaled_color_image, Image1->Width);

   if (scaled_color_image->Cols() > scaled_color_image->Rows()){
     Image2->Top=Image2->Top + (scaled_color_image->Cols()-scaled_color_image->Rows())/2;
   }else if (scaled_color_image->Rows() > scaled_color_image->Cols()){
     Image2->Left=Image2->Left + (scaled_color_image->Rows()-scaled_color_image->Cols())/2;
   }

   color_handler->CreateBitmapAndAssign(scaled_color_image);
   color_handler->Show(Image1);

   scaled_Y_image = new GreyImage(scaled_color_image->Cols(), scaled_color_image->Rows());
   scaled_color_image->GreyScale(1, scaled_Y_image);
   Y_handler = new BMPHandler();
   Y_handler->CreateBitmapAndAssign(scaled_Y_image);
   Y_handler->Show(Image2);

   Edit1->Text = "0.2126";
   Edit2->Text = "0.7152";
   Edit3->Text = "0.0722";
   
   StatusBar1->SimpleText = ("You can change the type of conversion.");
}
//---------------------------------------------------------------------------
// destructor
__fastcall TGreyScaleForm::~TGreyScaleForm()
{
   delete Y_image;
   delete scaled_Y_image;
   delete color_image;
   delete scaled_color_image;
   delete Y_handler;
   delete color_handler;
}
//---------------------------------------------------------------------------
// first type of conversion
void __fastcall TGreyScaleForm::RadioButton1Click(TObject *Sender)
{
   Edit1->Text = "0.2126";
   Edit2->Text = "0.7152";
   Edit3->Text = "0.0722";
   type_conversion = 1;
   scaled_color_image->GreyScale(1, scaled_Y_image);
   Y_handler->CreateBitmapAndAssign(scaled_Y_image);
   Y_handler->Show(Image2);
}
//---------------------------------------------------------------------------
//second type of conversion
void __fastcall TGreyScaleForm::RadioButton2Click(TObject *Sender)
{
   type_conversion = 2;
   Edit1->Text = "0.2990";
   Edit2->Text = "0.5870";
   Edit3->Text = "0.1140";
   scaled_color_image->GreyScale(2, scaled_Y_image);
   Y_handler->CreateBitmapAndAssign(scaled_Y_image);
   Y_handler->Show(Image2);
}//---------------------------------------------------------------------------
//third type of conversion
void __fastcall TGreyScaleForm::RadioButton3Click(TObject *Sender)
{
   type_conversion = 3;
   Edit1->Text = "0.3333";
   Edit2->Text = "0.3333";
   Edit3->Text = "0.3333";
   scaled_color_image->GreyScale(3, scaled_Y_image);
   Y_handler->CreateBitmapAndAssign(scaled_Y_image);
   Y_handler->Show(Image2);
}
//---------------------------------------------------------------------------
// OK button
void __fastcall TGreyScaleForm::OKBitBtnClick(TObject *Sender)
{
   Y_image = new GreyImage(color_image->Cols(), color_image->Rows());
   PictureForm->StatusBar1->Panels->Items[4]->Text = "Grey scale image";
   color_image->GreyScale(type_conversion, Y_image);
   PictureForm->CreateGreyImage(Y_image);

   PictureForm->MSave->Visible = false;
   PictureForm->MView->Visible = true;
   PictureForm->MActualView1->Visible = false;
   PictureForm->MZoomIn1->Visible = true;
   PictureForm->MZoomOut1->Visible = true;
   PictureForm->MMagnifyingGlass->Visible = true;
   PictureForm->MShowMoreImage->Visible = true;
   PictureForm->MEdit->Visible = true;
   PictureForm->MUndo1->Visible = true;
   PictureForm->MCut1->Visible = false;
   PictureForm->MResize1->Visible = true;
   PictureForm->MTranslate->Visible = true;
   PictureForm->MFFTSize->Visible = true;
   PictureForm->MRotate1->Visible = true;
   PictureForm->MImage->Visible = true;
   PictureForm->MNoise1->Visible = true;
   PictureForm->MContrast->Visible = true;
   PictureForm->MBrightness->Visible = true;
   PictureForm->MProfile->Visible = true;
   PictureForm->MHistogram1->Visible = true;
   PictureForm->MConvolution1->Visible = true;
   PictureForm->LUT1->Visible = true;
   PictureForm->DFT1->Visible = true;
   PictureForm->MLogicArith1->Visible = true;
   PictureForm->MObject1->Visible = true;
   PictureForm->MMorpholog1->Visible = true;
   PictureForm->MNonlinearFiltres1->Visible = true;
   PictureForm->MBitFields1->Visible = true;
   PictureForm->MSobelFilters1->Visible = true;
   PictureForm->MCharacteristics->Visible = true;
   PictureForm->MCorrection->Visible = true;
   PictureForm->MAveraging->Visible = true;
   PictureForm->MColor->Visible = true;
   PictureForm->MPseudoColor->Visible = true;
   PictureForm->MSplitToRGB->Visible = false;
   PictureForm->MGreyScale->Visible = false;
   PictureForm->MAdjust->Visible = false;
   Close();
}
//---------------------------------------------------------------------------
// Cancel button
void __fastcall TGreyScaleForm::CancelBitBtnClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
// Release
void __fastcall TGreyScaleForm::FormClose(TObject *Sender,
      TCloseAction &Action)
{
   Release();
}
//---------------------------------------------------------------------------


