/*
   GreyScaleUnit.h

   hlavikov soubor okna pro pevod barevnho obrazu do edotnov stupnice

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef GreyScaleUnitH
#define GreyScaleUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "Headers\image.h"
#include "Headers\image_grey.h"
#include "Headers\image_const.h"
#include "Headers\image_color.h"
#include "Headers\bmp.h"
#include "Headers\bmp_handler.h"
#include "Headers\bmp_handler_color.h"
#include "Headers\scale.h"
#include "Headers\scale_color.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
//---------------------------------------------------------------------------
class TGreyScaleForm : public TForm
{
__published:	// IDE-managed Components
        TPanel *GreyScaleForm;
        TPanel *Panel2;
        TPanel *Panel3;
        TBitBtn *OKBitBtn;
        TBitBtn *CancelBitBtn;
        TStatusBar *StatusBar1;
        TPanel *Panel1;
        TRadioButton *RadioButton1;
        TRadioButton *RadioButton2;
        TRadioButton *RadioButton3;
        TPanel *Panel4;
        TLabel *Label1;
        TEdit *Edit1;
        TLabel *Label2;
        TEdit *Edit2;
        TLabel *Label3;
        TEdit *Edit3;
        TLabel *Label4;
        TImage *Image1;
        TImage *Image2;
        void __fastcall RadioButton2Click(TObject *Sender);
        void __fastcall RadioButton1Click(TObject *Sender);
        void __fastcall RadioButton3Click(TObject *Sender);
        void __fastcall OKBitBtnClick(TObject *Sender);
        void __fastcall CancelBitBtnClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
private:	// User declarations
        BMPHandler* Y_handler;
        BMPHandlerColor* color_handler;
        ColorImage* color_image;
        ColorImage* scaled_color_image;
        GreyImage* Y_image;
        GreyImage* scaled_Y_image;
        short scale1, scale2;
        int type_conversion;
public:		// User declarations
        __fastcall TGreyScaleForm(TComponent* Owner);
        __fastcall ~TGreyScaleForm();
};
//---------------------------------------------------------------------------
extern PACKAGE TGreyScaleForm *GreyScaleForm;
//---------------------------------------------------------------------------
#endif
