/*
   HSVToolUnit.h

   hlavikov soubor okna pro pravu jednotlivch kanl v HSV modelu

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef HSVToolUnitH
#define HSVToolUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <StdCtrls.hpp>
#include "Headers\image.h"
#include "Headers\image_grey.h"
#include "Headers\image_const.h"
#include "Headers\image_color.h"
#include "Headers\image_float.h"
#include "Headers\bmp.h"
#include "Headers\bmp_handler.h"
#include "Headers\bmp_handler_color.h"
#include "Headers\scale.h"
#include "Headers\scale_color.h"
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
class THSVToolForm : public TForm
{
__published:	// IDE-managed Components
        TStatusBar *StatusBar1;
        TPanel *Panel1;
        TPanel *Panel5;
        TBitBtn *BitBtn1;
        TBitBtn *BitBtn2;
        TTimer *Timer1;
        TPanel *Panel3;
        TTrackBar *TrackBar1;
        TTrackBar *TrackBar3;
        TTrackBar *TrackBar2;
        TLabel *Label1;
        TLabel *Label2;
        TLabel *Label3;
        TPanel *Panel4;
        TImage *Image2;
        TPanel *Panel6;
        TImage *Image3;
        TEdit *Edit3;
        TEdit *Edit2;
        TEdit *Edit1;
        TButton *Button1;
        TImage *Image1;
        void __fastcall BitBtn4Click(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall TrackBar1Change(TObject *Sender);
        void __fastcall TrackBar2Change(TObject *Sender);
        void __fastcall TrackBar3Change(TObject *Sender);
        void __fastcall BitBtn2Click(TObject *Sender);
        void __fastcall Timer1Timer(TObject *Sender);
        void __fastcall Button1Click(TObject *Sender);
private:	// User declarations
        BMPHandlerColor* color_handler;

        FloatImage* h_image;
        FloatImage* s_image;
        FloatImage* v_image;

        FloatImage* h_image_temp;
        FloatImage* s_image_temp;
        FloatImage* v_image_temp;

        FloatImage* h_scale;
        FloatImage* s_scale;
        FloatImage* v_scale;

        FloatImage* h_scale_temp;
        FloatImage* s_scale_temp;
        FloatImage* v_scale_temp;

        ColorImage* color_image;
        ColorImage* scaled_color_image;

        //for showing
        ColorImage*  HSV_scale;
        
        short scale;
        bool change_h, change_s, change_v;
public:		// User declarations
        __fastcall THSVToolForm(TComponent* Owner);
        __fastcall ~THSVToolForm();
        void __fastcall Change(FloatImage* old_values, FloatImage* new_values, float _f, bool overflow);
        void __fastcall Show_Scale();
};
//---------------------------------------------------------------------------
extern PACKAGE THSVToolForm *HSVToolForm;
//---------------------------------------------------------------------------
#endif
