/*
   RGBComponentUnit.h

   hlavikov soubor okna pro editaci jednotlivch kanl (erven, modr, zelen)

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef RGBComponentUnitH
#define RGBComponentUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include "Headers\image.h"
#include "Headers\image_grey.h"
#include "Headers\image_const.h"
#include "Headers\image_color.h"
#include "Headers\bmp.h"
#include "Headers\bmp_handler.h"
#include "Headers\bmp_handler_color.h"
#include "Headers\scale.h"
#include "Headers\scale_color.h"
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
//---------------------------------------------------------------------------
class TRGBComponentsForm : public TForm
{
__published:	// IDE-managed Components
        TPanel *Panel1;
        TStatusBar *StatusBar1;
        TPanel *Panel2;
        TBitBtn *BitBtn1;
        TPanel *Panel3;
        TBitBtn *BitBtn2;
        TPanel *Panel4;
        TBitBtn *BitBtn3;
        TPanel *Panel5;
        TBitBtn *BitBtn4;
        TBitBtn *BitBtn5;
        TImage *Image1;
        TImage *Image2;
        TImage *Image3;
        TImage *Image4;
        void __fastcall BitBtn4Click(TObject *Sender);
        void __fastcall BitBtn1Click(TObject *Sender);
        void __fastcall BitBtn3Click(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall BitBtn5Click(TObject *Sender);
        void __fastcall BitBtn2Click(TObject *Sender);
private:	// User declarations
        BMPHandler* red_handler;
        BMPHandler* green_handler;
        BMPHandler* blue_handler;
        BMPHandlerColor* color_handler;

        GreyImage* red_image;
        GreyImage* green_image;
        GreyImage* blue_image;
        ColorImage* color_image;
        ColorImage* original_color_image;

        GreyImage* scaled_red_image;
        GreyImage* scaled_green_image;
        GreyImage* scaled_blue_image;
        ColorImage* scaled_color_image;

        short scale,staleR,scaleG,scaleB;
        AnsiString original_text;
        bool only_exit;
public:		// User declarations]
        __fastcall TRGBComponentsForm(TComponent* Owner);
        __fastcall ~TRGBComponentsForm();
        void __fastcall AssignChangedImage(GreyImage _image, int _type);
        void __fastcall PrepareMenuEdit();
        void __fastcall PrepareMenuColor();
};
//---------------------------------------------------------------------------
extern PACKAGE TRGBComponentsForm *RGBComponentsForm;
//---------------------------------------------------------------------------
#endif
