/*
   ColorBoxUnit.cpp

   definin soubor okna pro monost vybrn hodnoty stupnice edi

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "ColoBoxUnit.h"
#include "DrawUnit.h"
#include "RotateUnit.h"
#include "PictureUnit.h"


//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TColorBoxForm *ColorBoxForm;
//---------------------------------------------------------------------------
__fastcall TColorBoxForm::TColorBoxForm(TComponent* Owner)
        : TForm(Owner),point_position(100),with_users(true)
{
  Top = PictureForm->Top+30;
  Left = PictureForm->Left + PictureForm->Width - 50 - Width - 270;

  width = Width;
  Width = width*0.724;
  Panel1->Color = (TColor)0x00000000;
  Panel2->Color = (TColor)0x00111111;
  Panel3->Color = (TColor)0x00222222;
  Panel4->Color = (TColor)0x00333333;
  Panel5->Color = (TColor)0x00444444;
  Panel6->Color = (TColor)0x00555555;
  Panel7->Color = (TColor)0x00666666;
  Panel8->Color = (TColor)0x00777777;
  Panel9->Color = (TColor)0x00888888;
  Panel10->Color = (TColor)0x00999999;
  Panel11->Color = (TColor)0x00aaaaaa;
  Panel12->Color = (TColor)0x00bbbbbb;
  Panel13->Color = (TColor)0x00cccccc;
  Panel14->Color = (TColor)0x00dddddd;
  Panel15->Color = (TColor)0x00eeeeee;
  Panel16->Color = (TColor)0x00ffffff;

  double k = 256/(double)Image->Height;
  for(int i(0); i<=Image->Height; i++){
     Image->Canvas->Brush->Color = (TColor)((double)i*k+
        0x100*(int)((double)i*k)+0x10000*(int)((double)i*k));
     Image->Canvas->FillRect(TRect(0,i,Image->Width,i+1));
  }
  ResultPanel->Color = Panel1->Color;
  DrawPoint(point_position);

}
//---------------------------------------------------------------------------

void __fastcall TColorBoxForm::OnPanelClick(TObject *Sender)
{
    if (Sender == Panel1){
       ResultPanel->Color = Panel1->Color;
    }else if (Sender == Panel2){
       ResultPanel->Color = Panel2->Color;
    }else if (Sender == Panel3){
       ResultPanel->Color = Panel3->Color;
    }else if (Sender == Panel4){
       ResultPanel->Color = Panel4->Color;
    }else if (Sender == Panel5){
       ResultPanel->Color = Panel5->Color;
    }else if (Sender == Panel6){
       ResultPanel->Color = Panel6->Color;
    }else if (Sender == Panel7){
       ResultPanel->Color = Panel7->Color;
    }else if (Sender == Panel8){
       ResultPanel->Color = Panel8->Color;
    }else if (Sender == Panel9){
       ResultPanel->Color = Panel9->Color;
    }else if (Sender == Panel10){
       ResultPanel->Color = Panel10->Color;
    }else if (Sender == Panel11){
       ResultPanel->Color = Panel11->Color;
    }else if (Sender == Panel12){
       ResultPanel->Color = Panel12->Color;
    }else if (Sender == Panel13){
       ResultPanel->Color = Panel13->Color;
    }else if (Sender == Panel14){
       ResultPanel->Color = Panel14->Color;
    }else if (Sender == Panel15){
       ResultPanel->Color = Panel15->Color;
    }else if (Sender == Panel16){
       ResultPanel->Color = Panel16->Color;
    }

}
//---------------------------------------------------------------------------
void __fastcall TColorBoxForm::DrawPoint(int Y)
{
   Image->Canvas->Pen->Mode = pmNotXor;
   Image->Canvas->Brush->Style = bsClear;
   Image->Canvas->Pen->Color = clBlack;
   LeftTop.x =  (int)((double)Image->Width/(double)4);
   RightDown.x = (int)(3*(double)Image->Width/(double)4);
   LeftTop.y = Y-(int)((double)Image->Width/(double)4);
   RightDown.y = Y+(int)((double)Image->Width/(double)4);
   Image->Canvas->MoveTo(0,Y);
   Image->Canvas->LineTo(Image->Width,Y);
   Image->Canvas->MoveTo(Image->Width/2,Y-Image->Width/2);
   Image->Canvas->LineTo(Image->Width/2,Y+Image->Width/2);
   Image->Canvas->Ellipse(LeftTop.x,LeftTop.y,RightDown.x,RightDown.y);
   double k = 256/(double)Image->Height;
   ResultPanel->Color = (TColor)((double)Y*k+
        0x100*(int)((double)Y*k)+0x10000*(int)((double)Y*k));
}

void __fastcall TColorBoxForm::ImageMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
   if(LeftTop.y<Y && Y<RightDown.y){
      drawing = true;
   }
}
//---------------------------------------------------------------------------

void __fastcall TColorBoxForm::ImageMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
   if (drawing){
      if(Y<0)
         Y=0;
      if(Y>Image->Height-1)
         Y=Image->Height-1;
      DrawPoint(point_position);
      point_position = Y;
      DrawPoint(point_position);
   }
}
//---------------------------------------------------------------------------

void __fastcall TColorBoxForm::ImageMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
   if(drawing)
      drawing = false;        
}
//---------------------------------------------------------------------------


void __fastcall TColorBoxForm::Button1Click(TObject *Sender)
{
   if(with_users){
      Width = width;
      with_users = false;
   }else{
      Width= width*0.724;
      with_users = true;
   }      
}
//---------------------------------------------------------------------------

void __fastcall TColorBoxForm::CancelButtonClick(TObject *Sender)
{
   Close();
}
//---------------------------------------------------------------------------

void __fastcall TColorBoxForm::BitBtn1Click(TObject *Sender)
{
   switch(kind){
      case brush:
         DrawForm->Image->Canvas->Brush->Color = ResultPanel->Color;
         break;
      case pen:
         DrawForm->Image->Canvas->Pen->Color = ResultPanel->Color;
         break;
      case other:
         RotateForm->Panel2->Color = ResultPanel->Color;
         break;
   }
}
//---------------------------------------------------------------------------

