/*
   ContrastUnit.h

   hlavikov soubor okna pro korekci kontrastu

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef ContrastUnitH
#define ContrastUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include "Headers\bmp_handler.h"
#include "Headers\geometric_image.h"
#include "Headers\image_grey.h"
#include "Headers\contrast.h"
#include "Headers\brightness.h"
//---------------------------------------------------------------------------
class TContrastForm : public TForm
{
__published:	// IDE-managed Components
        TPanel *Panel1;
        TButton *ResetButton;
        TBitBtn *OKBitBtn;
        TBitBtn *CancelBitBtn;
        TBevel *Bevel1;
        TPanel *Panel4;
        TLabel *Label1;
        TTrackBar *TrackBar;
        TEdit *PositionEdit;
        TStatusBar *StatusBar1;
        TPanel *Panel5;
        TPanel *Panel6;
        TImage *Image1;
        TImage *Image2;
        void __fastcall TrackBarChange(TObject *Sender);
        void __fastcall CancelBitBtnClick(TObject *Sender);
        void __fastcall ResetButtonClick(TObject *Sender);
        void __fastcall OKBitBtnClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
private:	// User declarations
        float position;
        BMPHandler* contrast_handler;
        GeometricImage* sized_image;
        GreyImage* contrast_image;
        GreyImage* original_image;
        Contrast* contrast;
public:		// User declarations
        __fastcall TContrastForm(TComponent* Owner);
        __fastcall ~TContrastForm();
};
//---------------------------------------------------------------------------
extern PACKAGE TContrastForm *ContrastForm;
//---------------------------------------------------------------------------
#endif
