/*
   ConvolutionUnit.h

   hlavikov soubor hlavnho konvolunho okna

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef ConvolutionUnitH
#define ConvolutionUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include "..\Headers\bmp_handler.h"
#include "..\Headers\image_grey.h"
#include "..\Headers\convolution.h"
#include "..\Headers\kernel.h"
#include "..\Headers\scale.h"
#include <Dialogs.hpp>
#include <ComCtrls.hpp>
//---------------------------------------------------------------------------
class TConvolutionForm : public TForm
{
__published:	// IDE-managed Components
        TMainMenu *MainMenu1;
        TMenuItem *MKernel;
        TMenuItem *MOpen;
        TPanel *Panel1;
        TBitBtn *OKBitBtn;
        TBitBtn *CancelBitBtn;
        TMenuItem *MMIPS;
        TMenuItem *MLowFilter3x3;
        TButton *PerformButton;
        TMenuItem *MHighFilter;
        TMenuItem *MLP1;
        TMenuItem *MLP2;
        TMenuItem *MLP3;
        TMenuItem *MHP1;
        TMenuItem *MHP2;
        TMenuItem *MHP3;
        TMenuItem *MShiftDiff;
        TMenuItem *MVertical;
        TMenuItem *MHorizontal;
        TMenuItem *MHorizVertical;
        TMenuItem *MVert;
        TMenuItem *MHor;
        TMenuItem *MGradientDirectEdge;
        TMenuItem *MNorth;
        TMenuItem *MNorthEast;
        TMenuItem *MEast;
        TMenuItem *MSouthEast;
        TMenuItem *MSouth;
        TMenuItem *MSouthWest;
        TMenuItem *MWest;
        TMenuItem *MNOrthWest;
        TMenuItem *MBlurringKerner;
        TMenuItem *B3x3;
        TMenuItem *B5X5;
        TOpenDialog *OpenDialog;
        TMenuItem *MNewKernel;
        TMenuItem *MSave;
        TMenuItem *N1;
        TBevel *Bevel1;
        TStatusBar *StatusBar;
        TCheckBox *PreviewCheckBox;
        TBitBtn *ViewBitBtn;
        TMenuItem *MLaplace;
        TMenuItem *MLAP1;
        TMenuItem *MLAP2;
        TMenuItem *MLAP3;
        TMenuItem *MLAP4;
        TSaveDialog *SaveDialog;
        TCheckBox *CylindricCheckBox;
        TMenuItem *MLineVertical;
        TMenuItem *MLineHorizontal;
        TMenuItem *MLine_45;
        TMenuItem *MLine_135;
        TMenuItem *Maxabs1;
        TMenuItem *DerivativeNorth11;
        TMenuItem *DerivativeNorth21;
        TMenuItem *DerivativeNorthEast11;
        TMenuItem *DerivativeEast11;
        TMenuItem *DerivativeEast21;
        TMenuItem *DerivatedSouthEast11;
        TMenuItem *DerivativeSouthEast21;
        TMenuItem *DerivativeSouth11;
        TMenuItem *DerivativeSouth21;
        TMenuItem *DerivativeSouthWest11;
        TMenuItem *DerivativeSouthWest21;
        TMenuItem *DerivativeWest11;
        TMenuItem *DerivativeWest21;
        TMenuItem *DerivativeNorthWest11;
        TMenuItem *DerivativeNorthWest21;
        TMenuItem *Laplacian11;
        TMenuItem *Laplacian21;
        TMenuItem *Laplacian31;
        TMenuItem *Laplacian41;
        TMenuItem *Enhancementsmall1;
        TMenuItem *Enhancementnormal1;
        TMenuItem *Enhancementstrong1;
        TMenuItem *Enhancementmaximum1;
        TMenuItem *Enhancementtype11;
        TMenuItem *EnhancementType21;
        TMenuItem *EnhancementType31;
        TMenuItem *EnhancementType41;
        TMenuItem *Smoothing11;
        TMenuItem *Smoothing21;
        TMenuItem *Smoothing31;
        TMenuItem *Smoothing41;
        TMenuItem *DerivativeHorizontal11;
        TMenuItem *DerivativeHorizontal21;
        TMenuItem *DerivativeVertical11;
        TMenuItem *DerivativeVertical21;
        TMenuItem *VerticalLineDetect1;
        TMenuItem *HorizontalLineDetect1;
        TMenuItem *N1stDiagonalDetection1;
        TMenuItem *N2ndDiagonalDetection2;
        TMenuItem *Derivative1;
        TMenuItem *N2;
        TMenuItem *N3;
        TMenuItem *Effectfilters1;
        TMenuItem *N5;
        TMenuItem *N7;
        TMenuItem *N3levelMaxabsmask11;
        TMenuItem *N3levelMaxabsmask21;
        TMenuItem *N3levelMaxabsmask31;
        TMenuItem *N3levelMaxabsmask41;
        TMenuItem *N9;
        TMenuItem *N3levelMaxabsmask15x51;
        TMenuItem *N3levelMaxabsmask25x51;
        TMenuItem *N3levelMaxabsmask35x51;
        TMenuItem *N3levelMaxabsmask45x51;
        TMenuItem *N10;
        TMenuItem *N3levelMaxabsmask17x71;
        TMenuItem *N3levelMaxabsmask27x71;
        TMenuItem *N3levelMaxabsmask37x71;
        TMenuItem *N3levelMaxabsmask47x71;
        TMenuItem *N11;
        TMenuItem *N3levelMaxabsmask19x91;
        TMenuItem *N3levelMaxabsmask29x91;
        TMenuItem *N3levelMaxabsmask39x91;
        TMenuItem *N3levelMaxabsmask49x91;
        TMenuItem *N12;
        TMenuItem *EdgeFilters1;
        TMenuItem *N5levelMaxabsmask13x31;
        TMenuItem *N5levelMaxabsmask23x31;
        TMenuItem *N5levelMaxabsmask33x31;
        TMenuItem *N5levelMaxabsmask43x31;
        TMenuItem *Robertsmeansquaremask11;
        TMenuItem *Robertsmeansquaremask21;
        TMenuItem *MathFunctions1;
        TMenuItem *SobelMeanSquaremask11;
        TMenuItem *SobelMeanSquaremask21;
        TMenuItem *N14;
        TMenuItem *CompassMaxmask11;
        TMenuItem *CompassMaxmask21;
        TMenuItem *CompassMaxmask31;
        TMenuItem *CompassMaxmask41;
        TMenuItem *CompassMaxmask51;
        TMenuItem *CompassMaxmask61;
        TMenuItem *CompassMaxmask71;
        TMenuItem *CompassMaxmask81;
        TMenuItem *KirschMaxmask11;
        TMenuItem *KirschMaxmask21;
        TMenuItem *KirschMaxmask31;
        TMenuItem *KirschMaxmask41;
        TMenuItem *KirschMaxmask51;
        TMenuItem *KirschMaxmask61;
        TMenuItem *KirschMaxmask71;
        TMenuItem *KirschMaxmask81;
        TMenuItem *N8;
        TMenuItem *Smoothing1;
        TMenuItem *Enhancement1;
        TMenuItem *Passfilters1;
        TMenuItem *N4;
        TMenuItem *N6;
        TMenuItem *CompassMax1;
        TMenuItem *kirschMax1;
        TMenuItem *Square1;
        TMenuItem *N13;
        TMenuItem *N15;
        TMenuItem *N16;
        TPanel *Panel5;
        TImage *Image3;
        TImage *Image1;
        TPanel *Panel6;
        TImage *Image2;
        void __fastcall PerformButtonClick(TObject *Sender);
        void __fastcall OKBitBtnClick(TObject *Sender);
        void __fastcall CancelBitBtnClick(TObject *Sender);
        void __fastcall MLP1Click(TObject *Sender);
        void __fastcall MLP2Click(TObject *Sender);
        void __fastcall MLP3Click(TObject *Sender);
        void __fastcall MHP3Click(TObject *Sender);
        void __fastcall MHP2Click(TObject *Sender);
        void __fastcall MHP1Click(TObject *Sender);
        void __fastcall MVerticalClick(TObject *Sender);
        void __fastcall MHorizontalClick(TObject *Sender);
        void __fastcall MHorizVerticalClick(TObject *Sender);
        void __fastcall MVertClick(TObject *Sender);
        void __fastcall MHorClick(TObject *Sender);
        void __fastcall MNorthClick(TObject *Sender);
        void __fastcall MNorthEastClick(TObject *Sender);
        void __fastcall MEastClick(TObject *Sender);
        void __fastcall MSouthEastClick(TObject *Sender);
        void __fastcall MSouthClick(TObject *Sender);
        void __fastcall MSouthWestClick(TObject *Sender);
        void __fastcall MWestClick(TObject *Sender);
        void __fastcall MNOrthWestClick(TObject *Sender);
        void __fastcall B3x3Click(TObject *Sender);
        void __fastcall B5X5Click(TObject *Sender);
        void __fastcall MOpenClick(TObject *Sender);
        void __fastcall MNewKernelClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall PreviewCheckBoxClick(TObject *Sender);
        void __fastcall ViewBitBtnClick(TObject *Sender);
        void __fastcall MLAP1Click(TObject *Sender);
        void __fastcall MLAP2Click(TObject *Sender);
        void __fastcall MLAP3Click(TObject *Sender);
        void __fastcall MLAP4Click(TObject *Sender);
        void __fastcall MSaveClick(TObject *Sender);
        void __fastcall MLineVerticalClick(TObject *Sender);
        void __fastcall MLineHorizontalClick(TObject *Sender);
        void __fastcall MLine_45Click(TObject *Sender);
        void __fastcall MLine_135Click(TObject *Sender);
        void __fastcall DerivativeNorth11Click(TObject *Sender);
        void __fastcall DerivativeNorth21Click(TObject *Sender);
        void __fastcall DerivativeNorthEast11Click(TObject *Sender);
        void __fastcall DerivativeEast11Click(TObject *Sender);
        void __fastcall DerivativeEast21Click(TObject *Sender);
        void __fastcall DerivatedSouthEast11Click(TObject *Sender);
        void __fastcall DerivativeSouthEast21Click(TObject *Sender);
        void __fastcall DerivativeSouth11Click(TObject *Sender);
        void __fastcall DerivativeSouth21Click(TObject *Sender);
        void __fastcall DerivativeSouthWest11Click(TObject *Sender);
        void __fastcall DerivativeSouthWest21Click(TObject *Sender);
        void __fastcall DerivativeWest11Click(TObject *Sender);
        void __fastcall DerivativeWest21Click(TObject *Sender);
        void __fastcall DerivativeNorthWest11Click(TObject *Sender);
        void __fastcall DerivativeNorthWest21Click(TObject *Sender);
        void __fastcall Laplacian11Click(TObject *Sender);
        void __fastcall Laplacian21Click(TObject *Sender);
        void __fastcall Laplacian31Click(TObject *Sender);
        void __fastcall Laplacian41Click(TObject *Sender);
        void __fastcall Enhancementsmall1Click(TObject *Sender);
        void __fastcall Enhancementnormal1Click(TObject *Sender);
        void __fastcall Enhancementstrong1Click(TObject *Sender);
        void __fastcall Enhancementmaximum1Click(TObject *Sender);
        void __fastcall Enhancementtype11Click(TObject *Sender);
        void __fastcall EnhancementType21Click(TObject *Sender);
        void __fastcall EnhancementType31Click(TObject *Sender);
        void __fastcall EnhancementType41Click(TObject *Sender);
        void __fastcall Smoothing11Click(TObject *Sender);
        void __fastcall Smoothing21Click(TObject *Sender);
        void __fastcall Smoothing31Click(TObject *Sender);
        void __fastcall Smoothing41Click(TObject *Sender);
        void __fastcall DerivativeHorizontal11Click(TObject *Sender);
        void __fastcall DerivativeHorizontal21Click(TObject *Sender);
        void __fastcall DerivativeVertical11Click(TObject *Sender);
        void __fastcall DerivativeVertical21Click(TObject *Sender);
        void __fastcall VerticalLineDetect1Click(TObject *Sender);
        void __fastcall HorizontalLineDetect1Click(TObject *Sender);
        void __fastcall N1stDiagonalDetection1Click(TObject *Sender);
        void __fastcall N2ndDiagonalDetection2Click(TObject *Sender);
        void __fastcall N3levelMaxabsmask11Click(TObject *Sender);
        void __fastcall N3levelMaxabsmask21Click(TObject *Sender);
        void __fastcall N3levelMaxabsmask31Click(TObject *Sender);
        void __fastcall N3levelMaxabsmask41Click(TObject *Sender);
        void __fastcall N3levelMaxabsmask15x51Click(TObject *Sender);
        void __fastcall N3levelMaxabsmask25x51Click(TObject *Sender);
        void __fastcall N3levelMaxabsmask35x51Click(TObject *Sender);
        void __fastcall N3levelMaxabsmask45x51Click(TObject *Sender);
        void __fastcall N3levelMaxabsmask17x71Click(TObject *Sender);
        void __fastcall N3levelMaxabsmask27x71Click(TObject *Sender);
        void __fastcall N3levelMaxabsmask37x71Click(TObject *Sender);
        void __fastcall N3levelMaxabsmask47x71Click(TObject *Sender);
        void __fastcall N3levelMaxabsmask19x91Click(TObject *Sender);
        void __fastcall N3levelMaxabsmask29x91Click(TObject *Sender);
        void __fastcall N3levelMaxabsmask39x91Click(TObject *Sender);
        void __fastcall N3levelMaxabsmask49x91Click(TObject *Sender);
        void __fastcall N5levelMaxabsmask13x31Click(TObject *Sender);
        void __fastcall N5levelMaxabsmask23x31Click(TObject *Sender);
        void __fastcall N5levelMaxabsmask33x31Click(TObject *Sender);
        void __fastcall N5levelMaxabsmask43x31Click(TObject *Sender);
        void __fastcall Robertsmeansquaremask11Click(TObject *Sender);
        void __fastcall Robertsmeansquaremask21Click(TObject *Sender);
        void __fastcall SobelMeanSquaremask11Click(TObject *Sender);
        void __fastcall SobelMeanSquaremask21Click(TObject *Sender);
        void __fastcall CompassMaxmask11Click(TObject *Sender);
        void __fastcall CompassMaxmask21Click(TObject *Sender);
        void __fastcall CompassMaxmask31Click(TObject *Sender);
        void __fastcall CompassMaxmask41Click(TObject *Sender);
        void __fastcall CompassMaxmask51Click(TObject *Sender);
        void __fastcall CompassMaxmask61Click(TObject *Sender);
        void __fastcall CompassMaxmask71Click(TObject *Sender);
        void __fastcall CompassMaxmask81Click(TObject *Sender);
        void __fastcall KirschMaxmask11Click(TObject *Sender);
        void __fastcall KirschMaxmask21Click(TObject *Sender);
        void __fastcall KirschMaxmask31Click(TObject *Sender);
        void __fastcall KirschMaxmask41Click(TObject *Sender);
        void __fastcall KirschMaxmask51Click(TObject *Sender);
        void __fastcall KirschMaxmask61Click(TObject *Sender);
        void __fastcall KirschMaxmask71Click(TObject *Sender);
        void __fastcall KirschMaxmask81Click(TObject *Sender);
private:	// User declarations
        unsigned c_absolute;
        double c_scale;
        BMPHandler* convol_handler, *sized_handler;
        GreyImage* sized_image;
        GreyImage* convol_image;
        GreyImage* original_image;
        Convolution* convolution;
        Kernel* kernel;
        bool preview;
        int kernels_number;
public:		// User declarations
        __fastcall TConvolutionForm(TComponent* Owner);
        __fastcall ~TConvolutionForm();
        void __fastcall SetKernel(Kernel& _kernel);
        void __fastcall SetStatusBar(Kernel* kernel);
        Kernel* __fastcall GetKernel() { return kernel; }
};
//---------------------------------------------------------------------------
extern PACKAGE TConvolutionForm *ConvolutionForm;
//---------------------------------------------------------------------------
#endif
