/*
   NewKernelSizeUnit.cpp

   definin soubor okna pro monost zmny velikosti konvolun masky

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "NewKernelSizeUnit.h"
#include "NewKernelUnit.h"
#include "PictureUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TNewKernelSizeForm *NewKernelSizeForm;
//---------------------------------------------------------------------------
__fastcall TNewKernelSizeForm::TNewKernelSizeForm(TComponent* Owner)
        : TForm(Owner)
{
   Top = PictureForm->Top+30;
   Left = PictureForm->Left + PictureForm->Width - 30 - Width;
}
//---------------------------------------------------------------------------
void __fastcall TNewKernelSizeForm::BitBtn1Click(TObject *Sender)
{
   try{
      new_cols = ColsEdit->Text.ToDouble();
      new_rows = RowsEdit->Text.ToDouble();
      if(!((new_cols>=1)&&(new_cols<=25)&&(new_rows>=1)&&(new_rows<=25)))
         throw Exception("Number of rows and columns must be between 1 and 25");
      NewKernelForm->SetNewSizeKernel(new_cols, new_rows);
      Close();
   }catch(EConvertError &E){
      Application->MessageBox(E.Message.c_str(),
         "User's Kernel",MB_ICONQUESTION|MB_OK);
   }catch(Exception &E){
      Application->MessageBox(E.Message.c_str(),
         "User's Kernel",MB_ICONQUESTION|MB_OK);
   }

}
//---------------------------------------------------------------------------
void __fastcall TNewKernelSizeForm::FormClose(TObject *Sender,
      TCloseAction &Action)
{
   Release();        
}
//---------------------------------------------------------------------------


