/*
   NewKernelUnit.h

   hlavikov soubor okna pro definici novch konvolunch masek

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef NewKernelUnitH
#define NewKernelUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "..\Headers\kernel.h"
#include <Menus.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>
//---------------------------------------------------------------------------
const int edit_top = 32;
const int edit_left = 40;
const int diff_top = 23;//32
const int diff_left = 37;//56
const int edit_width = 33;
const int edit_height = 21;
const int buttons_differ = 103;
const int absolute_differ = 43;

enum ModeKernel{view_kernel_mode, new_kernel_mode, modify_kernel_mode};
//---------------------------------------------------------------------------
class TNewKernelForm : public TForm
{
__published:	// IDE-managed Components
        TMainMenu *MainMenu1;
        TMenuItem *MKernel;
        TMenuItem *MSaveAs;
        TMenuItem *MSize;
        TMenuItem *MClear;
        TMenuItem *M3x3;
        TMenuItem *M5x5;
        TPanel *Panel;
        TBitBtn *CancelBitBtn;
        TBitBtn *ClearBitBtn;
        TMenuItem *M4X4;
        TMenuItem *M2X2;
        TLabel *SumLabel;
        TEdit *SumEdit;
        TCheckBox *AbsoluteCheckBox;
        TSaveDialog *SaveDialog;
        TMenuItem *Anoth;
        TBitBtn *Set1BitBtn;
        TMenuItem *Setto11;
        TMenuItem *N1;
        TMenuItem *Exit;
        TBitBtn *ModifyBitBtn;
        TBitBtn *OKButton;
        TBevel *Bevel1;
        void __fastcall ClearBitBtnClick(TObject *Sender);
        void __fastcall CancelBitBtnClick(TObject *Sender);
        void __fastcall M2X2Click(TObject *Sender);
        void __fastcall M3x3Click(TObject *Sender);
        void __fastcall M4X4Click(TObject *Sender);
        void __fastcall M5x5Click(TObject *Sender);
        void __fastcall OKButtonClick(TObject *Sender);
        void __fastcall MExitClick(TObject *Sender);
        void __fastcall MClearClick(TObject *Sender);
        void __fastcall MSaveAsClick(TObject *Sender);
        void __fastcall FormResize(TObject *Sender);
        void __fastcall AnothClick(TObject *Sender);
        void __fastcall Set1BitBtnClick(TObject *Sender);
        void __fastcall Setto11Click(TObject *Sender);
        void __fastcall ExitClick(TObject *Sender);
        void __fastcall ModifyBitBtnClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
private:	// User declarations
        TEdit** edit;
        int rows_num, cols_num;
        int form_width, form_height;
        double sum;
        double* data;
        bool abs;
        Kernel* kernel;
        void SetSize(int _cols, int _rows);
        void DeleteEdit();
        bool GetKernel();
        int new_cols, new_rows;
        ModeKernel mode_kernel;
public:		// User declarations
        __fastcall TNewKernelForm(TComponent* Owner);
        __fastcall ~TNewKernelForm();
        void __fastcall SetNewSizeKernel(int _c, int _r);
        void __fastcall SetModeKernel(ModeKernel);

};
//---------------------------------------------------------------------------
extern PACKAGE TNewKernelForm *NewKernelForm;
//---------------------------------------------------------------------------
#endif
