/*
   FlatFieldUnit.h

   hlavikov soubor okna Flat-Field korekce

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef FlatFieldUnitH
#define FlatFieldUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "..\Headers\frame_image.h"
#include "..\Headers\bmp_handler.h"
#include "..\Headers\image_grey.h"
#include "..\Headers\scale.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
#include <Dialogs.hpp>
//---------------------------------------------------------------------------
class TFlatFieldForm : public TForm
{
__published:	// IDE-managed Components
        TPanel *Panel1;
        TStatusBar *StatusBar;
        TPanel *Panel2;
        TPanel *Panel3;
        TPanel *Panel4;
        TPanel *Panel5;
        TLabel *Label1;
        TLabel *Label2;
        TLabel *Label3;
        TLabel *Label4;
        TBitBtn *BitBtn1;
        TBitBtn *BitBtn2;
        TButton *Button1;
        TButton *Button3;
        TButton *Button4;
        TImage *Image1;
        TImage *Image2;
        TImage *Image3;
        TImage *Image4;
        TOpenDialog *OpenDialog;
        TPanel *Panel6;
        TLabel *Label6;
        TEdit *PositionEdit;
        TTrackBar *TrackBar;
        void __fastcall Button1Click(TObject *Sender);
        void __fastcall Button3Click(TObject *Sender);
        void __fastcall Button4Click(TObject *Sender);
        void __fastcall BitBtn1Click(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall TrackBarChange(TObject *Sender);
private:	// User declarations
        // handlers
        BMPHandler* frame_original_handler;
        BMPHandler* frame_background_handler;
        BMPHandler* frame_dark_handler;
        BMPHandler* frame_corrected_handler;

        // full images
        GreyImage* original_image;
        GreyImage* background_image;
        GreyImage* dark_image;
        GreyImage* corrected_image;

        // sized images
        GreyImage* sized_original_image;
        GreyImage* sized_background_image;
        GreyImage* sized_dark_image;
        GreyImage* sized_corrected_image;

        // use for flat-fielt transformation
        GreyImage* image1;
        GreyImage* image2;
        GreyImage* image3;
        GreyImage* image4;

        // IO-original, IB-background, ID-dark, IC-corrected, M-brightness level
        float IO, IB, ID, IC, BL;

         // others
        AnsiString original_file_name, background_file_name, dark_file_name;
        short scale;
public:		// User declarations
        __fastcall TFlatFieldForm(TComponent* Owner);
        __fastcall ~TFlatFieldForm();
        void __fastcall FlatFieldSubtract(GreyImage& _image1, GreyImage& _image2,
                                          GreyImage& _image3, GreyImage& _image4);
        void __fastcall FlatFieldCompute();
};
//---------------------------------------------------------------------------
extern PACKAGE TFlatFieldForm *FlatFieldForm;
//---------------------------------------------------------------------------
#endif
