/*
   NonUniformIlluminationUnit.h

   hlavikov soubor okna pro korekci nehomogennho pozad

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef NonUniformIlluminationUnitH
#define NonUniformIlluminationUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include "..\Headers\bmp_handler.h"
#include "..\Headers\image_grey.h"
#include "..\Headers\scale.h"
//---------------------------------------------------------------------------
class TNonUniformIlluminationForm : public TForm
{
__published:	// IDE-managed Components
        TPanel *Panel1;
        TLabel *Label1;
        TLabel *Label2;
        TLabel *Label3;
        TPanel *Panel2;
        TImage *Image1;
        TPanel *Panel4;
        TImage *Image3;
        TBitBtn *BitBtn1;
        TBitBtn *BitBtn2;
        TPanel *Panel3;
        TImage *Image2;
        TPanel *Panel6;
        TLabel *Label6;
        TEdit *PositionEdit;
        TTrackBar *TrackBar;
        TStatusBar *StatusBar1;
        TPanel *Panel5;
        TProgressBar *ProgressBar1;
        TButton *Button1;
        void __fastcall BitBtn1Click(TObject *Sender);
        void __fastcall BitBtn2Click(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall ComputeBackground
                (GreyImage& _image1, GreyImage& _image2, GreyImage& _image3, int size);
        void __fastcall Button1Click(TObject *Sender);
        void __fastcall TrackBarChange(TObject *Sender);
private:	// User declarations
        BMPHandler* handler;
        GreyImage* original_image;
        GreyImage* sized_image;
        GreyImage* background_image;
        GreyImage* corrected_image;

        // use for transformation
        GreyImage* image1;
        GreyImage* image2;
        GreyImage* image3;

        // for computing background
        int size_mask;
public:		// User declarations
        __fastcall TNonUniformIlluminationForm(TComponent* Owner);
        __fastcall ~TNonUniformIlluminationForm();
};
//---------------------------------------------------------------------------
extern PACKAGE TNonUniformIlluminationForm *NonUniformIlluminationForm;
//---------------------------------------------------------------------------
#endif
