/*
   DrawUnit.h

   hlavikov soubor okna pro dodn syntetickch objekt do obrazu

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef DrawUnitH
#define DrawUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
#include <Menus.hpp>
#include <Dialogs.hpp>
#include "..\Headers\list_image.h"
#include "..\Headers\image_grey.h"
#include <ComCtrls.hpp>
//---------------------------------------------------------------------------

enum TDrawingTool {dtLine, dtRectangle, dtEllipse, dtRoundRect, dtWeb};

//---------------------------------------------------------------------------
class TDrawForm : public TForm
{
__published:	// IDE-managed Components
        TPanel *Panel1;
        TSpeedButton *LineSpeedButton;
        TSpeedButton *EllipseSpeedButton;
        TSpeedButton *RectSpeedButton;
        TSpeedButton *RoundRectSpeedButton;
        TSpeedButton *WebSpeedButton;
        TPopupMenu *SizePopupMenu;
        TMenuItem *Size1;
        TMenuItem *Size2;
        TMenuItem *Size3;
        TMenuItem *Size4;
        TMenuItem *Size5;
        TMainMenu *MainMenu;
        TMenuItem *MEdit;
        TMenuItem *New;
        TPanel *Panel2;
        TSpeedButton *SolidSpeedButton;
        TSpeedButton *ClearSpeedButton;
        TSpeedButton *HorizontalSpeedButton;
        TSpeedButton *DiagCrossSpeedButton;
        TSpeedButton *BDiagonalSpeedButton;
        TSpeedButton *CrossSpeedButton;
        TSpeedButton *VerticalSpeedButton;
        TSpeedButton *FDiagonalSpeedButton;
        TSpeedButton *ColorBrushSpeedButton;
        TColorDialog *ColorDialog1;
        TSpeedButton *ColorPenSpeedButton;
        TMenuItem *MUndo;
        TMenuItem *MCancel;
        TMenuItem *MReset;
        TPopupMenu *WebPopupMenu;
        TMenuItem *web10;
        TMenuItem *web20;
        TMenuItem *web30;
        TMenuItem *web40;
        TStatusBar *StatusBar1;
        TLabel *Label1;
        TLabel *Label2;
        TLabel *Label3;
        TLabel *Label4;
        TLabel *Label5;
        TLabel *Label6;
        TLabel *Label8;
        TLabel *Label9;
        TLabel *Label10;
        TLabel *Label7;
        TLabel *Label11;
        TLabel *Label12;
        TLabel *Label13;
        TLabel *Label14;
        TLabel *Label15;
        TPanel *Panel3;
        TPanel *Panel4;
        TMenuItem *OK1;
        TMenuItem *N1;
        TLabel *Label16;
        TLabel *Label17;
        void __fastcall NewClick(TObject *Sender);
        void __fastcall LineSpeedButtonClick(TObject *Sender);
        void __fastcall EllipseSpeedButtonClick(TObject *Sender);
        void __fastcall RoundRectSpeedButtonClick(TObject *Sender);
        void __fastcall RectSpeedButtonClick(TObject *Sender);
        void __fastcall SetBrushStyle(TObject *Sender);
        void __fastcall ColorBrushSpeedButtonClick(TObject *Sender);
        void __fastcall Size1Click(TObject *Sender);
        void __fastcall Size2Click(TObject *Sender);
        void __fastcall Size3Click(TObject *Sender);
        void __fastcall Size4Click(TObject *Sender);
        void __fastcall Size5Click(TObject *Sender);
        void __fastcall ColorPenSpeedButtonClick(TObject *Sender);
        void __fastcall MUndoClick(TObject *Sender);
        void __fastcall MCancelClick(TObject *Sender);
        void __fastcall MResetClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall WebSpeedButtonClick(TObject *Sender);
        void __fastcall PixelsPerLineClick(TObject *Sender);
        void __fastcall FormShow(TObject *Sender);
        void __fastcall OK1Click(TObject *Sender);
private:	// User declarations
        bool drawing, drawing_allowed, cancel_press;
        TColor brush_color, pen_color;
        TBrushStyle brush_style;
        int pixels_per_line;
        TPoint origin, move_pt;
        TDrawingTool drawing_tool;
        GreyImage* image,*orig_image;
        ListI<GreyImage>* list;
public:		// User declarations
        __fastcall TDrawForm(TComponent* Owner);
        __fastcall ~TDrawForm();
        TImage* Image;
        TPoint& __fastcall Origin() { return origin;}
        TPoint& __fastcall MovePt() { return move_pt;}
        bool&   __fastcall Drawing() { return drawing;}

        void __fastcall AssignImage();
        void __fastcall DrawShape(TPoint TopLeft, TPoint BottomRight, TPenMode AMode);
        void __fastcall OnMouseDown(TMouseButton Button, int X, int Y);
        void __fastcall OnMouseMove(int X, int Y);
        void __fastcall OnMouseUp(TMouseButton Button, int X, int Y);
};
//---------------------------------------------------------------------------
extern PACKAGE TDrawForm *DrawForm;
//---------------------------------------------------------------------------
#endif
