/*
   AverageUnit.h

   hlavikov soubor okna pro prmrovn z vce obraz

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef AverageUnitH
#define AverageUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "Headers\bmp.h"
#include "Headers\bmp_handler.h"
#include "Headers\image_grey.h"
#include "Headers\list_image.h"
#include "Headers\frame_image.h"
#include "Headers\in_out.h"
#include "Headers\geometric_image.h"
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
//---------------------------------------------------------------------------
class TAverageForm : public TForm
{
__published:	// IDE-managed Components
        TOpenDialog *OpenDialog1;
        TPanel *Panel1;
        TButton *Button1;
        TPanel *Panel2;
        TStatusBar *StatusBar1;
        TBitBtn *BitBtn1;
        TButton *Button2;
        TBitBtn *BitBtn2;
        TGroupBox *GroupBox1;
        TComboBox *ComboBox1;
        TLabel *Label2;
        TImage *Image1;
        TPanel *Panel3;
        TLabel *Label1;
        TEdit *Edit1;
        TEdit *Edit2;
        TLabel *Label3;
        void __fastcall Button1Click(TObject *Sender);
        void __fastcall AddToAverageList(AnsiString file_path);
        void __fastcall Button2Click(TObject *Sender);
        void __fastcall BitBtn2Click(TObject *Sender);
        void __fastcall ComboBox1Change(TObject *Sender);
        void __fastcall ArithmeticAverage();
        void __fastcall BitBtn1Click(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
private:	// User declarations
       BMPHandler* a_handler;
       ListI<GreyImage>* average_list;
       ListI<GreyImage>* a_list;
       TStringList* average_path;
       int number_images, data, x_size, y_size;
       GreyImage* image;
       GreyImage* a_image;
       GreyImage* b_image;
       GreyImage* d_image;
       GreyImage* sized_image;
       VInOut* file;
       FrameImage* frame;

public:		// User declarations
        __fastcall TAverageForm(TComponent* Owner);
        __fastcall ~TAverageForm();
        bool __fastcall Check_Validity(AnsiString file_path);
};
//---------------------------------------------------------------------------
extern PACKAGE TAverageForm *AverageForm;
//---------------------------------------------------------------------------
#endif
