/*
   CutUnit.cpp

   definin soubor okna pro vez obrazu

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "CutUnit.h"
#include "PictureUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TCutForm *CutForm;
//---------------------------------------------------------------------------
__fastcall TCutForm::TCutForm(TComponent* Owner)
        : TForm(Owner)
{
   Top = PictureForm->Top+30;
   Left = PictureForm->Left + PictureForm->Width - 30 - Width;
   PictureForm->GetBMPHandler()->Set(orig);
}
//---------------------------------------------------------------------------
__fastcall TCutForm::~TCutForm()
{
}
//---------------------------------------------------------------------------
void __fastcall TCutForm::CutBitBtnClick(TObject *Sender)
{
   try{
      LT_Col = LT_Col_Edit->Text.ToInt();
      LT_Row = LT_Row_Edit->Text.ToInt();
      RD_Col = RD_Col_Edit->Text.ToInt();
      RD_Row = RD_Row_Edit->Text.ToInt();
      if(!((LT_Col>=0)&&(LT_Col<orig.Cols())&&(LT_Row>=0)&&(LT_Row<orig.Rows())&&
           (RD_Col>=0)&&(RD_Col<orig.Cols())&&(RD_Row>=0)&&(RD_Row<orig.Rows())))
         throw Exception(AnsiString("Columns must be between 0 and ")+AnsiString(orig.Cols()-1)+AnsiString(",\n")+
                         AnsiString("Rows must be between 0 and ")+AnsiString(orig.Rows()-1));
      if((LT_Col>RD_Col)||(LT_Row>RD_Row))
         throw Exception("Incorrectly entered coordinates of the corner points.");
      width = abs(RD_Col-LT_Col);
      height = abs(RD_Row-LT_Row);
      orig.ReadImageAreaToImage(cutted, LT_Col, LT_Row, width, height);
      //PictureForm->AssignImage(&cutted);
      PictureForm->AssignList(&cutted);
      Close();
   }catch(EConvertError &E){
      Application->MessageBox(E.Message.c_str(),
         "Cut Tool Window",MB_ICONQUESTION|MB_OK);
   }catch(Exception &E){
      Application->MessageBox(E.Message.c_str(),
         "Cut Tool Window",MB_ICONQUESTION|MB_OK);
   }
}
//---------------------------------------------------------------------------
void __fastcall TCutForm::FormClose(TObject *Sender, TCloseAction &Action)
{
   Release();        
}
//---------------------------------------------------------------------------




