/*
   MagnifyingGlassUnit.h

   hlavikov soubor okna pro pouit lupy v obraze

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------

#ifndef MagnifyingGlassUnitH
#define MagnifyingGlassUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include "Headers\bmp_handler.h"
#include "Headers\image_grey.h"
#include <Forms.hpp>
#include "Headers\scale.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
#include <Graphics.hpp>
//---------------------------------------------------------------------------
class TMagnifyingGlassForm : public TForm
{
__published:	// IDE-managed Components
        TStatusBar *StatusBar1;
        TPanel *Panel1;
        TPanel *Panel3;
        TImage *Image2;
        TBitBtn *BitBtn1;
        TPanel *Panel4;
        TLabel *Label1;
        TTimer *Timer1;
        TPanel *Panel2;
        TImage *Image1;
        TPanel *Panel5;
        TLabel *Label2;
        TTrackBar *TrackBar1;
        TTrackBar *TrackBar2;
        TEdit *Edit1;
        TEdit *Edit2;
        TCheckBox *CheckBox1;
        void __fastcall BitBtn1Click(TObject *Sender);
        void __fastcall Image1MouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall Image1MouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
        void __fastcall Timer1Timer(TObject *Sender);
        void __fastcall Image1MouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
        void __fastcall TrackBar2Change(TObject *Sender);
        void __fastcall TrackBar1Change(TObject *Sender);
        void __fastcall CheckBox1Click(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
private:	// User declarations
        BMPHandler* magnifying_handler;
        GreyImage* original_image;
        GreyImage* sized_image_light;
        GreyImage* sized_image_dark;
        GreyImage* sized_image_lightdark;

        GreyImage* detail_image;
        GreyImage* sized_detail_image;

        short scale, scale2;
        int x_ordinate, y_ordinate, size_glass, // sized
            x_ordinate_original, y_ordinate_original, // non-sized
            size_glass_original, max_size, min_size, // glass parameters
            lightness; // dark opposite light koecifient
        float resize_koecifient; // resize:size
        bool interp; // interpolation on/off
        bool can_move; // move mouse with rectangle

public:		// User declarations
        __fastcall TMagnifyingGlassForm(TComponent* Owner);
        __fastcall ~TMagnifyingGlassForm();
        void __fastcall ViewDetail(int x, int y);
        void __fastcall MakeDark(GreyImage* im_in, GreyImage* im_out);
        void __fastcall CombineDetailAndDark(GreyImage* im_light, GreyImage* im_dark,
                        GreyImage* im_lightdark, int x, int y, int size);
        void __fastcall ReCount();
};
//---------------------------------------------------------------------------
extern PACKAGE TMagnifyingGlassForm *MagnifyingGlassForm;
//---------------------------------------------------------------------------
#endif
