/*
   ShowSixImagesUnit.h

   hlavikov soubor okna pro souasn zobrazen esti obrzk

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef ShowSixImagesUnitH
#define ShowSixImagesUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "..\Headers\in_out.h"
#include "..\Headers\frame_image.h"
#include "..\Headers\bmp_handler.h"
#include "..\Headers\bmp_handler_color.h"
#include "..\Headers\image_grey.h"
#include "..\Headers\image_color.h"
#include "..\Headers\scale.h"
#include "..\Headers\scale_color.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
#include <Dialogs.hpp>
//---------------------------------------------------------------------------
class TShowSixImagesForm : public TForm
{
__published:	// IDE-managed Components
        TStatusBar *StatusBar1;
        TPanel *Panel1;
        TPanel *Panel2;
        TImage *Image1;
        TPanel *Panel3;
        TImage *Image2;
        TPanel *Panel4;
        TImage *Image3;
        TPanel *Panel5;
        TImage *Image4;
        TButton *Button1;
        TButton *Button2;
        TButton *Button3;
        TPanel *Panel6;
        TImage *Image5;
        TPanel *Panel7;
        TImage *Image6;
        TButton *Button4;
        TButton *Button5;
        TButton *Button6;
        TBitBtn *BitBtn1;
        TOpenDialog *OpenDialog;
        void __fastcall Button1Click(TObject *Sender);
        void __fastcall Button2Click(TObject *Sender);
        void __fastcall Button3Click(TObject *Sender);
        void __fastcall Button4Click(TObject *Sender);
        void __fastcall Button5Click(TObject *Sender);
        void __fastcall Button6Click(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall BitBtn1Click(TObject *Sender);
private:	// User declarations
        BMPHandler* handler;
        BMPHandlerColor* color_handler;
        GreyImage* image;
        GreyImage* scaled_image;
        ColorImage* color_image;
        ColorImage* scaled_color_image;
        // other variables
        AnsiString image_file_name;
        VInOut* file;
        short scale1, scale2;
public:		// User declarations
        __fastcall TShowSixImagesForm(TComponent* Owner);
        __fastcall ~TShowSixImagesForm();
        void __fastcall Load_grey_image(TImage* _image);
        void __fastcall Load_color_image(TImage* _image);
};
//---------------------------------------------------------------------------
extern PACKAGE TShowSixImagesForm *ShowSixImagesForm;
//---------------------------------------------------------------------------
#endif
