/*
   ShowTwoImagesUnit.cpp

   definin soubor okna pro souasn zobrazen dvou obrzk

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "ShowTwoImagesUnit.h"
#include "PictureUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TShowTwoImagesForm *ShowTwoImagesForm;
//---------------------------------------------------------------------------
__fastcall TShowTwoImagesForm::TShowTwoImagesForm(TComponent* Owner)
        : TForm(Owner)
{
  Top = PictureForm->Top+30;
  Left = PictureForm->Left + PictureForm->Width - 50 - Width;

  image = new GreyImage();
  scaled_image = new GreyImage();
  color_image = new ColorImage();
  scaled_color_image = new ColorImage();

  handler = NULL;
  color_handler = NULL;

  StatusBar1->SimpleText =  "Click to load button and select some image.";
}
//---------------------------------------------------------------------------
__fastcall TShowTwoImagesForm::~TShowTwoImagesForm()
{
  delete (handler);
  delete (color_handler);
  delete (image);
  delete (scaled_image);
  delete (color_image);
  delete (scaled_color_image);
}
//---------------------------------------------------------------------------
void __fastcall TShowTwoImagesForm::BitBtn1Click(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
// load Image1
void __fastcall TShowTwoImagesForm::Button1Click(TObject *Sender)
{
  try{
    if (handler!=NULL) {delete (handler); handler = NULL;}
    if (color_handler!=NULL) {delete (color_handler); color_handler=NULL;}
    if (OpenDialog->Execute()){
       switch(OpenDialog->FilterIndex){
            // Bitmap BMP file - 256 colors
            case(1):
               Load_grey_image(Image1);
               break;
            // Bitmap BMP file - 16.7 million colors
            case(2):
               Load_color_image(Image1);
               break;
       }
    }
  }catch(VEMsg &E){
      Application->MessageBox(E.msg.c_str(),
      "Exception Catched",MB_ICONHAND|MB_OK);
   }catch(VECorruptedFile &E){
      Application->MessageBox(E.msg.c_str(),
      "Exception Catched",MB_ICONHAND|MB_OK);
       file = NULL;
         switch (OpenDialog->FilterIndex){
            case(1):
               delete(handler);
               handler = NULL;
               break;
            case(2):
               delete(color_handler);
               color_handler = NULL;
               break;
         }
   }
}
//---------------------------------------------------------------------------
// load Image1
void __fastcall TShowTwoImagesForm::Button2Click(TObject *Sender)
{
  try{
    if (handler!=NULL) {delete (handler); handler = NULL;}
    if (color_handler!=NULL) {delete (color_handler); color_handler=NULL;}
    if (OpenDialog->Execute()){
       switch(OpenDialog->FilterIndex){
            // Bitmap BMP file - 256 colors
            case(1):
               Load_grey_image(Image2);
               break;
            // Bitmap BMP file - 16.7 million colors
            case(2):
               Load_color_image(Image2);
               break;
       }
    }
  }catch(VEMsg &E){
      Application->MessageBox(E.msg.c_str(),
      "Exception Catched",MB_ICONHAND|MB_OK);
   }catch(VECorruptedFile &E){
      Application->MessageBox(E.msg.c_str(),
      "Exception Catched",MB_ICONHAND|MB_OK);
       file = NULL;
         switch (OpenDialog->FilterIndex){
            case(1):
               delete(handler);
               handler = NULL;
               break;
            case(2):
               delete(color_handler);
               color_handler = NULL;
               break;
         }
   }
}
//---------------------------------------------------------------------------
void __fastcall TShowTwoImagesForm::Load_grey_image(TImage* _image)
{
   handler = new BMPHandler();
   delete file;
   file = new VBitmap(OpenDialog->FileName);
   file->ConvertToBMP(handler);
   handler->Set(*image);
   //delete scaled_image;
   //scaled_image = new GreyImage();
   Scale scale1(*image, *scaled_image, _image->Width);
   handler->CreateBitmapAndAssign(scaled_image);
   handler->Show(_image);
   _image->Hint = file->ImageName();
   _image->ShowHint = true;
}
//---------------------------------------------------------------------------
void __fastcall TShowTwoImagesForm::Load_color_image(TImage* _image)
{
   color_handler = new BMPHandlerColor();
   delete file;
   file = new VBitmap(OpenDialog->FileName, true);
   file->ConvertToColorBMP(color_handler);
   color_handler->Set(*color_image);
   delete scaled_color_image;
   scaled_color_image = new ColorImage();
   Scale_color scale2(*color_image, *scaled_color_image, _image->Width);
   color_handler->CreateBitmapAndAssign(scaled_color_image);
   color_handler->Show(_image);
   _image->Hint = file->ImageName();
   _image->ShowHint = true;
}
//---------------------------------------------------------------------------

void __fastcall TShowTwoImagesForm::FormClose(TObject *Sender,
      TCloseAction &Action)
{
   Release();
}
//---------------------------------------------------------------------------



