/*
   TranslateUnit.cpp

   definin soubor okna pro operaci posunut

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "TranslateUnit.h"
#include "PictureUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TTranslateForm *TranslateForm;
//---------------------------------------------------------------------------
__fastcall TTranslateForm::TTranslateForm(TComponent* Owner)
        : TForm(Owner)
{
   Top = PictureForm->Top+30;
   Left = PictureForm->Left + PictureForm->Width - 30 - Width;
   PictureForm->GetBMPHandler()->Set(orig);
}
//---------------------------------------------------------------------------
void __fastcall TTranslateForm::TranslateBitBtnClick(TObject *Sender)
{
try{
      LT_Col = LT_Col_Edit->Text.ToInt();
      LT_Row = LT_Row_Edit->Text.ToInt();
      RD_Col = RD_Col_Edit->Text.ToInt();
      RD_Row = RD_Row_Edit->Text.ToInt();
      if(!((LT_Col>=0)&&(LT_Col<orig.Cols())&&(LT_Row>=0)&&(LT_Row<orig.Rows())&&
           (RD_Col>=0)&&(RD_Col<orig.Cols())&&(RD_Row>=0)&&(RD_Row<orig.Rows())))
         throw Exception(AnsiString("Columns must be between 0 and ")+AnsiString(orig.Cols()-1)+AnsiString(",\n")+
                         AnsiString("Rows must be between 0 and ")+AnsiString(orig.Rows()-1));
      if((LT_Col>RD_Col)||(LT_Row>RD_Row))
         throw Exception("Incorrectly entered coordinates of the corner points.");
      width = abs(RD_Col-LT_Col);
      height = abs(RD_Row-LT_Row);
      Trans_Col = Trans_Col_Edit->Text.ToInt() - LT_Col;
      Trans_Row = Trans_Row_Edit->Text.ToInt() - LT_Row;
      if((LT_Col+Trans_Col>orig.Cols()-1)||(LT_Row+Trans_Row>orig.Rows()-1)||
         (LT_Col+Trans_Col<0)||(LT_Row+Trans_Row<0)||(LT_Col+Trans_Col+width>orig.Cols()-1)||(LT_Row+Trans_Row+height>orig.Rows()-1))
              throw Exception("Partition goes out of border of the original image.");
      orig.ReadImageAreaToImage(buff, LT_Col, LT_Row, width, height);
      orig.WriteImageAreaFromImage(buff, LT_Col+Trans_Col, LT_Row+Trans_Row, width, height);
      PictureForm->AssignList(&orig);
      Close();
   }catch(EConvertError &E){
      Application->MessageBox(E.Message.c_str(),
         "Translate Tool Window",MB_ICONQUESTION|MB_OK);
   }catch(Exception &E){
      Application->MessageBox(E.Message.c_str(),
         "Translate Tool Window",MB_ICONQUESTION|MB_OK);
   }
}
//---------------------------------------------------------------------------
