/*
   DFTVCircSymFilterUnit.h

   hlavikov soubor okna filtru Cilcurary Symmetric Filter

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef DFTCircSymFilterUnitH
#define DFTCircSymFilterUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
#include "..\Headers\image_complex.h"
//---------------------------------------------------------------------------
class TDFTCircSymFilterForm : public TForm
{
__published:	// IDE-managed Components
        TBevel *Bevel1;
        TPanel *Panel1;
        TBitBtn *BitBtn1;
        TBitBtn *BitBtn2;
        TBitBtn *PerformBitBtn;
        TEdit *CutOffEdit;
        TEdit *OrderEdit;
        TLabel *Label1;
        TLabel *Label2;
        TCheckBox *CheckBox;
        void __fastcall PerformBitBtnClick(TObject *Sender);
        void __fastcall CheckBoxClick(TObject *Sender);
        void __fastcall BitBtn2Click(TObject *Sender);
        void __fastcall BitBtn1Click(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
private:	// User declarations
        ComplexImage* orig_image, *filtered_image;
        GreyImage* orig_grey_image;
        CircularKind  circular_kind;
public:		// User declarations
        __fastcall TDFTCircSymFilterForm(TComponent* Owner);
        __fastcall ~TDFTCircSymFilterForm();
};
//---------------------------------------------------------------------------
extern PACKAGE TDFTCircSymFilterForm *DFTCircSymFilterForm;
//---------------------------------------------------------------------------
#endif
