/*
   DFTFreqConvolutionUnit.h

   hlavikov soubor okna, umoujcho provdt konvoluci a dekonvoluci
   natenho obrazu a s natenou maskou.

   tato funkce nen implementovna v tto verzi programu

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef DFTFreqConvolutionUnitH
#define DFTFreqConvolutionUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include "..\Headers\kernel.h"
#include <Menus.hpp>
#include <Dialogs.hpp>
#include "..\Headers\image_complex.h"
#include <Buttons.hpp>
//---------------------------------------------------------------------------
class TDFTFreqConvolutionForm : public TForm
{
__published:	// IDE-managed Components
        TBevel *Bevel1;
        TPanel *Panel1;
        TMainMenu *MainMenu1;
        TMenuItem *MKernel;
        TMenuItem *MLoadKernel;
        TOpenDialog *OpenDialog;
        TBitBtn *PerformConvolutionBitBtn;
        TBitBtn *BitBtn1;
        TBitBtn *CancelBitBtn;
        TBitBtn *PerformDeconvolutionBitBtn;
        TEdit *BoundEdit;
        TMenuItem *MEdit;
        TMenuItem *MReset;
        TLabel *Label1;
        TLabel *Label2;
        void __fastcall MLoadKernelClick(TObject *Sender);
        void __fastcall PerformConvolutionBitBtnClick(TObject *Sender);
        void __fastcall PerformDeconvolutionBitBtnClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall CancelBitBtnClick(TObject *Sender);
        void __fastcall MResetClick(TObject *Sender);
        void __fastcall BitBtn1Click(TObject *Sender);
private:	// User declarations
        Kernel* kernel;
        ComplexImage* orig_image, *kernel_image, *conv_image, *image;
        GreyImage* orig_grey_image;
public:		// User declarations
        __fastcall TDFTFreqConvolutionForm(TComponent* Owner);
        __fastcall ~TDFTFreqConvolutionForm();
};
//---------------------------------------------------------------------------
extern PACKAGE TDFTFreqConvolutionForm *DFTFreqConvolutionForm;
//---------------------------------------------------------------------------
#endif
