/*
   DFTFrequencyMaskUnit.h

   hlavikov soubor okna filtru Frequency Mask, umoujcho vybrat
   jakoukoli obdlnkovou st spektra a tu vyfiltrovat

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef DFTFrequencyMaskUnitH
#define DFTFrequencyMaskUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
#include "..\Headers\image_complex.h"
#include <Menus.hpp>
//---------------------------------------------------------------------------
class TDFTFrequencyMaskForm : public TForm
{
__published:	// IDE-managed Components
        TBevel *Bevel1;
        TPanel *Panel1;
        TBitBtn *PerformBitBtn;
        TBitBtn *OKBitBtn;
        TBitBtn *CancelBitBtn;
        TRadioGroup *RectRadioGroup;
        TEdit *MtpEdit;
        TMainMenu *MainMenu1;
        TMenuItem *MEdit;
        TMenuItem *MReset;
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall PerformBitBtnClick(TObject *Sender);
        void __fastcall CancelBitBtnClick(TObject *Sender);
        void __fastcall RectRadioGroupClick(TObject *Sender);
        void __fastcall MResetClick(TObject *Sender);
        void __fastcall OKBitBtnClick(TObject *Sender);
private:	// User declarations
        ComplexImage* orig_image, *filtered_image;
        GreyImage* orig_grey_image;
public:		// User declarations
        __fastcall TDFTFrequencyMaskForm(TComponent* Owner);
        __fastcall ~TDFTFrequencyMaskForm();
};
//---------------------------------------------------------------------------
extern PACKAGE TDFTFrequencyMaskForm *DFTFrequencyMaskForm;
//---------------------------------------------------------------------------
#endif
