/*
   DFTOptionsUnit.cpp

   definin soubor okna nastavujc parametry filtru

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "DFTOptionsUnit.h"
#include "DFTUnit.h"
#include "PictureUnit.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TDFTOptionsForm *DFTOptionsForm;
//---------------------------------------------------------------------------
__fastcall TDFTOptionsForm::TDFTOptionsForm(TComponent* Owner)
        : TForm(Owner)
{
   Top = PictureForm->Top+30;
   Left = PictureForm->Left + PictureForm->Width - 30 - Width;
   
   options = DFTForm->GetDFTOptions();
   SetVisualComp(options);
}
//---------------------------------------------------------------------------
void
__fastcall TDFTOptionsForm::SetVisualComp(DFTOptions& options)
{
   ViewValuesCheckBox->Checked = options.ViewValues;
   if(ViewValuesCheckBox->Checked == false){
      ViewAsRadioGroup->Enabled = false;
   }else{
      ViewAsRadioGroup->Enabled = true;
   }
   switch(options.ViewAs){
      case(0):
          ViewAsRadioGroup->ItemIndex = 0;
          break;
      case(1):
          ViewAsRadioGroup->ItemIndex = 1;
          break;
      case(2):
          ViewAsRadioGroup->ItemIndex = 2;
          break;
      case(3):
          ViewAsRadioGroup->ItemIndex = 3;
          break;
   }
   ScaleEdit->Text = options.Scale;
   switch(options.Inverse_kind){
      case(0):
          InverseRadioGroup->ItemIndex = 0;
          break;
      case(1):
          InverseRadioGroup->ItemIndex = 1;
          break;
      case(2):
          InverseRadioGroup->ItemIndex = 2;
          break;
   }
}
//---------------------------------------------------------------------------
void __fastcall TDFTOptionsForm::ViewAsRadioGroupClick(TObject *Sender)
{
   switch(ViewAsRadioGroup->ItemIndex){
      case(0):
         options.ViewAs = magnitude;
         break;
      case(1):
         options.ViewAs = realpart;
         break;
      case(2):
         options.ViewAs = imaginary;
         break;
      case(3):
         options.ViewAs = phase;
         break;
   }
}
//---------------------------------------------------------------------------

void __fastcall TDFTOptionsForm::ViewValuesCheckBoxClick(TObject *Sender)
{
   options.ViewValues = ViewValuesCheckBox->Checked;
   SetVisualComp(options);
}
//---------------------------------------------------------------------------

void __fastcall TDFTOptionsForm::OKBitBtnClick(TObject *Sender)
{
   DFTForm->GetDFTOptions() = options;
   DFTForm->SetDFTOptions(DFTForm->GetDFTOptions());
}
//---------------------------------------------------------------------------

void __fastcall TDFTOptionsForm::ScaleEditExit(TObject *Sender)
{
   try{
      options.Scale = ScaleEdit->Text.ToInt();
   }catch(EConvertError& E){
      Application->MessageBox(E.Message.c_str(), "Save Tool Window Error" ,
            MB_ICONWARNING | MB_OKCANCEL);
   }

}
//---------------------------------------------------------------------------

void __fastcall TDFTOptionsForm::InverseRadioGroupClick(TObject *Sender)
{
   switch(InverseRadioGroup->ItemIndex){
      case(0):
          options.Inverse_kind = normal;
          break;
      case(1):
          options.Inverse_kind = const_phase;
          break;
      case(2):
          options.Inverse_kind = const_amplitude;
          break;
   }
}
//---------------------------------------------------------------------------

