/*
   DFTRingFrequencyMaskUnit.h

   hlavikov soubor okna filtru Frequency Mask, umoujcho vybrat
   jakoukoli kruhovou st spektra a tu vyfiltrovat

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef DFTRingFrequencyMaskUnitH
#define DFTRingFrequencyMaskUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "..\Headers\image_complex.h"
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
class TDFTRingFrequencyMaskForm : public TForm
{
__published:	// IDE-managed Components
        TBevel *Bevel1;
        TPanel *Panel1;
        TRadioGroup *RingRadioGroup;
        TCheckBox *KindCheckBox;
        TEdit *Freq1Edit;
        TBitBtn *PerformBitBtn;
        TBitBtn *BitBtn1;
        TBitBtn *Cancel;
        TEdit *Freq2Edit;
        TLabel *Label1;
        TLabel *Label2;
        TEdit *MtpEdit;
        void __fastcall PerformBitBtnClick(TObject *Sender);
        void __fastcall BitBtn1Click(TObject *Sender);
        void __fastcall RingRadioGroupClick(TObject *Sender);
        void __fastcall CancelClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
private:	// User declarations
        ComplexImage* orig_image, *filtered_image;
        GreyImage* orig_grey_image;
public:		// User declarations
        __fastcall TDFTRingFrequencyMaskForm(TComponent* Owner);
        __fastcall ~TDFTRingFrequencyMaskForm();
};
//---------------------------------------------------------------------------
extern PACKAGE TDFTRingFrequencyMaskForm *DFTRingFrequencyMaskForm;
//---------------------------------------------------------------------------
#endif
