/*
   DFTSaveUnit.h

   hlavikov soubor okna, pomoc kterho lze uloit hodnoty koefficient do
   ascii souboru.

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef DFTSaveUnitH
#define DFTSaveUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <FileCtrl.hpp>
#include <Buttons.hpp>
#include "..\Headers\dft_save_coefficients.h"
#include <iomanip.h>
#include "..\Headers\dft_vector.h"
#include "..\Headers\image_complex.h"
#include <Dialogs.hpp>
using namespace dft;
//---------------------------------------------------------------------------
class TDFTSaveForm : public TForm
{
__published:	// IDE-managed Components
        TPanel *Panel1;
        TBitBtn *BitBtn2;
        TSaveDialog *SaveDialog;
        TGroupBox *GroupBox1;
        TLabel *Label1;
        TEdit *XPosEdit;
        TEdit *XNegEdit;
        TLabel *Label2;
        TLabel *Label7;
        TEdit *YPosEdit;
        TLabel *Label8;
        TEdit *YNegEdit;
        TBitBtn *BitBtn1;
        void __fastcall BitBtn1Click(TObject *Sender);
private:	// User declarations
        int half;
        ComplexImage* c_image;
        // pos_neg == 1 > positive coeff (e.g. 0 - 127)
        // pos_neg == 0 > negative coeff (e.g  0 - 128)
        bool __fastcall ReadNumbersFromEdit(AnsiString all_string,
                                                   vector& coeff, int pos_neg);

        void __fastcall SaveCoefficients(DFTSaveCoefficients);
        bool __fastcall IfFileExistsOverWrite(AnsiString file_path);
        DFTSaveCoefficients save_coeff;
public:		// User declarations
        __fastcall TDFTSaveForm(TComponent* Owner);
        __fastcall ~TDFTSaveForm();
};
//---------------------------------------------------------------------------
extern PACKAGE TDFTSaveForm *DFTSaveForm;
//---------------------------------------------------------------------------
#endif
