/*
   DFTScissorsFrequencyMaskUnit.h

   hlavikov soubor okna filtru Scissors Frequency Mask, umoujc
   filtrovat oblast ve tvaru nek a to bu k horizontln, nebo
   vertikln ose.

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef DFTScissorsFrequencyMaskUnitH
#define DFTScissorsFrequencyMaskUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "..\Headers\image_complex.h"
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
class TDFTScissorsFrequencyMaskForm : public TForm
{
__published:	// IDE-managed Components
        TBevel *Bevel1;
        TPanel *Panel1;
        TBitBtn *PerformBitBtn;
        TBitBtn *BitBtn1;
        TBitBtn *CancelBitBtn;
        TCheckBox *KindCheckBox;
        TRadioGroup *ScissRadioGroup;
        TEdit *MtpEdit;
        TEdit *AngleEdit;
        TLabel *Label1;
        void __fastcall PerformBitBtnClick(TObject *Sender);
        void __fastcall CancelBitBtnClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall BitBtn1Click(TObject *Sender);
        void __fastcall ScissRadioGroupClick(TObject *Sender);
private:	// User declarations
        ComplexImage* orig_image, *filtered_image;
        GreyImage* orig_grey_image;
public:		// User declarations
        __fastcall TDFTScissorsFrequencyMaskForm(TComponent* Owner);
        __fastcall ~TDFTScissorsFrequencyMaskForm();
};
//---------------------------------------------------------------------------
extern PACKAGE TDFTScissorsFrequencyMaskForm *DFTScissorsFrequencyMaskForm;
//---------------------------------------------------------------------------
#endif
