/*
   DFTSizeUnit.h

   hlavikov soubor okna, zarovnvajcho obraz do velikosti, na kterou
   lze aplikovat FFT algoritmus.

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef DFTSizeUnitH
#define DFTSizeUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include "..\Headers\bmp_handler.h"
#include "..\Headers\image_grey.h"
#include "..\Headers\scale.h"
#include "..\Headers\translate.h"
#include <Buttons.hpp>
//---------------------------------------------------------------------------
class TDFTSizeForm : public TForm
{
__published:	// IDE-managed Components
        TPanel *Panel1;
        TBevel *Bevel1;
        TImage *Image1;
        TLabel *Label1;
        TBitBtn *OKBitBtn;
        TBitBtn *BitBtn2;
        TBevel *Bevel2;
        TRadioGroup *RadioGroup;
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall OKBitBtnClick(TObject *Sender);
        void __fastcall RadioGroupClick(TObject *Sender);
private:	// User declarations
        BMPHandler* sized_handler;
        GreyImage* original_image, *sqr_original_image,
                 *sized_image, *sqr_sized_image;
        int which_pow_of2, max_size;
        bool terminate, cancel;
        bool __fastcall CheckSize(int cols, int rows);
        void __fastcall BlackBackground(GreyImage* back_image,
                    GreyImage* forw_image, int size_of_window);
        void __fastcall MakeUpWithImage(GreyImage* back_image,
                    GreyImage* forw_image, int size_of_window);
        void __fastcall MakeUpWithMirror(GreyImage* back_image,
                    GreyImage* forw_image, int size_of_window);
public:		// User declarations
        __fastcall TDFTSizeForm(TComponent* Owner);
        __fastcall ~TDFTSizeForm();
};
//---------------------------------------------------------------------------
extern PACKAGE TDFTSizeForm *DFTSizeForm;
//---------------------------------------------------------------------------
#endif
