/*
   DFTViewCoeffUnit.cpp

   definin soubor okna sloucho k zobrazen hodnoty FFT koeficientu

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "DFTViewCoeffUnit.h"
#include "DFTUnit.h"
#include "PictureUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TDFTViewCoeffForm *DFTViewCoeffForm;
//---------------------------------------------------------------------------
__fastcall TDFTViewCoeffForm::TDFTViewCoeffForm(TComponent* Owner)
        : TForm(Owner)
{

   Top = PictureForm->Top+30;
   Left = PictureForm->Left + PictureForm->Width - 30 - Width;

   image = DFTForm->GetDFTComplexImage();
   RealLabel->Caption = "Real Part : " + FormatFloat("0.0000",image->Data(
                    image->Cols()/2, image->Rows()/2).real());
   ImagLabel->Caption = "Imag. Part : " + FormatFloat("0.0000",image->Data(
                    image->Cols()/2, image->Rows()/2).imag());
   MagnitudeLabel->Caption = "Magnitude : " + FormatFloat("0.0000",abs(image->Data(
                    image->Cols()/2, image->Rows()/2)));
   PhaseLabel->Caption = "Phase : " + FormatFloat("0.00",arg(image->Data(
                    image->Cols()/2, image->Rows()/2))*180/3.1415927);
}
//---------------------------------------------------------------------------

void __fastcall TDFTViewCoeffForm::ViewButtonClick(TObject *Sender)
{
   try{
      int fx = XEdit->Text.ToInt();
      if (fx>image->Cols()/2)
         throw Exception("Examined Image has only " +
                AnsiString(image->Cols()/2) + "  coefficients in X direction");
      if (fx<-image->Cols()/2)
         throw Exception("Examined Image has only " +
                AnsiString(image->Cols()/2) + "  coefficients in X direction");

      int fy = YEdit->Text.ToInt();
      if (fy>image->Rows()/2)
         throw Exception("Examined Image has only " +
                AnsiString(image->Rows()/2) + "  coefficients in Y direction");
      if (fy< -image->Rows()/2)
         throw Exception("Examined Image has only " +
                AnsiString(image->Rows()/2) + "  coefficients in Y direction");

      RealLabel->Caption = "Real Part : " + FormatFloat("0.00000",image->Data(
                    fx+image->Cols()/2, fy+image->Rows()/2).real());
      ImagLabel->Caption = "Imag. Part : " + FormatFloat("0.00000",image->Data(
                    fx+image->Cols()/2, fy+image->Rows()/2).imag());
      MagnitudeLabel->Caption = "Magnitude : " + FormatFloat("0.00000",abs(image->Data(
                    fx+image->Cols()/2, fy+image->Rows()/2)));
      PhaseLabel->Caption = "Phase : " + FormatFloat("0.00",arg(image->Data(
                    fx+image->Cols()/2, fy+image->Rows()/2))*180/3.1415927);


   }catch(EConvertError& E){
      Application->MessageBox(E.Message.c_str(), "Save Tool Window Error" ,
            MB_ICONWARNING | MB_OK);
   }catch(Exception& E){
      Application->MessageBox(E.Message.c_str(), "Save Tool Window Error" ,
            MB_ICONWARNING | MB_OK);
   }
}
//---------------------------------------------------------------------------
