/*
   FftFiltrationUnit.h

   hlavikov soubor okna umonujc filtraci pomoc FFT

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------

#ifndef FftFiltrationUnitH
#define FftFiltrationUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include "Headers\bmp_handler.h"
#include "Headers\image_grey.h"
#include "Headers\image_complex.h"
#include "Headers\dft_options.h"
#include "Headers\dft_save_coefficients.h"
#include "Headers\freq_mask.h"
#include "Headers\scale.h"
#include <Buttons.hpp>
//---------------------------------------------------------------------------
class TFftFiltrationForm : public TForm
{
__published:	// IDE-managed Components
        TStatusBar *StatusBar;
        TPanel *PanelB;
        TLabel *Label8;
        TPanel *Panel2;
        TImage *Image2;
        TPanel *PanelC;
        TPanel *Panel5;
        TImage *Image3;
        TPanel *PanelD;
        TLabel *Label9;
        TPanel *Panel7;
        TImage *Image4;
        TLabel *Label10;
        TPanel *PanelA;
        TLabel *Label1;
        TLabel *Label4;
        TLabel *Label5;
        TLabel *Label6;
        TEdit *Edit1;
        TEdit *Edit2;
        TComboBox *MethodComboBox;
        TPanel *Panel4;
        TImage *Image1;
        TButton *PerformFftButton;
        TComboBox *ViewComboBox;
        TLabel *Label2;
        TLabel *Label3;
        TComboBox *FilterComboBox;
        TLabel *LabelA;
        TEdit *EditA;
        TEdit *EditB;
        TLabel *LabelB;
        TLabel *LabelC;
        TEdit *EditC;
        TButton *PerformFilterButton;
        TProgressBar *ProgressBar1;
        TButton *PerformBackwardFftButton;
        TProgressBar *ProgressBar2;
        TButton *Button1;
        TButton *Button2;
        TButton *Button3;
        TButton *Button4;
        TBitBtn *BitBtn1;
        TBitBtn *BitBtn2;
        TCheckBox *CheckBox1;
        TLabel *Label7;
        TComboBox *InverseRadioGroup;
        TListBox *ListBox1;
        TListBox *ListBox2;
        TButton *Button5;
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall MethodComboBoxChange(TObject *Sender);
        void __fastcall NoResizeMaybe();
        void __fastcall MakeBlack();
        void __fastcall FindOptimalSize();
        void __fastcall MakeAverage();
        void __fastcall MakeMirror();
        void __fastcall MakePeriodic();
        void __fastcall MakeRepetition();
        void __fastcall FFTForward(DFTOptions &options);
        void __fastcall PerformFftButtonClick(TObject *Sender);
        void __fastcall SetDFTOptions(DFTOptions &opt);
        void __fastcall SetFilterOptions(DFTOptions &opt);
        void __fastcall ViewAsRadioGroupClick(TObject *Sender);
        void __fastcall ViewComboBoxChange(TObject *Sender);
        void __fastcall VisitedBox(AnsiString T1, AnsiString T2, AnsiString T3);
        void __fastcall FilterComboBoxChange(TObject *Sender);
        void __fastcall PerformFilterButtonClick(TObject *Sender);
        void __fastcall PerformLowPass();
        void __fastcall PerformHighPass();
        void __fastcall PerformMultiple();
        void __fastcall PerformScissorsHorizont();
        void __fastcall PerformScissorsVertical();
        void __fastcall PerformBandPass();
        void __fastcall PerformBandStop();
        void __fastcall PerformBackwardFftButtonClick(TObject *Sender);
        void __fastcall EditAChange(TObject *Sender);
        void __fastcall EditBChange(TObject *Sender);
        void __fastcall EditCChange(TObject *Sender);
        void __fastcall Button1Click(TObject *Sender);
        void __fastcall Button2Click(TObject *Sender);
        void __fastcall Button3Click(TObject *Sender);
        void __fastcall Button4Click(TObject *Sender);
        void __fastcall BitBtn2Click(TObject *Sender);
        void __fastcall ViewOutputImage();
        void __fastcall ViewCutOutputImage();
        void __fastcall CheckBox1Click(TObject *Sender);
        void __fastcall BitBtn1Click(TObject *Sender);
        void __fastcall InverseRadioGroupChange(TObject *Sender);
        void __fastcall ListBox1Click(TObject *Sender);
        void __fastcall ListBox2Click(TObject *Sender);
        void __fastcall Button5Click(TObject *Sender);
        void __fastcall Image2MouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
        void __fastcall Image3MouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
        void __fastcall PanelBMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
        void __fastcall PanelAMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
        void __fastcall PanelCMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
        void __fastcall PanelDMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
        void __fastcall FormMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
        void __fastcall ListBox1MouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
        void __fastcall ListBox2MouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);

private:	// User declarations
        BMPHandler* handler;
        GreyImage* original_image;
        GreyImage* fill_image;
        GreyImage* fft_image;
        GreyImage* filtered_image;
        GreyImage* complete_image;
        GreyImage* cut_complete_image;
        GreyImage* sized_image;
        ComplexImage* complex_fft_image;
        ComplexImage* complex_filtered_image;
        ComplexImage* complex_complete_image;
        DFTOptions options;
        int allow_size;
        int type_of_view;
        double scale_const;
        int pos_x, pos_y;
public:		// User declarations
        __fastcall TFftFiltrationForm(TComponent* Owner);
        __fastcall ~TFftFiltrationForm();
        BMPHandler* __fastcall GetBMPHandler();
        void HideShowingData();
};
//---------------------------------------------------------------------------
extern PACKAGE TFftFiltrationForm *FftFiltrationForm;
//---------------------------------------------------------------------------
#endif
