/*
   ViewUnit.cpp

   definin soubor okna zobrazujc frekvenn spektrum po fft filtraci

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "ViewUnit.h"
#include "FftFiltrationUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TViewForm *ViewForm;
//---------------------------------------------------------------------------
__fastcall TViewForm::TViewForm(TComponent* Owner)
        : TForm(Owner)
{
   Top = FftFiltrationForm->Top+15;
   Left = FftFiltrationForm->Left + FftFiltrationForm->Width - 30 - Width;

   original_image = new GreyImage();
   sized_image = new GreyImage();
   handler = new BMPHandler(*(FftFiltrationForm->GetBMPHandler()));
   handler->Set(*original_image);
   Scale scale(*original_image, *sized_image, Image1->Width);
   handler->Assign(*sized_image);
   handler->Show(Image1);
}
//---------------------------------------------------------------------------
__fastcall TViewForm::~TViewForm()
{
   delete (handler);
   delete (original_image);
   delete (sized_image);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::BitBtn1Click(TObject *Sender)
{
   Close();        
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::FormClose(TObject *Sender, TCloseAction &Action)
{
   Release();             
}
//---------------------------------------------------------------------------

