/*
   asci.h

   hlavikov soubor tdy pro Vstup/vstup formt ASCII

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef asciH
#define asciH
//---------------------------------------------------------------------------
#include "in_out.h"
#include "bmp_handler.h"
#include <iomanip.h>

class VAsci : public VInOut
{
private:
   BMPHandler* handler;
public:
   __fastcall VAsci(AnsiString _file_path);
   __fastcall VAsci(GreyImage* _image)
      :VInOut(_image)
      {}
   __fastcall VAsci(BMPHandler* _handler)
      :VInOut(_handler)
      { handler = new BMPHandler; }
   __fastcall ~VAsci();
   // member functions
   void         __fastcall AsciToGreyImage();
   int inline   __fastcall CharToInt(char* buff, unsigned long& index,
                   unsigned long size);
   //virtual functions
   void         __fastcall Assign(BMPHandler* _handler);
   virtual void __fastcall SaveToFile(AnsiString _save_file_name);
}; // class VMatlab

#endif

