/*
   contrast.h

   hlavikov soubor tdy operace pro korekci kontrastu

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef contrastH
#define contrastH
//---------------------------------------------------------------------------
#include "image_grey.h"
#include "lut.h"

class Contrast
{
private:
   const GreyImage* original_image;
   GreyImage* contrast_image;
   LUT contrast_lut;
   long sum;
   float average;
   int col, row;
   int height, width;
public:
   // constructors
   Contrast();
   Contrast(const GreyImage& _original_image, GreyImage& _contrast_image,
            int col, int row, int width, int height);
   ~Contrast() {}
   // member functions
   void ApplyLUT(LUT& lut);
   void ContrastCorrection(float contrast);
}; // class Brightness
#endif

