/*
   Dft.h

   hlavikov soubor pro DFT

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef dftH
#define dftH

//---------------------------------------------------------------------------
// class DFT - Discrete Fourier Transform
#include "image_complex.h"

class DFT
{
private:
   ComplexImage*  image;
   TProgressBar* prog_bar;
   double* data;
public:
   DFT(ComplexImage* _image, TProgressBar* prog_bar);
   ~DFT();
   // member function
   void PerformDFT(double dir);
   bool CheckSize();
private:
   void fft(double* data, int num, double dir);
}; //class DFT
#endif
