/*
   dig.h

   hlavikov soubor tdy pro Vstup/vstup formt Dig.

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef digH
#define digH
//---------------------------------------------------------------------------
#include "in_out.h"
#include "bmp_handler.h"
#include <iomanip.h>

class VDig : public VInOut
{
private:
   BMPHandler* handler;
public:
   __fastcall VDig(AnsiString _file_path);
   __fastcall VDig(GreyImage* _image)
      :VInOut(_image)
      {}
   __fastcall VDig(BMPHandler* _handler)
      :VInOut(_handler)
      { handler = new BMPHandler; }
   __fastcall ~VDig();
   // member functions
   void         __fastcall DigToGreyImage();
   //virtual functions
   void         __fastcall Assign(BMPHandler* _handler);
   virtual void __fastcall SaveToFile(AnsiString _save_file_name);
}; // class VDig

#endif
