/*
   In_out.h

   hlavikov soubor tdy pro prci se soubory

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef in_outH
#define in_outH
//---------------------------------------------------------------------------
#include "bmp_handler.h"
#include "bmp_handler_color.h"
#include "image_grey.h"
#include "image_color.h"
#include "size_bmp_g.h"

class VInOut
{
protected:
   AnsiString file_path;
   AnsiString suffix;
   TMemoryStream* mstream;
   GreyImage* image;
   ColorImage* color_image;
public:
   // constructors
   __fastcall VInOut()
      :file_path(NULL), image(NULL), color_image(NULL), mstream(NULL)
      {}
   __fastcall VInOut(AnsiString _file_path);
   __fastcall VInOut(GreyImage* _image)
      :file_path(NULL), image(_image), mstream(NULL)
      {}
   __fastcall VInOut(BMPHandler* _handler);
   __fastcall VInOut(BMPHandlerColor* color_handler);
   // member function
   // CheckSuffix() checks if the suffix of file is valid
   void       __fastcall CheckSuffix();
   void       __fastcall Assign(GreyImage& _image);
   virtual void __fastcall Assign(BMPHandler* handler){};
   virtual void __fastcall ColorAssign(BMPHandlerColor* color_handler){};
   AnsiString __fastcall ImageName();
   void __fastcall ChangePath(AnsiString _file_path);
   AnsiString __fastcall FilePath () { return file_path; }
   // sets a BMPhandler with GreyImage object
   virtual void __fastcall ConvertToBMP(BMPHandler* handler);
   virtual void __fastcall ConvertToColorBMP(BMPHandlerColor* color_handler);
   // creates a bmp file with ... name
   void       __fastcall SaveToBMP(AnsiString _save_file_name);
   // virtual functions
   // destructor
   virtual      __fastcall ~VInOut();
   virtual void __fastcall SaveToFile(AnsiString _save_file_name)=0;
   void __fastcall SaveProfile(TPoint points[360], AnsiString file_path);
}; // class VInOut
#endif
