/*
   Matlab.h

   hlavikov soubor pro zkladn prci s matic (obrazem)

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef matlabH
#define matlabH
//---------------------------------------------------------------------------
#include "in_out.h"
#include <iomanip.h>

class VMatlab : public VInOut
{
private:
public:
   __fastcall VMatlab(AnsiString _file_path);
   __fastcall VMatlab(GreyImage* _image)
      :VInOut(_image)
      {}
   __fastcall VMatlab(BMPHandler* _handler)
      :VInOut(_handler)
      {}
   __fastcall ~VMatlab();
   // member functions
   void         __fastcall MatlabToGreyImage();
   int inline   __fastcall CharToInt(char* buff, unsigned long& index,
                   unsigned long size);
   //virtual functions
   void         __fastcall Assign(BMPHandler* _handler);
   virtual void __fastcall SaveToFile(AnsiString _save_file_name);
}; // class VMatlab

#endif
