/*
   rotate.h

   hlavikov soubor tdy pro rotaci obrazu s interpolac

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef rotateH
#define rotateH
//---------------------------------------------------------------------------
#include <math.h>
#include "image_grey.h"

class Rotate
{
private:
   const GreyImage* original_image;
   GreyImage* rotated_image;
public:
   // constructors
   Rotate();
   Rotate(const GreyImage& _original_image, GreyImage& _rotated_image);
   ~Rotate(){}
   // member function
   void PerformRotation(int col, int row, int width, int height, double angle,
                        bool interpolate, TColor color);
   void ChangeSizeRotation(double angle, bool interpolate, TColor color);                     
}; // class Rotate
#endif
