/*
   bmp_handler.h

   hlavikov soubor tdy operace s bmp files

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef bmp_handlerH
#define bmp_handlerH
//---------------------------------------------------------------------------
#include "image_grey.h"
#include "size_bmp_g.h"
// class BMPHandler serves for a basic manipulation of the data stored
// in the Windows DIB - *.bmp files

class BMPHandler
{
private:
   Graphics::TBitmap *bitmap;
   GreyImage* image;
   AnsiString file_name;
   TMemoryStream* mstream;
public:
   // constructors
   BMPHandler();
   BMPHandler(const AnsiString _file_name);
   BMPHandler(TMemoryStream* memory_stream);
   BMPHandler(Graphics::TBitmap* _bitmap);
   BMPHandler(const AnsiString _file_name, GreyImage _image);
   // copy constructor
   BMPHandler(const BMPHandler& init);
   ~BMPHandler();
   // member functions
   AnsiString& FileName() { return file_name;}
   int Width()  { return bitmap->Width;  }
   int Height() { return bitmap->Height; }
   int Rows()   { return bitmap->Height; }
   int Cols()   { return bitmap->Width;  }
   // function for saving bitmap on the disc
   void SaveToFile(AnsiString _file_name);
   // draws the bitmap on the TImage component
   void Show(TImage* Image);
   // loads the data from the GreyImage object
   void Assign(TMemoryStream* memory_stream);
   void Assign(GreyImage _image);
   void Assign(Graphics::TBitmap* _bitmap);
   // assign the GreyImage object with the data from the bitmap
   void Set(GreyImage& _image);
   void Set(Graphics::TBitmap* _bitmap);
   // create palette and info_header
   void CreateBitmapAndAssign(GreyImage* _image);
   // overloaded operator
   BMPHandler& operator = (BMPHandler& right);
}; //class BMPHandler
#endif
