/*
   brightness.h

   hlavikov soubor tdy operace pro korekci jasu

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef brightnessH
#define brightnessH
//---------------------------------------------------------------------------
#include "image_grey.h"
#include "lut.h"

class Brightness
{
private:
   const GreyImage* original_image;
   GreyImage* bright_image;
   LUT bright_lut;
public:
   // constructors
   Brightness();
   Brightness(const GreyImage& _original_image, GreyImage& _brigh_image);
   ~Brightness() {}
   // member functions
   void ApplyLUT(LUT& lut, int col, int row, int width, int height);
   void AdjImageBrightness(short brightness_factor, int col, int row,
                        int width, int height);
}; // class Brightness
#endif
