/*
   convolution.h

   hlavikov soubor tdy pro konvoluci

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef convolutionH
#define convolutionH
//---------------------------------------------------------------------------
#include "image_grey.h"
#include "kernel.h"
    

class Convolution
{
private:
   const GreyImage* original_image;
   GreyImage* convol_image;
   const Kernel* ker;

   long sum;
   double r_sum;
   int row_offset;
   int col_offset;
   int cols_extent;
   int rows_extent;
public:
   // constructors
   Convolution();
   Convolution(const Kernel& _ker, const GreyImage& original_image,
                         GreyImage& convol_image);
   ~Convolution() {}
   // member functions
   void PerformConvolution( int col, int row, int width, int height,
                       unsigned scale, unsigned absolute);
   void PerformRealConvolution( int col, int row, int width, int height,
                       double scale, unsigned absolute);
   void CylindricalConvolution( int col, int row, int width, int height,
                       double scale, unsigned absolute);
}; // class Convolution

#endif
