/*
   dft_save_coefficients.h

   hlavikov soubor umoujc uloen koecifientu DFT

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef dft_save_coefficientsH
#define dft_save_coefficientsH
//---------------------------------------------------------------------------
#include "dft_vector.h"
using namespace dft;

class DFTSaveCoefficients
{
public:
   AnsiString file_path;
   bool save;
   vector coeff_x;
   vector coeff_y;
   vector n_coeff_x; // n_ as negative coefficients
   vector n_coeff_y;
public:
   // constructor
   DFTSaveCoefficients()
     : save(true),file_path(NULL) {}
   ~DFTSaveCoefficients(){}
   // overloaded operator of assignment
   DFTSaveCoefficients& operator=(DFTSaveCoefficients& init){
      if(this!=&init){
         file_path = init.file_path;
         save = init.save;
         coeff_x = init.coeff_x;
         coeff_y = init.coeff_y;
         n_coeff_x = init.n_coeff_x;
         n_coeff_y = init.n_coeff_y;
      }
      return *this;
   }
};// class DFTSaveCoefficients

#endif
