/*
   geometric_image.h

   hlavikov soubor tdy pro nkter geometrick operace s obrazem.

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef geometric_imageH
#define geometric_imageH
//---------------------------------------------------------------------------
#include "image_grey.h"
#include "scale.h"
#include "rotate.h"
#include "translate.h"

class GeometricImage  : public GreyImage
{
private:
   Scale* scale;
   Rotate* rotate;
   Translate* trans;
public:
   // constructors
   __fastcall GeometricImage()
     : GreyImage() {}
   __fastcall GeometricImage(int _cols, int _rows);
   ~GeometricImage(){}
   // member functions
   void PerformScale(GreyImage& _scaled_image, int s_col, int s_row,
                     int s_width, int s_height, double scale_h,
                     double scale_v, int d_col, int d_row,
                     bool interpolate);
   void ChangeSize(GreyImage& _sized_image, int s_col, int s_row,
                   int s_width, int s_height, int d_col, int d_row,
                   int d_width, int d_height, bool interpolate);
   void PerformRotation(GreyImage& _rotated_image, int col, int row, int width,
               int height, double angle, bool interpolate);
   void PerformTranslation(GreyImage& _translated_image, int s_col, int s_row,
                           int s_width, int s_height, int d_col, int d_row,
                           bool erase_flag);
   void MirrorImage(GreyImage& _mirror_image, int s_col, int s_row,
                    int s_width, int s_height, int d_col, int d_row,
                    MirrorType which_mirror);
   //void SinDistortion(GreyImage& _distorted_image, double omega, int amp);
}; //class GeometricImage

#endif
