/*
   image_grey.h

   hlavikov soubor tdy pro zkladn tdu 8bitovch obraz.

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef image_greyH
#define image_greyH
//---------------------------------------------------------------------------
#include <fstream.h>
#include "image.h"
#include "image_const.h"

// basic class for greyscale images

class GreyImage : public Image<unsigned char>
{
private:
public:
   // constructors
   GreyImage()
     :Image<unsigned char>()  {}
   GreyImage(int _cols, int _rows)
     :Image<unsigned char>(_cols,_rows) {}
   // destructor
   virtual ~GreyImage() {}
   // member functions
   // functiond for dealing with readind from and saving into *.bmp
   void ReadFromBMP(AnsiString file_name);
   void Show(TCanvas* canvas);
   // function for reading and writing portion of an image
   void ReadImageAreaToImage(GreyImage& buff,int col, int row,
                             int width, int height);
   void WriteImageAreaFromImage(GreyImage& buff,int col, int row,
                             int width, int height);
   // clearing specifing area of an image
   void ClearImageArea(unsigned char pixel_value, int width,
                       int height, int col = 0, int row = 0);
   void BitField(GreyImage& image, int b, int width,
                       int height, int col = 0, int row = 0);
   void DrawCircle(int ic, int ir, int irad, unsigned char pixel_value);
   void DrawCross(int ic, int ir, unsigned char pixel_value);
   void Drawline(int p1r, int p1c, int p2r, int p2c, unsigned char pixel_value);
}; // class GreyImage

#endif
