/*
   lut_fly_belt.h

   hlavikov soubor LUT tabulky - opasek

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef lut_fly_beltH
#define lut_fly_beltH
//---------------------------------------------------------------------------
#include "lut_base.h"
enum WhichPoint { _LM, _RM };

class LUTFlyBelt : public LUTBase
{
private:
   VPoint LD, RT, LM, RM; // left_down, right_top, left_middle, roght_middle
   bool down;
   WhichPoint which_point;
public:
   // constructors
   LUTFlyBelt()
      : LUTBase() {}
   LUTFlyBelt(TImage* _Image, TPanel* _Panel);
   virtual ~LUTFlyBelt() {}
   // member functions
   void SetNewPoints(int X, int Y, VPoint& LM, VPoint& RM);
   void KeepInBorder(VPoint& point);  
   // virtual member functions
   virtual void DrawChart();
   virtual void OnMouseDown(TMouseButton Button, int X, int Y);
   virtual void OnMouseUp  (TMouseButton Button, int X, int Y);
   virtual void OnMouseMove(int X, int Y);
}; // class LUTFlyBelt
#endif

