/*
   lut_threshold_equal_1.h

   hlavikov soubor LUT tabulky - prahovn

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef lut_threshold_equal_1H
#define lut_threshold_equal_1H
//---------------------------------------------------------------------------
#include "lut_base.h"

enum Which_DragTE1{ _L, _M, _R,};

class LUTThresholdEqual_1 : public LUTBase
{
private:
   VPoint LD, LM, LMD, LMT, RM, RMT, RMD, RT;
   VPoint RMold, LMold;
   Which_DragTE1 which_drag;
   bool down;
   int start, diff;
public:
   // constructors
   LUTThresholdEqual_1()
      : LUTBase() {}
   LUTThresholdEqual_1(TImage* _Image, TPanel* _Panel);
   virtual ~LUTThresholdEqual_1() {}
   // member functions
   void SetNewPoints(int X, int Y);
   // virtual member functions
   virtual void DrawChart();
   virtual void OnMouseDown(TMouseButton Button, int X, int Y);
   virtual void OnMouseUp  (TMouseButton Button, int X, int Y);
   virtual void OnMouseMove(int X, int Y);
}; // class LUTThresholdEqual_1
#endif
