/*
   mask_options.h

   hlavikov soubor definujc nastaven vlastnost masky
   pro morfologick operace

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef mask_optionsH
#define mask_optionsH
//---------------------------------------------------------------------------
// class for specifiing the mask
enum MaskShape { full, round, cross, vertical, horizontal, shape_user };
enum MaskSize { size3x3, size5x5, size_user };
//---------------------------------------------------------------------------
class MaskOptions
{
private:
   MaskShape shape;
   MaskSize size;
   int cols, rows;
public:
   //constructors
   MaskOptions()
     :shape(full), size(size3x3){}
   MaskOptions(MaskShape _shape, MaskSize _size)
     :shape(_shape), size(_size){}
   // member functions
   int& Cols() { return cols; }
   int& Rows() { return rows; }
   MaskShape& Shape() { return shape; }
   MaskSize& Size() { return size; }
   // overloaded operator of assignment
   MaskOptions& operator= (const MaskOptions& init){
      if(this!=&init){
         size = init.size;
         shape = init.shape;
         cols = init.cols;
         rows = init.rows;
      }
      return *this;
   }
}; // class MaskOptions
#endif
