/*
   noise_options.h

   hlavikov soubor definujc vlastnosti jednotlivch druh umu

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef noise_optionsH
#define noise_optionsH
//---------------------------------------------------------------------------
// class for exchanging of the noise parameters between the Noise Windows
// Salt and Pepper Noise function
struct SaltAndPepper
{
   double probability;
};
// Gaussian Noise function
struct Gaussian
{
   double var;
   double mean;
};
// Gamma Noise function
struct Gamma
{
   double var;
   int alpha;  //alpha>0
};
// Negative Exponential Noise
struct NegativeExp
{
   double var;
};
// Rayleigh Noise
struct Rayleigh
{
   double var;
};
// Uniform Noise
struct Uniform
{
   double var;
   double mean;
};
//---------------------------------------------------------------------------
// main Noise Options class
// member datas are public!
class NoiseOptions
{
public:
   SaltAndPepper salt_and_pepper;
   Gaussian gaussian;
   Gamma gamma;
   NegativeExp negative_exp;
   Rayleigh rayleigh;
   Uniform uniform;
public:
   // constructor
   NoiseOptions(){
     salt_and_pepper.probability = 0.01;
     gaussian.mean = 0;
     gaussian.var = 500;
     gamma.var = 500;
     gamma.alpha = 5;
     negative_exp.var = 500;
     rayleigh.var = 500;
     uniform.var = 500;
     uniform.mean = 0;
  }
   // overloaded operator
   NoiseOptions& operator=(const NoiseOptions& init){
      if(this!=&init){
         salt_and_pepper.probability = init.salt_and_pepper.probability;
         gaussian.var = init.gaussian.var;
         gaussian.mean = init.gaussian.mean;
         gamma.var = init.gamma.var;
         gamma.alpha = init.gamma.alpha;
         negative_exp.var = init.negative_exp.var;
         rayleigh.var = init.rayleigh.var;
         uniform.var = init.uniform.var;
         uniform.mean = init.uniform.mean;
      }
      return *this;
   }
}; // class NoiseOptions
#endif
