/*
   nonlinear_filter.h

   hlavikov soubor NonlinearFilter pro nelinern filtraci

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef nonlinear_filterH
#define nonlinear_filterH
//---------------------------------------------------------------------------
#include "image_grey.h"

//---------------------------------------------------------------------------
class NonlinearFilter
{
private:
   const GreyImage* original_image;
   GreyImage* filtered_image;
public:
   // constructors
   NonlinearFilter();
   NonlinearFilter(const GreyImage& _original_image,
                  GreyImage& _filtered_image);
   ~NonlinearFilter();
   // member functions
   void MedianFilter(int col, int row, int width, int height,
                     int neighborhood_cols, int neighborhood_rows);
   void MaximumFilter(int col, int row, int width, int height,
                     int neighborhood_cols, int neighborhood_rows);
   void MinimumFilter(int col, int row, int width, int height,
                     int neighborhood_cols, int neighborhood_rows);
   void HarmonicMeanFilter(int col, int row, int width, int height,
                     int neighborhood_cols, int neighborhood_rows);
   void MidpointFilter(int col, int row, int width, int height,
                     int neighborhood_cols, int neighborhood_rows);
   void GeometricMeanFilter(int col, int row, int width, int height,
                     int neighborhood_cols, int neighborhood_rows);
   void ContraHarmonicMeanFilter(int col, int row, int width, int height,
                     int neighborhood_cols, int neighborhood_rows, int p);

}; // class NonlinearFilter

#endif
