/*
   pseudo_color.h

   hlavikov soubordefinujc prci s pseudobarevnmi obrazy

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef pseudo_colorH
#define pseudo_colorH

#include "Headers\image_grey.h"
#include "size_bmp_g.h"
#include "math.h"

enum Palette_Type
{
   GREY, BONE, COPPER, HOT, JET, HSV, FLAG
};

//---------------------------------------------------------------------------
class PseudoColor
{

public:
   // constructors
   PseudoColor();
   ~PseudoColor();
   void __fastcall Transform(GreyImage* image1, TMemoryStream* mstream,
                             int palette[3][256]);
   void __fastcall ChangePalette(int palette[3][256], Palette_Type pal);
   void __fastcall CreateImageFromPalette(int palette[3][256],
                   TMemoryStream* memory_stream);
   void __fastcall IntToRBG(int NotRGB, int RGB[3]);
   void __fastcall Gradient(int first_level, int second_level, int first_color[3],
                            int second_color[3], int palette[3][256]);
   int RoundToInt(float f);                         

private:		// User declarations
        TMemoryStream* memory_stream;
        unsigned char* buffer;
}; // class PseudoColor

#endif
