/*
   GammaCorrectionUnit.h

   hlavikov soubor okna pro gama korekci

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef GammaCorrectionUnitH
#define GammaCorrectionUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>
#include "Headers\bmp_handler.h"
#include "Headers\image_grey.h"
#include "Headers\brightness.h"
#include "Headers\scale.h"
//---------------------------------------------------------------------------
class TGammaCorrectionForm : public TForm
{
__published:	// IDE-managed Components
        TStatusBar *StatusBar1;
        TPanel *Panel1;
        TTimer *Timer1;
        TPanel *Panel4;
        TPanel *Panel2;
        TImage *Image3;
        TLabel *Label5;
        TUpDown *UpDown4;
        TEdit *Edit4;
        TLabel *Label4;
        TLabel *Label2;
        TEdit *Edit3;
        TUpDown *UpDown3;
        TEdit *Edit1;
        TUpDown *UpDown1;
        TLabel *Label1;
        TEdit *Edit2;
        TUpDown *UpDown2;
        TPanel *Panel6;
        TImage *Image1;
        TLabel *Label7;
        TPanel *Panel7;
        TPanel *Panel3;
        TImage *Image4;
        TLabel *Label6;
        TPanel *Panel5;
        TEdit *Edit5;
        TTrackBar *TrackBar1;
        TLabel *Label3;
        TButton *ResetButton;
        TLabel *Label8;
        TBitBtn *CancelBitBtn;
        TBitBtn *OKBitBtn;
        TImage *Image2;
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall UpDown1Click(TObject *Sender, TUDBtnType Button);
        void __fastcall UpDown2Click(TObject *Sender, TUDBtnType Button);
        void __fastcall UpDown3Click(TObject *Sender, TUDBtnType Button);
        void __fastcall UpDown4Click(TObject *Sender, TUDBtnType Button);
        void __fastcall TrackBar1Change(TObject *Sender);
        void __fastcall CancelBitBtnClick(TObject *Sender);
        void __fastcall OKBitBtnClick(TObject *Sender);
        void __fastcall Edit1Change(TObject *Sender);
        void __fastcall Edit3Change(TObject *Sender);
        void __fastcall Edit4Change(TObject *Sender);
        void __fastcall ResetButtonClick(TObject *Sender);
        void __fastcall Timer1Timer(TObject *Sender);
        void __fastcall Edit2Change(TObject *Sender);
private:	// User declarations
        int in_1, in_2, out_1, out_2, max_hist, max_modif_hist;
        float gamma_level;
        int transform[256];
        int hist[256];
        int modif_hist[256];
        BMPHandler* handler;
        GreyImage* original_image;
        GreyImage* sized_image;
        GreyImage* modification_image;

public:		// User declarations
        __fastcall TGammaCorrectionForm(TComponent* Owner);
        __fastcall ~TGammaCorrectionForm();
        void __fastcall ComputePreview();
        void __fastcall ComputeFinalImage();
        void __fastcall ComputeTransform();
        void __fastcall ShowHistogram();
        void __fastcall ShowModifHistogram();
};
//---------------------------------------------------------------------------
extern PACKAGE TGammaCorrectionForm *GammaCorrectionForm;
//---------------------------------------------------------------------------
#endif
