/*
   HistogramEqualizationUnit.h

   hlavikov soubor okna pro ekvalizaci histogramu

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef HistogramEqualizationUnitH
#define HistogramEqualizationUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "..\Headers\frame_image.h"
#include "..\Headers\bmp_handler.h"
#include "..\Headers\image_grey.h"
#include "..\Headers\scale.h"
#include "..\Headers\histogram.h"
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
//---------------------------------------------------------------------------
class THistogramEqualizationForm : public TForm
{
__published:	// IDE-managed Components
        TPanel *Panel1;
        TStatusBar *StatusBar1;
        TPanel *Panel4;
        TPanel *Panel5;
        TPanel *Panel2;
        TPanel *Panel3;
        TLabel *Label1;
        TLabel *Label2;
        TLabel *Label3;
        TLabel *Label4;
        TBitBtn *BitBtnCancel;
        TBitBtn *BitBtnOk;
        TImage *Image1;
        TImage *Image2;
        TImage *Image3;
        TImage *Image4;
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall BitBtnOkClick(TObject *Sender);
        void __fastcall Image3MouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall Image4MouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall Image3MouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
        void __fastcall Image4MouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
        void __fastcall Image3MouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
        void __fastcall Image4MouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
        void __fastcall Panel1MouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
        void __fastcall Image1MouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
        void __fastcall Image2MouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
private:	// User declarations
        BMPHandler* handler;
        GreyImage* original_image;
        GreyImage* equailized_image;
        GreyImage* sized_original_image;
        GreyImage* sized_equailized_image;
        Histogram histogram1, histogram2;
        short scale1, scale2;
        int last1, last2;
public:		// User declarations
        __fastcall THistogramEqualizationForm(TComponent* Owner);
        __fastcall ~THistogramEqualizationForm();
};
//---------------------------------------------------------------------------
extern PACKAGE THistogramEqualizationForm *HistogramEqualizationForm;
//---------------------------------------------------------------------------
#endif
