/*
   HistogramModificationUnit.h

   hlavikov soubor okna pro modifikaci histogramu

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef HistogramModificationUnitH
#define HistogramModificationUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include "Headers\bmp_handler.h"
#include "Headers\image_grey.h"
#include "Headers\brightness.h"
#include "Headers\point_image.h"
#include "Headers\scale.h"
//---------------------------------------------------------------------------
class THistogramModificationForm : public TForm
{
__published:	// IDE-managed Components
        TStatusBar *StatusBar1;
        TPanel *Panel1;
        TPanel *Panel4;
        TLabel *Label5;
        TLabel *Label7;
        TLabel *Label3;
        TPanel *Panel2;
        TImage *Image3;
        TPanel *Panel6;
        TImage *Image1;
        TEdit *Edit5;
        TTrackBar *TrackBar1;
        TPanel *Panel7;
        TLabel *Label6;
        TLabel *Label8;
        TPanel *Panel3;
        TImage *Image4;
        TPanel *Panel5;
        TImage *Image2;
        TBitBtn *CancelBitBtn;
        TBitBtn *OKBitBtn;
        TComboBox *ComboBox1;
        TLabel *Label1;
        TTimer *Timer1;
        void __fastcall ComboBox1Change(TObject *Sender);
        void __fastcall TrackBar1Change(TObject *Sender);
        void __fastcall Timer1Timer(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall OKBitBtnClick(TObject *Sender);
private:	// User declarations
        int max_hist, max_modif_hist;
        float alfa, gmin, gmax, amp_index;
        long int num_pixel;
        BMPHandler* handler;
        GreyImage* original_image;
        GreyImage* sized_image;
        GreyImage* modification_image;
        int hist_original[256];
        int hist_modif[256];
        float cum_hist_original[256]; // cumulative histogram
        unsigned char transform[256];
public:		// User declarations
        __fastcall THistogramModificationForm(TComponent* Owner);
        __fastcall ~THistogramModificationForm();
        void __fastcall UniformTransform();
        void __fastcall ExponencialTransform();
        void __fastcall RayleighTransform();
        void __fastcall CubeRootTransform();
        void __fastcall LogarithmizeTransform();
        void __fastcall ComputePreviewImage();
        void __fastcall ShowOriginalHistogram();
        void __fastcall ShowModifHistogram();
        void __fastcall ComputeFinalImage();
};
//---------------------------------------------------------------------------
extern PACKAGE THistogramModificationForm *HistogramModificationForm;
//---------------------------------------------------------------------------
#endif
