/*
   HistogramSpecificationUnit.h

   hlavikov soubor okna pro specifikaci histogramu

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef HistogramSpecificationUnitH
#define HistogramSpecificationUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include "Headers\bmp_handler.h"
#include "Headers\image_grey.h"
#include "Headers\brightness.h"
#include "Headers\point_image.h"
#include "Headers\scale.h"
//---------------------------------------------------------------------------
class THistogramSpecificationForm : public TForm
{
__published:	// IDE-managed Components
        TStatusBar *StatusBar1;
        TBitBtn *CancelBitBtn;
        TBitBtn *OKBitBtn;
        TPanel *Panel4;
        TLabel *Label5;
        TLabel *Label7;
        TPanel *Panel2;
        TImage *Image3;
        TPanel *Panel6;
        TImage *Image1;
        TPanel *Panel3;
        TImage *Image4;
        TLabel *Label6;
        TLabel *Label8;
        TPanel *Panel5;
        TImage *Image2;
        TButton *Button1;
        void __fastcall OKBitBtnClick(TObject *Sender);
        void __fastcall CancelBitBtnClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall Button1Click(TObject *Sender);
private:	// User declarations
        int max_hist, max_modif_hist;
        BMPHandler* handler;
        GreyImage* original_image;
        GreyImage* sized_image;
        GreyImage* modification_image;
        int hist_original[256];
        int hist_required[256];
        int hist_modif[256];
        int transform[256];
        long int cum_hist_original[256]; // cumulative in histogram
        long int cum_hist_required[256]; // cumulative out histogram
        LUT* original_lut;

public:		// User declarations
        __fastcall THistogramSpecificationForm(TComponent* Owner);
        __fastcall ~THistogramSpecificationForm();
        void __fastcall ComputePreview();
        void __fastcall ShowHistogram();
        void __fastcall ShowModifHistogram();
        void __fastcall ComputeFinalImage();
        void __fastcall ComputeTransform();
        void __fastcall SetData(int data[]);
        void __fastcall SetData(LUT* lut);
        void __fastcall NormalizeSurface();
};
//---------------------------------------------------------------------------
extern PACKAGE THistogramSpecificationForm *HistogramSpecificationForm;
//---------------------------------------------------------------------------
#endif
