/*
   HistogramStretchingUnit.h

   hlavikov soubor okna pro funkci roztaen histogramu

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef HistogramStretchingUnitH
#define HistogramStretchingUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "..\Headers\frame_image.h"
#include "..\Headers\bmp_handler.h"
#include "..\Headers\image_grey.h"
#include "..\Headers\scale.h"
#include "..\Headers\histogram.h"
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
//---------------------------------------------------------------------------
class THistogramStrechingForm : public TForm
{
__published:	// IDE-managed Components
        TStatusBar *StatusBar1;
        TPanel *Panel1;
        TLabel *Label1;
        TLabel *Label2;
        TLabel *Label3;
        TLabel *Label4;
        TPanel *Panel4;
        TImage *Image3;
        TPanel *Panel5;
        TImage *Image4;
        TPanel *Panel2;
        TImage *Image1;
        TPanel *Panel3;
        TImage *Image2;
        TBitBtn *BitBtnCancel;
        TBitBtn *BitBtnOk;
        TLabel *Label18;
        TPanel *Panel6;
        TLabel *Label5;
        TTrackBar *TrackBar;
        TEdit *Edit1;
        TTimer *Timer1;
        void __fastcall n(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall Image4MouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall Image3MouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
        void __fastcall Image4MouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
        void __fastcall Image3MouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
        void __fastcall Image3MouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall Image4MouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
        void __fastcall BitBtnOkClick(TObject *Sender);
        void __fastcall Image1MouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
        void __fastcall Image2MouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
        void __fastcall TrackBarChange(TObject *Sender);
        void __fastcall Timer1Timer(TObject *Sender);
private:	// User declarations
        BMPHandler* handler;
        GreyImage* original_image;
        GreyImage* stretched_image;
        GreyImage* sized_original_image;
        GreyImage* sized_stretched_image;
        Histogram histogram1, histogram2;
        short scale1, scale2;
        int last1, last2;
        float omis_level;
public:		// User declarations
        __fastcall THistogramStrechingForm(TComponent* Owner);
        __fastcall ~THistogramStrechingForm();
        __fastcall ComputeIt();
};
//---------------------------------------------------------------------------
extern PACKAGE THistogramStrechingForm *HistogramStrechingForm;
//---------------------------------------------------------------------------
#endif
