/*
   HistogramUnit.cpp

   definin soubor okna pro zobrazen histogramu

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "HistogramUnit.h"
#include "DrawUnit.h"
#include "PictureUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
THistogramForm *HistogramForm;
//---------------------------------------------------------------------------
// constructor
__fastcall THistogramForm::THistogramForm(TComponent* Owner)
        : TForm(Owner)
{
   Top = PictureForm->Top+30;
   Left = PictureForm->Left + PictureForm->Width - 30 - Width;

   PictureForm->GetBMPHandler()->Set(image);
   histogram.InitFromGreyImage(image,0,0,image.Cols(),image.Rows());
   //histogram.DisplayWithComment(Image1,Panel2);
   histogram.Display(Image1);
   last = 0;
}
//---------------------------------------------------------------------------
// destructor
__fastcall THistogramForm::~THistogramForm()
{

}
//---------------------------------------------------------------------------
// close this form
void __fastcall THistogramForm::FormClose(TObject *Sender,
      TCloseAction &Action)
{
  Release();
}
//---------------------------------------------------------------------------
// mouse down
void __fastcall THistogramForm::Image1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
   DrawForm->OnMouseDown(Button, X, Y);
}
//---------------------------------------------------------------------------
// mouse up
void __fastcall THistogramForm::Image1MouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
   DrawForm->OnMouseUp(Button, X, Y);
}
//---------------------------------------------------------------------------
// show information about histogram
void __fastcall THistogramForm::Image1MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
  DrawForm->OnMouseMove(X, Y);
  if ((10 <= X)&&(X <= 265)&&(10 <= Y)&&(Y <= Panel2->Height-12)){
    histogram.LineOnly(Image1, last);
    histogram.CursorLine(Image1, X-10);
    last = X-10;
    StatusBar1->Panels->Items[0]->Text = "Pixel value: " + AnsiString(X-10);
    StatusBar1->Panels->Items[1]->Text = "Count: " + AnsiString(histogram.Count(X-10));
  }else{
    histogram.LineOnly(Image1, last);
    StatusBar1->Panels->Items[0]->Text = "";
    StatusBar1->Panels->Items[1]->Text = "";
  }
}
//---------------------------------------------------------------------------
void __fastcall THistogramForm::Panel1MouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
   histogram.LineOnly(Image1, last);
   StatusBar1->Panels->Items[0]->Text = "";
   StatusBar1->Panels->Items[1]->Text = "";
}
//---------------------------------------------------------------------------




