/*
   HistogramUnit.h

   hlavikov soubor okna pro zobrazen histogramu

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef HistogramUnitH
#define HistogramUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include "..\Headers\image_grey.h"
#include "..\Headers\histogram.h"
#include <Menus.hpp>
#include <Buttons.hpp>
//---------------------------------------------------------------------------
class THistogramForm : public TForm
{
__published:	// IDE-managed Components
        TBevel *Bevel1;
        TPanel *Panel1;
        TPanel *Panel2;
        TImage *Image1;
        TStatusBar *StatusBar1;
        TBitBtn *BitBtn1;
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall Image1MouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall Image1MouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
        void __fastcall Image1MouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
        void __fastcall Panel1MouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
private:	// User declarations
        GreyImage image, eq_image;
        Histogram histogram;
        int last;
public:		// User declarations
        __fastcall THistogramForm(TComponent* Owner);
        __fastcall ~THistogramForm();
};
//---------------------------------------------------------------------------
extern PACKAGE THistogramForm *HistogramForm;
//---------------------------------------------------------------------------
#endif
