/*
   TypeAdjHistogramUnit.h

   hlavikov soubor okna pro monost zmny LUT pro specifikaci histogramu

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef TypeAdjHistogramUnitH
#define TypeAdjHistogramUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include "..\Headers\image_grey.h"
#include "..\Headers\point_image.h"
#include "..\Headers\lut_base.h"
#include "..\Headers\lut_brightness.h"
#include "..\Headers\lut_contrast.h"
#include "..\Headers\lut_threshold.h"
#include "..\Headers\lut_3l_threshold.h"
#include "..\Headers\lut_threshold_equal_1.h"
#include "..\Headers\lut_threshold_equal_2.h"
#include "..\Headers\lut_negative.h"
#include "..\Headers\lut_equal.h"
#include "..\Headers\lut_equal_negative.h"
#include "..\Headers\lut_fly_belt.h"
#include "..\Headers\lut_bit_fields.h"
#include "..\Headers\lut_free.h"
#include "..\Headers\lut_exp.h"
#include "..\Headers\lut_ln.h"
#include "..\Headers\brightness.h"
//---------------------------------------------------------------------------
class TTypeSpecificationHistogramForm : public TForm
{
__published:	// IDE-managed Components
        TPanel *Panel1;
        TBevel *Bevel1;
        TImage *Image;
        TTimer *LutTimer;
        void __fastcall ImageMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall ImageMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
        void __fastcall ImageMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
        void __fastcall LutTimerTimer(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall TransferData();

private:	// User declarations
        LUTBase* lut_base;
        bool just_once;
        int width;
        LUT* original_lut;
        //PointImage* hist_image;
public:		// User declarations
        __fastcall TTypeSpecificationHistogramForm(TComponent* Owner);
        __fastcall ~TTypeSpecificationHistogramForm();
};
//---------------------------------------------------------------------------
extern PACKAGE TTypeSpecificationHistogramForm *TypeSpecificationHistogramForm;
//---------------------------------------------------------------------------
#endif
