/*
   LUTAdjUnit.h

   hlavikov soubor okna pro monost zmny LUT s nhledem na histogram

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef LUTAdjUnitH
#define LUTAdjUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include "..\Headers\image_grey.h"
#include "..\Headers\point_image.h"
#include "..\Headers\lut_base.h"
#include "..\Headers\lut_brightness.h"
#include "..\Headers\lut_contrast.h"
#include "..\Headers\lut_threshold.h"
#include "..\Headers\lut_3l_threshold.h"
#include "..\Headers\lut_threshold_equal_1.h"
#include "..\Headers\lut_threshold_equal_2.h"
#include "..\Headers\lut_negative.h"
#include "..\Headers\lut_equal.h"
#include "..\Headers\lut_equal_negative.h"
#include "..\Headers\lut_fly_belt.h"
#include "..\Headers\lut_bit_fields.h"
#include "..\Headers\lut_free.h"
#include "..\Headers\lut_exp.h"
#include "..\Headers\lut_ln.h"
#include "..\Headers\brightness.h"
//---------------------------------------------------------------------------
class TLUTAdjForm : public TForm
{
__published:	// IDE-managed Components
        TPanel *Panel1;
        TBevel *Bevel1;
        TImage *Image;
        TCheckBox *CheckBoxHist;
        TTimer *LutTimer;
        TBevel *Bevel2;
        TImage *HistImage;
        void __fastcall ImageMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall ImageMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
        void __fastcall ImageMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
        void __fastcall LutTimerTimer(TObject *Sender);
        void __fastcall CheckBoxHistClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
private:	// User declarations
        LUTBase* lut_base;
        Histogram* lut_histogram;
        PointImage* lut_image;
        Brightness* apply_lut;
        bool just_once;
        int width, width_with_hist;
        //PointImage* hist_image;
public:		// User declarations
        __fastcall TLUTAdjForm(TComponent* Owner);
        __fastcall ~TLUTAdjForm();
};
//---------------------------------------------------------------------------
extern PACKAGE TLUTAdjForm *LUTAdjForm;
//---------------------------------------------------------------------------
#endif
