/*
   LUTListUnit.h

   hlavikov soubor okna pro vbr jedn z 16 LUT

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef LUTListUnitH
#define LUTListUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>

enum ListLUT { brightness, contrast, threshold, equal, negative, equal_negative,
               fly_belt, bit_field1, bit_field2, bit_field3, free_lut,
               threshold_3l, threshold_equal_1, threshold_equal_2, exp_lut, ln_lut };
//---------------------------------------------------------------------------
class TLUTListForm : public TForm
{
__published:	// IDE-managed Components
        TPanel *Panel1;
        TBitBtn *BrightnesBitBtn;
        TBitBtn *ContrastBitBtn;
        TBitBtn *TresholdBitBtn;
        TBitBtn *EqualBitBtn;
        TBitBtn *NegativeBitBtn;
        TBitBtn *EqualNegateBitBtn;
        TBitBtn *FlyBeltBitBtn;
        TBitBtn *BitField1BitBtn;
        TBitBtn *BitField2BitBtn;
        TBitBtn *BitField3BitBtn;
        TBitBtn *FreeBitBtn;
        TBitBtn *Threshold3lBitBtn;
        TBitBtn *ThresholdEqual_1BitBtn;
        TBitBtn *ThresholdEqual_2BitBtn;
        TBitBtn *Exp_BitBtn;
        TBitBtn *Ln_BitBtn;
        void __fastcall TresholdBitBtnClick(TObject *Sender);
        void __fastcall BrightnesBitBtnClick(TObject *Sender);
        void __fastcall ContrastBitBtnClick(TObject *Sender);
        void __fastcall EqualBitBtnClick(TObject *Sender);
        void __fastcall NegativeBitBtnClick(TObject *Sender);
        void __fastcall EqualNegateBitBtnClick(TObject *Sender);
        void __fastcall BitField1BitBtnClick(TObject *Sender);
        void __fastcall BitField2BitBtnClick(TObject *Sender);
        void __fastcall BitField3BitBtnClick(TObject *Sender);
        void __fastcall FreeBitBtnClick(TObject *Sender);
        void __fastcall FlyBeltBitBtnClick(TObject *Sender);
        void __fastcall Threshold3lBitBtnClick(TObject *Sender);
        void __fastcall ThresholdEqual_1BitBtnClick(TObject *Sender);
        void __fastcall ThresholdEqual_2BitBtnClick(TObject *Sender);
        void __fastcall Exp_BitBtnClick(TObject *Sender);
        void __fastcall Ln_BitBtnClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
private:	// User declarations
        ListLUT which_lut;
public:		// User declarations
        __fastcall TLUTListForm(TComponent* Owner);
        ListLUT WhichLUT() { return which_lut; }
};
//---------------------------------------------------------------------------
extern PACKAGE TLUTListForm *LUTListForm;
//---------------------------------------------------------------------------
#endif
