/*
   LUTUnit.cpp

   definin soubor okna pro LUT s nhledem

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "LUTUnit.h"
#include "PictureUnit.h"
#include "LUTListUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TLUTForm *LUTForm;
//---------------------------------------------------------------------------
__fastcall TLUTForm::TLUTForm(TComponent* Owner)
        : TForm(Owner)
{
   original_lut = new LUT();
   original_image = new PointImage();
   sized_image = new GeometricImage();
   lut_image = new PointImage();
   lut_handler = new BMPHandler(*(PictureForm->GetBMPHandler()));
   sized_handler = new BMPHandler(*(PictureForm->GetBMPHandler()));
   lut_handler->Set(*original_image);
   Scale scale(*original_image, *sized_image, Image1->Width);
   Scale scale2(*original_image, *lut_image, Image2->Width);

   if (sized_image->Cols() > sized_image->Rows()){
     Image2->Top=Image2->Top + (sized_image->Cols()-sized_image->Rows())/2;
   }else if (sized_image->Rows() > sized_image->Cols()){
     Image2->Left=Image2->Left + (sized_image->Rows()-sized_image->Cols())/2;
   }

   lut_handler->Assign(*lut_image);
   sized_handler->Assign(*sized_image);
   sized_handler->Show(Image1);
   lut_handler->Show(Image2);

}
//---------------------------------------------------------------------------
__fastcall TLUTForm::~TLUTForm()
{
   delete (lut_handler);
   delete (sized_handler);
   delete (sized_image);
   delete (lut_image);
   delete (original_image);
   delete (original_lut);
}
//---------------------------------------------------------------------------
void __fastcall TLUTForm::OKBitBtnClick(TObject *Sender)
{
   original_image->ApplyLUT(*original_lut, 0, 0, original_image->Cols(),
                                                original_image->Rows());
   PictureForm->AssignList(original_image);
   Close();
   Release();
}
//---------------------------------------------------------------------------

void __fastcall TLUTForm::LUTBitBtnClick(TObject *Sender)
{
   Application->CreateForm(__classid(TLUTListForm),
                          &LUTListForm);
   LUTListForm->Top = Top;
   LUTListForm->Left = Left + Width+5;
   LUTListForm -> ShowModal();
}
//---------------------------------------------------------------------------
void
__fastcall TLUTForm::SetBMPHandler(GreyImage* init)
{
   lut_handler->Assign(*init);
   lut_handler->Show(Image2);
}
//---------------------------------------------------------------------------
void __fastcall TLUTForm::FormClose(TObject *Sender, TCloseAction &Action)
{
   Release();        
}
//---------------------------------------------------------------------------

