/*
   LUTUnit.h

   hlavikov soubor okna pro LUT s nhledem

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef LUTUnitH
#define LUTUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
#include "..\Headers\bmp_handler.h"
#include "..\Headers\geometric_image.h"
#include "..\Headers\image_grey.h"
#include "..\Headers\point_image.h"
#include <ComCtrls.hpp>
//---------------------------------------------------------------------------
class TLUTForm : public TForm
{
__published:	// IDE-managed Components
        TPanel *Panel1;
        TPanel *Panel2;
        TImage *Image1;
        TPanel *Panel3;
        TImage *Image2;
        TBitBtn *OKBitBtn;
        TBitBtn *CamcelBitBtn;
        TBitBtn *LUTBitBtn;
        TBevel *Bevel1;
        TStatusBar *StatusBar1;
        void __fastcall OKBitBtnClick(TObject *Sender);
        void __fastcall LUTBitBtnClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
private:	// User declarations
        BMPHandler* lut_handler, *sized_handler;
        GeometricImage* sized_image;
        PointImage* lut_image;
        PointImage* original_image;
        LUT* original_lut;
public:		// User declarations
        __fastcall TLUTForm(TComponent* Owner);
        __fastcall ~TLUTForm();
        BMPHandler* __fastcall GetBMPHandler() { return lut_handler; }
        void        __fastcall SetBMPHandler(GreyImage* init);
        PointImage* __fastcall GetLUTImage() { return lut_image; }
        void        __fastcall SetLut(LUT* lut) { *original_lut = *lut; }
};
//---------------------------------------------------------------------------
extern PACKAGE TLUTForm *LUTForm;
//---------------------------------------------------------------------------
#endif
