/*
   FrameUnit.h

   hlavikov soubor okna provdjcho aritmetick a logick operace

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef FrameUnitH
#define FrameUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include <Buttons.hpp>
#include <Dialogs.hpp>
#include "..\Headers\frame_image.h"
#include "..\Headers\bmp_handler.h"
#include "..\Headers\image_grey.h"
#include "..\Headers\scale.h"
#include <ComCtrls.hpp>
//---------------------------------------------------------------------------
class TFrameForm : public TForm
{
__published:	// IDE-managed Components
        TPanel *Panel1;
        TBitBtn *OKBitBtn;
        TBitBtn *CancelBitBtn;
        TPanel *Panel2;
        TPanel *Panel3;
        TPanel *Panel4;
        TImage *Image1;
        TImage *Image2;
        TImage *Image3;
        TOpenDialog *OpenDialog;
        TPanel *Panel5;
        TEdit *PercentEdit;
        TUpDown *PercentUpDown;
        TLabel *Label1;
        TStatusBar *StatusBar;
        TButton *Button1;
        TButton *Button2;
        TPanel *Panel6;
        TRadioButton *RadioButton2;
        TRadioButton *RadioButton1;
        TGroupBox *GroupBox1;
        TGroupBox *GroupBox2;
        TLabel *Label3;
        TComboBox *ComboBox1;
        TLabel *Label2;
        TComboBox *ComboBox2;
        TLabel *Label4;
        TComboBox *ComboBox3;
        TLabel *Label5;
        TEdit *ConstantEdit;
        TPanel *Panel7;
        TRadioButton *RadioButton4;
        TRadioButton *RadioButton5;
        TRadioButton *RadioButton3;
        TLabel *Label6;
        TUpDown *ConstantUpDown;
        TPanel *Panel8;
        TPanel *Panel10;
        TEdit *MinValueEdit;
        TLabel *Label8;
        TUpDown *MinUpDown;
        TEdit *MaxValueEdit;
        TUpDown *MaxUpDown;
        TLabel *Label7;
        TPanel *Panel11;
        void __fastcall ComboBox2Change(TObject *Sender);
        void __fastcall OKBitBtnClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall PercentEditChange(TObject *Sender);
        void __fastcall PercentUpDownClick(TObject *Sender,
          TUDBtnType Button);
        void __fastcall Button2Click(TObject *Sender);
        void __fastcall RadioButton2Click(TObject *Sender);
        void __fastcall ComboBox1Change(TObject *Sender);
        void __fastcall ComboBox3Change(TObject *Sender);
        void __fastcall ConstantEditChange(TObject *Sender);
        void __fastcall RadioButton3Click(TObject *Sender);
        void __fastcall RadioButton4Click(TObject *Sender);
        void __fastcall RadioButton5Click(TObject *Sender);
        void __fastcall ConstantUpDownClick(TObject *Sender, TUDBtnType Button);
        void __fastcall MinValueEditChange(TObject *Sender);
        void __fastcall MinUpDownClick(TObject *Sender, TUDBtnType Button);
        void __fastcall MaxUpDownClick(TObject *Sender, TUDBtnType Button);
        void __fastcall MaxValueEditChange(TObject *Sender);
private:	// User declarations
        Graphics::TBitmap* Bm2;
        BMPHandler* frame1_handler;
        BMPHandler* frame2_handler;
        BMPHandler* frame3_handler;
        GreyImage* sized1_image;
        GreyImage* sized2_image;
        GreyImage* original1_image;
        GreyImage* original2_image;
        GreyImage* frame_image;
        GreyImage* PicOut;
        FrameImage* frame;
        AnsiString file_name1, file_name2;

        // artificial variables
        GreyImage* image;
        BMPHandler* frame_handler;
        AnsiString file_name;

        void PerformFrameProcess(BitFunction combine_type, short scale);
        void WeightImages(int percent);
        void ClearCanvas(TCanvas* canvas);
        BitFunction combine_type;
        int percent, constant, method, min_range, max_range;
        short scale;

public:		// User declarations
        __fastcall TFrameForm(TComponent* Owner);
        __fastcall ~TFrameForm();
};
//---------------------------------------------------------------------------
extern PACKAGE TFrameForm *FrameForm;
//---------------------------------------------------------------------------
#endif
