/*
   bmp.h

   hlavikov soubor tdy pro Vstup/vstup formt BMP.

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef bmpH
#define bmpH
//---------------------------------------------------------------------------
#include "bmp_handler.h"
#include "bmp_handler_color.h"
#include "in_out.h"

class VBitmap : public VInOut
{
private:
   BMPHandler* handler;
   BMPHandlerColor* color_handler;
public:
   __fastcall VBitmap(AnsiString _file_path);
   // for color images
   __fastcall VBitmap(AnsiString _file_path, bool color_img);
   __fastcall VBitmap(BMPHandler* _handler);
   __fastcall VBitmap(BMPHandlerColor* _color_handler);
   __fastcall ~VBitmap();
   // member functions
   void         __fastcall CheckValidity(int type_image);
   virtual void __fastcall ConvertToBMP(BMPHandler* _handler);
   virtual void __fastcall ConvertToColorBMP(BMPHandlerColor* _color_handler);
   void         __fastcall Assign(GreyImage& _image);
   //virtual functions
   void         __fastcall Assign(BMPHandler* _handler);
   void         __fastcall ColorAssign(BMPHandlerColor* _color_handler);
   virtual void __fastcall SaveToFile(AnsiString _save_file_name);
}; // class VBitmap

#endif
