/*
   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef dft_optionsH
#define dft_optionsH
//---------------------------------------------------------------------------
enum ComplexPart {magnitude, realpart, imaginary, phase};
enum FFTrans { forward, inverse, forward_inverse};
enum InverseKind { normal, const_phase, const_amplitude };
//---------------------------------------------------------------------------
class DFTOptions
{
public:
   bool InverseFFT;
   bool LowPassFilter;
   int LowPassKoef_X;
   int LowPassKoef_Y;
   bool HeightPassFilter;
   int HeightPassKoef_X;
   int HeightPassKoef_Y;
   bool ViewValues;
   ComplexPart ViewAs;
   int Scale;
   FFTrans Fft_trans;
   InverseKind Inverse_kind;
public:
   // constructor
   DFTOptions()
    :InverseFFT(false), LowPassFilter(false),
     LowPassKoef_X(0), LowPassKoef_Y(0),
     HeightPassFilter(false),HeightPassKoef_X(0),
     HeightPassKoef_Y(0),ViewValues(true),
     ViewAs(magnitude), Fft_trans(forward),Scale(1000),
     Inverse_kind(normal){}
   // overloaded operator of assignment
   DFTOptions& operator=(DFTOptions& init){
      if(this!=&init){
         InverseFFT = init.InverseFFT;
         LowPassFilter = init.LowPassFilter;
         LowPassKoef_X = init.LowPassKoef_X;
         LowPassKoef_Y = init.LowPassKoef_Y;
         HeightPassFilter = init.HeightPassFilter;
         HeightPassKoef_X = init.HeightPassKoef_X;
         HeightPassKoef_Y = init.HeightPassKoef_Y;
         ViewValues = init.ViewValues;
         ViewAs = init.ViewAs;
         Fft_trans = init.Fft_trans;
         Scale = init.Scale;
         Inverse_kind = init.Inverse_kind;
      }
      return *this;
   }
}; // class DFTOptions
//---------------------------------------------------------------------------
#endif
