/*
   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "dft_vector.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
namespace dft{
//---------------------------------------------------------------------------
vector::vector()
  :l(0), data(NULL)
{
}
//---------------------------------------------------------------------------
vector::vector(int _l)
  :l(_l)
{
   data = new int[l];
}
//---------------------------------------------------------------------------
vector::~vector()
{
   delete [] data;
}
//---------------------------------------------------------------------------
int&
vector::operator[](int index)
{
   // testing for proper index
   if(!(index>=0)&&(index<l))
      throw EDFTVectorRange("Out of Range");
   return data[index];
}
//---------------------------------------------------------------------------
vector&
vector::operator=(const vector& init)
{
   if(this!=&init){
      delete [] data;
      resize(init.length());
      for(int i(0); i< l; i++)
         data[i] = init.data[i];
   }
   return *this;
}
//---------------------------------------------------------------------------
vector&
vector::resize(int new_length)
{
   vector temp(length());
   for(int i(0); i< length(); i++)
      temp[i] = data[i];
   delete [] data;
   data = new int[new_length];
   for(int i(0); i< length(); i++)
      data[i] = temp[i];
   l = new_length;
   return *this;
}      

//---------------------------------------------------------------------------
} // namespace dft