//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "lut.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

// constructors
//---------------------------------------------------------------------------
// default constructor
LUT::LUT()
:max_quant_level(256)
{
   lut = new int[256];
   /*
      initialization the Look Up Table for stright through mapping
      If a point transform is performed on an initialized LUT, output
      data will equal input data;
   */
   for(register int index(0); index< max_quant_level; index++)
      lut[index] = index;
}

//---------------------------------------------------------------------------
// destructor
LUT::~LUT()
{
   delete [](lut);
}

//---------------------------------------------------------------------------
// copy constructor
LUT::LUT(const LUT& right)
{
   max_quant_level = right.max_quant_level;
   lut = new int[max_quant_level];
   for(register int index(0); index< max_quant_level; index++)
      lut[index] = right.lut[index];
}

// overloaded operators
//---------------------------------------------------------------------------
LUT&
LUT::operator = (const LUT& right)
{
   if(max_quant_level != right.max_quant_level)
      max_quant_level = right.max_quant_level;
   for(register int index(0); index< max_quant_level; index++)
      lut[index] = right.lut[index];
   return *this;
}


//---------------------------------------------------------------------------
void
LUT::SetLutEqual()
{
   for(register int index(0); index< max_quant_level; index++)
      lut[index] = index;
}

//---------------------------------------------------------------------------
void
LUT::SetLut_0()
{
   for(register int index(0); index< max_quant_level; index++)
      lut[index] = 0;
}

//---------------------------------------------------------------------------
void
LUT::SetLut_255()
{
   for(register int index(0); index< max_quant_level; index++)
      lut[index] = 255;
}
//--------------------------------------------------------------------------
int LUT::GetInt(int value)
{
   return lut[value];
}
