//---------------------------------------------------------------------------
#ifndef lutH
#define lutH
//---------------------------------------------------------------------------
// If the point process transformation depends only upon the original pixel
// value, the transformation process can be performed with th ehelp of a
// look-up table(LUT).

class LUT
{
private:
   int* lut;
   int max_quant_level;
public:
   // constructors + init
   LUT();
   LUT(int _mql) {} // for this moment empty
   ~LUT();
   // copy constructor
   LUT(const LUT& right);
   // member functions
   void SetLutEqual();
   void SetLut_0();
   void SetLut_255();
   // overloaded operators
   // non-const object
   int& operator [] (int index){
      if((index>=0)&&(index<max_quant_level))
         return lut[index];
      return lut[0];
   }
   // const object
   const int& operator [] (int index) const {
      if((index>=0)&&(index<max_quant_level))
         return lut[index];
      return lut[0];
   }
   LUT& operator = (const LUT& right);
   int GetInt(int value);
}; // class LUT



#endif
