//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "lut_free.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

// constructor - sets the left-down and right-top points
//---------------------------------------------------------------------------
LUTFree::LUTFree(TImage* _Image, TPanel* _Panel)
      : LUTBase(_Image, _Panel)
{
    LD.X() = LeftTop.X();
    LD.Y() = RightDown.Y();
    RT.Y() = LeftTop.Y();
    RT.X() = RightDown.X();
    Down() = false;
}

//---------------------------------------------------------------------------
// virtual function - just calls the DrawLine() function
void
LUTFree::DrawChart()
{
   DrawLine(LD,RT);
}

//---------------------------------------------------------------------------
// until the left button of the mose is pressed (i.e. down is equal to true)
// this function only changes the Cursor of the mouse. If the left button is
// pressed OnMouseMove() clears the old line and redraws the new one.
void
LUTFree::OnMouseMove(int X, int Y)
{
   if(Down()==false){
   }
   else{
     current.X() = X;
     current.Y() = Y;
     ClearRect(current, past);
   }
}

//---------------------------------------------------------------------------
void
LUTFree::OnMouseDown(TMouseButton Button, int X, int Y)
{
   if(Button == mbLeft){
         Down() = true;
         if(X < LeftTop.X()+1)
              X = LeftTop.X()+1;
         if(X > RightDown.X())
              X = RightDown.X();
         if(Y < LeftTop.Y())
              Y = LeftTop.Y();
         if(Y > RightDown.Y())
              Y = RightDown.Y();
         MoveTo(X,Y);
         past.X() = X;
         past.Y() = Y;
   }
}

//---------------------------------------------------------------------------
void
LUTFree::OnMouseUp(TMouseButton Button, int X, int Y)
{
   if(Down()){
      Down() = false;
      Cursor() = crDefault;
   }
}


void
LUTFree::ClearRect(VPoint& current, VPoint& past, TColor color)
{
   if(current.X() < LeftTop.X()+1)
      current.X() = LeftTop.X()+1;
   if(current.X() > RightDown.X())
      current.X() = RightDown.X();
   if(current.Y() < LeftTop.Y())
      current.Y() = LeftTop.Y();
   if(current.Y() > RightDown.Y())
      current.Y() = RightDown.Y();

   TRect rect;
   rect.Left = past.X();
   rect.Top = 3;
   rect.Right = current.X();
   rect.Bottom = RightDown.Y()+differ-3;

   TColor pc =  Canvas->Pen->Color;
   Canvas->Pen->Color = color ;
   Canvas->Brush->Color = clWhite;
   Canvas->FillRect(rect);
   DrawWeb();
   Canvas->Pen->Width = 2;
   Canvas->MoveTo(past.X(), past.Y());
   Canvas->LineTo(current.X(), current.Y());
   Canvas->Pen->Color = pc;
   if(current.X()>past.X())
      for(int i(past.X()-LeftTop.X()); i<(current.X()-LeftTop.X()); i++){
         Lut(i) = RightDown.Y()-past.Y()+(double)(i-past.X()+LeftTop.X())*
              (double)(past.Y()-current.Y())/(double)(current.X()-past.X()) ;
   }
   else
      for(int i(current.X()-LeftTop.X()); i<(past.X()-LeftTop.X()); i++)
         Lut(i) = RightDown.Y()-past.Y()-(double)(i-current.X()+LeftTop.X())*
              (double)(past.Y()-current.Y())/(double)(current.X()-past.X()) ;
   past = current;
}


