//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "lut_ln.h"
#include <math.h>

//---------------------------------------------------------------------------
#pragma package(smart_init)

// constructor - sets the left-down and right-top points
//---------------------------------------------------------------------------
LUTLn::LUTLn(TImage* _Image, TPanel* _Panel)
      : LUTBase(_Image, _Panel)
{
    LD.X() = LeftTop.X();
    LD.Y() = RightDown.Y();
    RT.X() = RightDown.X();
    RT.Y() = LeftTop.Y();
    Down() = false;
    q = -40;
    for(int i(0); i<256; i++){
        Lut(i) = (int)((double)255*(exp((double)i/(double)q)-(double) 1)/(exp((double)255/(double)q)-(double)1));
    }
}

//---------------------------------------------------------------------------
// virtual function - just calls the DrawLine() function
void
LUTLn::DrawChart()
{
   int width = RightDown.X() - LeftTop.X();
   int height = - LeftTop.Y() + RightDown.Y();
   int y;
   VPoint old = LD;
   for(int x(0); x<width; x++){
      y = (double)height*(exp((double)x/(double)q)-(double) 1)/(exp((double)width/(double)q)-(double)1);
      DrawLine(old, VPoint(LD.X()+x,LD.Y()-y), clWhite, 2, pmBlack, psSolid);
      old = VPoint(LD.X()+x,LD.Y()-y);
   }
}
