//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "lut_bit_fields.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
// constructor - sets the left-down and right-top points
//---------------------------------------------------------------------------
LUTBitField::LUTBitField(TImage* _Image, TPanel* _Panel,  int _number)
      : LUTBase(_Image, _Panel), number(_number)
{
   switch(number){
      case(0):
         points = new VPoint*[2];
         points[0] = new VPoint();
         points[1] = new VPoint();
         points[0]->X() = LeftTop.X();
         points[0]->Y() = RightDown.Y();
         points[1]->X() = RightDown.X();
         points[1]->Y() = LeftTop.Y();
         for(int i(0); i<256; i++)
            Lut(i) = i;
         break;
      case(1):
         points = new VPoint*[4];
         for(int i(0); i<4; i++)
            points[i] = new VPoint();
         points[0]->X() = LeftTop.X();
         points[0]->Y() = RightDown.Y();
         points[1]->X() = LeftTop.X()+lwidth/2;
         points[1]->Y() = LeftTop.Y();
         points[2]->X() = LeftTop.X()+lwidth/2;
         points[2]->Y() = RightDown.Y();
         points[3]->X() = RightDown.X();
         points[3]->Y() = LeftTop.Y();
         for(int i(0); i<256; i++)
            Lut(i) = (2*i)%256;
         break;
      case(2):
         points = new VPoint*[8];
         for(int i(0); i<8; i++)
            points[i] = new VPoint();
         points[0]->X() = LeftTop.X();
         points[0]->Y() = RightDown.Y();
         points[1]->X() = LeftTop.X() + lwidth/4;
         points[1]->Y() = LeftTop.Y();
         points[2]->X() = LeftTop.X() + lwidth/4;
         points[2]->Y() = RightDown.Y();
         points[3]->X() = LeftTop.X() + lwidth/2;
         points[3]->Y() = LeftTop.Y();
         points[4]->X() = LeftTop.X() + lwidth/2;
         points[4]->Y() = RightDown.Y();
         points[5]->X() = LeftTop.X() + 3*lwidth/4;
         points[5]->Y() = LeftTop.Y();
         points[6]->X() = LeftTop.X() + 3*lwidth/4;
         points[6]->Y() = RightDown.Y();
         points[7]->X() = RightDown.X();
         points[7]->Y() = LeftTop.Y();
         for(int i(0); i<256; i++)
            Lut(i) = (4*i)%256;
         break;
      case(3):
         points = new VPoint*[16];
         for(int i(0); i<16; i++)
            points[i] = new VPoint();
         points[0]->X() = LeftTop.X();
         points[0]->Y() = RightDown.Y();
         points[1]->X() = LeftTop.X()+lwidth/8;
         points[1]->Y() = LeftTop.Y();
         points[2]->X() = LeftTop.X()+lwidth/8;
         points[2]->Y() = RightDown.Y();
         points[3]->X() = LeftTop.X()+lwidth/4;
         points[3]->Y() = LeftTop.Y();
         points[4]->X() = LeftTop.X()+lwidth/4;
         points[4]->Y() = RightDown.Y();
         points[5]->X() = LeftTop.X()+3*lwidth/8;
         points[5]->Y() = LeftTop.Y();
         points[6]->X() = LeftTop.X()+3*lwidth/8;
         points[6]->Y() = RightDown.Y();
         points[7]->X() = LeftTop.X()+4*lwidth/8;
         points[7]->Y() = LeftTop.Y();
         points[8]->X() = LeftTop.X()+4*lwidth/8;
         points[8]->Y() = RightDown.Y();
         points[9]->X() = LeftTop.X()+5*lwidth/8;
         points[9]->Y() = LeftTop.Y();
         points[10]->X() = LeftTop.X()+5*lwidth/8;
         points[10]->Y() = RightDown.Y();
         points[11]->X() = LeftTop.X()+6*lwidth/8;
         points[11]->Y() = LeftTop.Y();
         points[12]->X() = LeftTop.X()+6*lwidth/8;
         points[12]->Y() = RightDown.Y();
         points[13]->X() = LeftTop.X()+7*lwidth/8;
         points[13]->Y() = LeftTop.Y();
         points[14]->X() = LeftTop.X()+7*lwidth/8;
         points[14]->Y() = RightDown.Y();
         points[15]->X() = LeftTop.X()+8*lwidth/8;
         points[15]->Y() = LeftTop.Y();
         for(int i(0); i<256; i++)
            Lut(i) = (8*i)%256;
         break;
   }
}

//---------------------------------------------------------------------------
// virtual function - just calls the DrawLine() function
void
LUTBitField::DrawChart()
{
   switch(number){
      case(0):
         DrawLine(*points[0], *points[1]);
         break;
      case(1):
         DrawLine(*points[0], *points[1]);
         DrawLine(*points[1], *points[2]);
         DrawLine(*points[2], *points[3]);
         DrawRect(*points[1],clBlack,2);
         DrawRect(*points[2],clBlack,2);
         break;
      case(2):
         DrawLine(*points[0], *points[1]);
         DrawLine(*points[1], *points[2]);
         DrawLine(*points[2], *points[3]);
         DrawLine(*points[3], *points[4]);
         DrawLine(*points[4], *points[5]);
         DrawLine(*points[5], *points[6]);
         DrawLine(*points[6], *points[7]);
         DrawRect(*points[1],clBlack,2);
         DrawRect(*points[2],clBlack,2);
         DrawRect(*points[3],clBlack,2);
         DrawRect(*points[4],clBlack,2);
         DrawRect(*points[5],clBlack,2);
         DrawRect(*points[6],clBlack,2);

         break;
      case(3):
         DrawLine(*points[0], *points[1]);
         DrawLine(*points[1], *points[2]);
         DrawLine(*points[2], *points[3]);
         DrawLine(*points[3], *points[4]);
         DrawLine(*points[4], *points[5]);
         DrawLine(*points[5], *points[6]);
         DrawLine(*points[6], *points[7]);
         DrawLine(*points[7], *points[8]);
         DrawLine(*points[8], *points[9]);
         DrawLine(*points[9], *points[10]);
         DrawLine(*points[10], *points[11]);
         DrawLine(*points[11], *points[12]);
         DrawLine(*points[12], *points[13]);
         DrawLine(*points[13], *points[14]);
         DrawLine(*points[14], *points[15]);
         DrawRect(*points[1],clBlack,2);
         DrawRect(*points[2],clBlack,2);
         DrawRect(*points[3],clBlack,2);
         DrawRect(*points[4],clBlack,2);
         DrawRect(*points[5],clBlack,2);
         DrawRect(*points[6],clBlack,2);
         DrawRect(*points[7],clBlack,2);
         DrawRect(*points[8],clBlack,2);
         DrawRect(*points[9],clBlack,2);
         DrawRect(*points[10],clBlack,2);
         DrawRect(*points[11],clBlack,2);
         DrawRect(*points[12],clBlack,2);
         DrawRect(*points[13],clBlack,2);
         break;
   }
}

//---------------------------------------------------------------------------
LUTBitField::~LUTBitField()
{
   delete [] points;
}

//---------------------------------------------------------------------------
void
LUTBitField::DrawLine(VPoint& start, VPoint& end, TColor color, int size)
{
   TPenMode  pm = Canvas -> Pen -> Mode;
   TColor pc =  Canvas->Pen->Color;
   int psize = Canvas->Pen->Width;

   Canvas->Pen->Color = color ;
   Canvas->Pen->Width = 2;
//   Canvas->Pen->Mode = pmXor;
   Canvas->MoveTo(start.X(), start.Y());
   Canvas->LineTo(end.X(), end.Y());
   Canvas->Pen->Color = pc;
   Canvas->Pen->Width = psize;
   Canvas->Pen->Mode = pm;
}
