//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "lut_contrast.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

// constructor - sets the left-down and right-top points
//---------------------------------------------------------------------------
LUTContrast::LUTContrast(TImage* _Image, TPanel* _Panel)
      : LUTBase(_Image, Panel)
{
    LD.X() = LeftTop.X();
    LD.Y() = RightDown.Y();
    RT.X() = RightDown.X();
    RT.Y() = LeftTop.Y();
    Down() = false;

}

//---------------------------------------------------------------------------
// virtual function - just calls the DrawLine() function
void
LUTContrast::DrawChart()
{
   DrawLine(LD,RT);
   DrawLine(VPoint(RightDown.X(),LeftTop.Y()),RT);
   DrawRect(RT,clBlack,2);
}

//---------------------------------------------------------------------------
// until the left button of the mose is pressed (i.e. down is equal to true)
// this function only changes the Cursor of the mouse. If the left button is
// pressed OnMouseMove() clears the old line and redraws the new one.
void
LUTContrast::OnMouseMove(int X, int Y)
{
   if(Down()==false){
      if(IsOnLine(LD, RT, X, Y, 3) == true)
         Cursor() = crCross;
      else
         Cursor() = crDefault;
   }
   else{
      Cursor() = crCross;
      DrawLine(LD,RT);
      DrawLine(VPoint(RightDown.X(),LeftTop.Y()),RT);
      DrawRect(RT,clWhite,2);
      SetNewPoints(X, Y, LD, RT);
      DrawWeb();
      DrawLine(LD,RT);
      DrawLine(VPoint(RightDown.X(),LeftTop.Y()),RT);
      DrawRect(RT,clBlack,2);

   }
}

//---------------------------------------------------------------------------
void
LUTContrast::OnMouseDown(TMouseButton Button, int X, int Y)
{
   if(Button == mbLeft){
      if(IsOnLine(LD, RT, X, Y, 4) == true)
         Down() = true;
   }
}

//---------------------------------------------------------------------------
void
LUTContrast::OnMouseUp(TMouseButton Button, int X, int Y)
{
   if(Down()){
      Down() = false;
      Cursor() = crDefault;
   }
}
//---------------------------------------------------------------------------
// This function checks if the cursor isn't out of border!
// This function is renewing the LUT as well.
void
LUTContrast::SetNewPoints(int X, int Y, VPoint& LD, VPoint& RT)
{
   int X_Y = X+Y-2*LeftTop.X();
   int _X = X - LeftTop.X();
   int _Y = Y - LeftTop.X();
   if(X_Y < lwidth){
      RT.Y() = LeftTop.Y();
      if (X_Y == lwidth){
         RT.X() = 260;
         lut->SetLutEqual();
      }
      else{
         RT.X() = lheight*(_X)/(lheight-_Y) + LeftTop.X();
         for(register int index(0); index< 256; index++){
            if(index < (RT.X() - LeftTop.X())*256/lwidth){
              Lut(index) = index*lheight/(RT.X()-LeftTop.X());//256/(RT.X()-4));
            }
            else Lut(index) = 255;
         }
         if (RT.X() < LeftTop.X()){
            RT.X() = LeftTop.X();
            lut->SetLut_255();
         }
         if((X < LeftTop.X())&&(Y<RightDown.Y())){
            RT.X() = LeftTop.X();
            lut->SetLut_255();
         }
      }
   }
   else{
      RT.X() = RightDown.X();
      RT.Y() = RightDown.Y() - lwidth*(lheight-_Y)/_X;
      for(register int index(0); index< 256; index++){
         Lut(index) = index*(lheight-_Y)/_X;
      }
      if(RT.Y() > RightDown.Y()){
         RT.Y() = RightDown.Y();
         lut->SetLut_0();
      }
      if((Y > RightDown.Y())&&(X > LeftTop.X())){
         RT.Y() = RightDown.Y();
         lut->SetLut_0();
      }
   }
   if((Y > RightDown.Y())&&(X < LeftTop.X())){
      RT.X() = RightDown.X();
      RT.Y() = LeftTop.Y();
      lut->SetLutEqual();
   }

/*   if(X + Y <= 264){
      RT.Y() = 4;
      if (Y == 260){
         RT.X() = 260;
         lut->SetLutEqual();
      }
      else{
         RT.X() = 256*(X-4)/(260-Y) + 4;
         for(register int index(0); index< 256; index++){
            if(index < RT.X() - 4){
              Lut(index) = (index*256/(RT.X()-4));
              int tmp = Lut(index);
            }
            else Lut(index) = 255;
         }
         if (RT.X() < 6){
            RT.X() = 6;
            lut->SetLut_255();
         }
         if((X < 10)&&(Y<260)){
            RT.X() = 6;
            lut->SetLut_255();
         }
      }
   }
   else{
      RT.X() = 260;
      if (X == 4){
         RT.X() = 260;
         RT.Y() = 4;
         lut->SetLutEqual();
      }
      else{
         RT.Y() = 260 - 256*(260-Y)/(X-4);
         for(register int index(0); index< 256; index++){
            Lut(index) = index*(260-RT.Y())/256;
            int tmp = Lut(index);
         }
         if(RT.Y() > 256){
            RT.Y() = 256;
            lut->SetLut_0();
         }
         if((Y > 260)&&(X > 10)){
            RT.Y() = 256;
            lut->SetLut_0();
         }
      }
   }
   if((Y > 260)&&(X < 10)){
      RT.X() = 260;
      RT.Y() = 4;
      lut->SetLutEqual();
   }*/
}




