//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "lut_equal_negative.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
// constructor - sets the left-down and right-top points
//---------------------------------------------------------------------------
LUTEqualNegative::LUTEqualNegative(TImage* _Image, TPanel* _Panel)
      : LUTBase(_Image, _Panel)
{
    L.X() = LeftTop.X();
    L.Y() = RightDown.Y();
    R.X() = RightDown.X();
    R.Y() = RightDown.Y();
    T.X() = LeftTop.X()+lwidth/2;
    T.Y() = LeftTop.Y()+lheight/2;
    Down() = false;
    for(int i(0); i<256; i++){
       if(i<128)
          Lut(i) = i;
       else
          Lut(i) = 255-i;
    }
}

//---------------------------------------------------------------------------
// virtual function - just calls the DrawLine() function
void
LUTEqualNegative::DrawChart()
{
   DrawLine(L,T);
   DrawLine(T,R);
   DrawRect(T,clBlack,2);
}


