//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "lut_threshold_equal_2.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)


// constructor - sets the left-down and right-top points
//---------------------------------------------------------------------------
LUTThresholdEqual_2::LUTThresholdEqual_2(TImage* _Image, TPanel* _Panel)
      : LUTBase(_Image, _Panel)
{
   LD.X() = LeftTop.X();
   LD.Y() = RightDown.Y();
   RT.X() = RightDown.X();
   RT.Y() = LeftTop.Y();
   M.X() = LeftTop.X() + lwidth/2;
   M.Y() = RightDown.Y()-(M.X()-LeftTop.X())*lheight/lwidth;
   MT.X() = M.X();
   MT.Y() = LeftTop.Y();
   MD.X() = M.X();
   MD.Y() = RightDown.Y();
   Down() = false;
}

//---------------------------------------------------------------------------
// virtual function - just calls the DrawLine() function
void
LUTThresholdEqual_2::DrawChart()
{
   DrawWeb();
   DrawLine(LD,M);
   DrawLine(M,MT);
   DrawLine(MT,RT);
   DrawLine(MD,M,clBlack,1,pmCopy,psDot);
   DrawRect(M,clBlack,2);
   DrawRect(MT,clBlack,2);
}

//---------------------------------------------------------------------------
// until the left button of the mose is pressed (i.e. down is equal to true)
// this function only changes the Cursor of the mouse. If the left button is
// pressed OnMouseMove() clears the old line and redraws the new one.
void
LUTThresholdEqual_2::OnMouseMove(int X, int Y)
{
   if(Down()==false){
      Cursor() = crDefault;
      if(IsOnLine(MD, MT, X, Y, 3) == true)
         Cursor() = crSizeWE;
   }
   else{
      DrawLine(LD,M);
      DrawLine(M,MT);
      DrawLine(MT,RT);
      DrawLine(MD,M,clWhite,1,pmCopy);
      DrawRect(M,clWhite,2);
      DrawRect(MT,clWhite,2);
      // set new positions
      SetNewPoints(X, Y);
      DrawWeb();
      DrawLine(LD,M);
      DrawLine(M,MT);
      DrawLine(MT,RT);
      DrawLine(MD,M,clWhite,1,pmCopy,psDot);
      DrawRect(M,clBlack,2);
      DrawRect(MT,clBlack,2);
   }
}

//---------------------------------------------------------------------------
void
LUTThresholdEqual_2::OnMouseDown(TMouseButton Button, int X, int Y)
{
   if(Button == mbLeft){
      if(IsOnLine(MD, MT, X, Y, 3) == true){
         Cursor() = crSizeWE;
         Down() = true;
      }
   }
}

//---------------------------------------------------------------------------
void
LUTThresholdEqual_2::OnMouseUp(TMouseButton Button, int X, int Y)
{
   if(Down()){
      Down() = false;
      Cursor() = crDefault;
   }
}
//---------------------------------------------------------------------------
// This function checks if the cursor isn't out of border!
// This function is renewing the LUT as well.
void
LUTThresholdEqual_2::SetNewPoints(int X, int Y)
{
   M.X() = X;
   M.Y() = RightDown.Y()-(M.X()-LeftTop.X())*lheight/lwidth;
   KeepInBorder(M);
   MT.X() = MD.X() = M.X();

   for(register int index(0); index<256; index++){
      if(index< M.X() - LeftTop.X())
         Lut(index) = index*lwidth/lheight;
      else
         Lut(index)=255;
   }
}   
