/*
   NOISE.h

   hlavikov soubor tdy Noise

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef noiseH
#define noiseH
//---------------------------------------------------------------------------
#include <stdlib.h> // rand()
#include "image_grey.h"

class Noise
{
private:
   const GreyImage* original_image;
   GreyImage* noise_image;
public:
   // constructors
   Noise();
   Noise(const GreyImage& _original_image,
                  GreyImage& _noise_image);
   ~Noise() {}
   // member functions
   void SaltAndPepper(int col, int row, int width, int height,
                      double probability);
   void GaussianNoise(int col, int row, int width, int height,
                      double var, double mean);
   void GammaNoise(int col, int row, int width, int height,
                      double var, int alpha);
   void NegativeExponentialNoise(int col, int row, int width, int height,
                      double var);
   void RayleighNoise(int col, int row, int width, int height,
                      double var);
   void UniformNoise(int col, int row, int width, int height,
                      double var, double mean);
}; // class Noise
#endif
