/*
   num_part.cpp

   definin soubor tdy pro pevod mezi hexa a dec

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "num_part.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

// constructors
//---------------------------------------------------------------------------
// for partition of int into two partitions
NumPart::NumPart(int _int_num)
:int_num(_int_num)
{
   if(int_num<=255){
      part_l  = (unsigned char)int_num;
      part_h  = 0;
      part_hh = 0;
   }

   if((255 <int_num)&&(int_num <= 65535)) {
      temp    = (unsigned char)(int_num/256);
      part_h  = (unsigned char)(int_num/256);
      part_l  = (unsigned char)(int_num-temp*256);
      part_hh = 0;
   }
}

//---------------------------------------------------------------------------
// for partition of double into three partitions
NumPart::NumPart(double _double_num)
:double_num(_double_num)
{
   if(double_num<=255){
      part_l  = (unsigned char)double_num;
      part_h  = 0;
      part_hh = 0;
   }

   if((255< double_num)&&(double_num <=65535)) {
      temp    = (unsigned char)(double_num/256);
      part_h  = (unsigned char)(double_num/256);
      part_l  = (unsigned char)(double_num-temp*256);
      part_hh = 0;
   }

   if(0xffff<double_num<0xffffff) {
      temp    = (int)(double_num/256);
      part_l  = (unsigned char)(double_num-temp*256);
      part_hh = (unsigned char)(temp/256);
      part_h  = (unsigned char)(temp-part_hh*256);
   }
}
