/*
   SCALE.h

   hlavikov soubor pro zmnu velikosti edotnovho obrazu

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef scaleH
#define scaleH
//---------------------------------------------------------------------------
#include "image_grey.h"

class Scale
{
private:
   const GreyImage* original_image;
   GreyImage* scaled_image;
public:
   // constructors
   Scale();
   Scale(const GreyImage& _original_image, GreyImage& _scaled_image);
   // constructor for a new image with new size - reduces a useless calling
   // of function Resize
   Scale(const GreyImage& _original_image, GreyImage& _scaled_image,
         int new_size);
   ~Scale(){}
   // member function
   void PerformScale(int s_col, int s_row, int s_width, int s_height,
                     double scale_h, double scale_v, int d_col, int d_row,
                     bool interpolate);
   void ChangeSize(int s_col, int s_row, int s_width, int s_height,
             int d_col, int d_row, int d_width, int d_height,
             bool interpolate);
   void NewSize(int _new_cols, int _new_rows, bool interpolate);          
}; // class Scale
#endif
