/*
   Vexcept.h

   hlavikov soubor pro definovn vyjmek

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef vexceptH
#define vexceptH
//---------------------------------------------------------------------------
class VEMemory
   {
   public:
      AnsiString msg;
      int alloc;
      VEMemory(const AnsiString& _msg, int _alloc = 0)
         : msg(_msg), alloc(_alloc) {}
}; // class Memory

class VESize
   {
   public:
      AnsiString msg;
      int size;
      VESize(const AnsiString& _msg, int _size = 0)
         : msg(_msg), size(_size) {}
}; // class Size

class VERange
   {
   public:
      AnsiString msg;
      VERange(const AnsiString& _msg)
         : msg(_msg) {}
}; // class Rage

class VEMsg
   {
   public:
      AnsiString msg;
      VEMsg(const AnsiString& _msg)
         : msg(_msg) {}
}; // class VMsg

class VECorruptedFile
   {
   public:
      AnsiString msg;
      AnsiString kind;
      VECorruptedFile(const AnsiString& _msg, const AnsiString& _kind)
         : msg(_msg), kind(_kind) {}
}; // class VECorruptedFile

//---------------------------------------------------------------------------
// new class EDFTTooLargeImage
class EDFTTooLargeImage : public Exception
{
public:
   __fastcall  EDFTTooLargeImage(const AnsiString Msg)
      :Exception(Msg){}
};
//---------------------------------------------------------------------------
class EDFTTerminate : public Exception
{
public:
   __fastcall  EDFTTerminate(const AnsiString Msg)
      :Exception(Msg){}
};
//---------------------------------------------------------------------------
class EDFTVectorRange : public Exception
{
public:
   __fastcall  EDFTVectorRange(const AnsiString Msg)
      :Exception(Msg){}
};





//---------------------------------------------------------------------------
#endif
