/*
   vmask.h

   hlavikov soubor tdy konvolun masky

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef vmaskH
#define vmaskH
//---------------------------------------------------------------------------
#include "morpholog_exception.h"
#include "mask_options.h"
// class Mask used for Morphological operations (i.e. in Morph class)

class VMask
{
private:
   int* data;
   int cols, rows;
public:
   // constructors
   VMask();
   VMask(int _c, int _r);
   VMask(MaskOptions init);
   ~VMask();
   // Member functions
   int         Cols()                  {return cols; }
   int         Rows()                  {return rows; }
   int const   Cols()            const {return cols; }
   int const   Rows()            const {return rows; }
   int&        Data(int c,int r)       {return data[c+r*cols];}
   int& const  Data(int c,int r) const {return data[c+r*cols];}
   // shape functions
   void Full(int i=1);
   void Cross(int i=1);
   void Round(int i=1);
   void Vertical(int i=1);
   void Horizontal(int i=1);
   // overloaded opetator
   VMask& operator=(const VMask& init);
};
//---------------------------------------------------------------------------

#endif
