/*
   vpoint.h

   hlavikov soubor tdy pro definici bodu

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef vpointH
#define vpointH
//---------------------------------------------------------------------------


class VPoint
{
private:
   int x,y;
public:
   // constructors
   VPoint()
     : x(0),y(0) {}
   VPoint(int _x,int _y)
     : x(_x),y(_y) {}
   // copy constructor
   VPoint(const VPoint& right)
      { x = right.x; y = right.y; }
   // member functions
         int& Row()       { return y; }
   const int& Row() const { return y; }
         int& Col()       { return x; }
   const int& Col() const { return x; }
         int& X()         { return x; }
   const int& X()   const { return x; }
         int& Y()         { return y; }
   const int& Y()   const { return y; }
   // overloaded operator
   VPoint operator = (const VPoint& right){
       if( this!=&right) {
          x = right.x;
          y = right.y;
       }
       return *this;
   }
   VPoint operator + (const VPoint& right){
       VPoint add(0,0);
       add.x = x + right.x;
       add.y = y + right.y;
       return add;
   }
   VPoint operator - (const VPoint& right) {
       VPoint sub(0,0);
       sub.x = x - right.x;
       sub.y = y - right.y;
       return sub;
   }
};  // class Point


#endif
