/*
   bmp_handler.h

   hlavikov soubor tdy operace s bmp files.

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef bmp_handler_colorH
#define bmp_handler_colorH
//---------------------------------------------------------------------------
#include "image_color.h"
#include "size_bmp_g.h"
// class BMPHandler serves for a basic manipulation of the data stored
// in the Windows DIB - *.bmp files

class BMPHandlerColor
{
private:
   Graphics::TBitmap *bitmap;
   ColorImage* color_image;
   AnsiString file_name;
   TMemoryStream* mstream;
public:
   // constructors
   BMPHandlerColor();
   BMPHandlerColor(const AnsiString _file_name, ColorImage _color_image);
   BMPHandlerColor(const BMPHandlerColor& init);
   ~BMPHandlerColor();
   // member functions
   AnsiString& FileName() { return file_name;}
   int Width()  { return bitmap->Width;  }
   int Height() { return bitmap->Height; }
   int Rows()   { return bitmap->Height; }
   int Cols()   { return bitmap->Width;  }
   // function for saving bitmap on the disc
   void SaveToFile(AnsiString _file_name);
   // assign the ColorImage object with the data from the bitmap
   void Set(ColorImage& _color_image);
   // loads the data from the ColorImage object
   void Assign(ColorImage _color_image);
   void Assign(TMemoryStream* memory_stream);
   // draws the bitmap on the TImage component
   void Show(TImage* Image);
   void CreateBitmapAndAssign(ColorImage* _color_image);
   
}; //class BMPHandlerColor
#endif