/*
   brightness.cpp

   definin soubor tdy operace pro korekci jasu.

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "brightness.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

// constructors + destructor
//---------------------------------------------------------------------------
// default constructor
Brightness::Brightness()
{
   original_image = NULL;
   bright_image   = NULL;
  // bright_lut = NULL;
}

//---------------------------------------------------------------------------
Brightness::Brightness(const GreyImage& _original_image,
                             GreyImage& _bright_image)
{
   original_image = &_original_image;
   bright_image   = &_bright_image;
   if((bright_image->Rows()!=original_image->Rows())||
      (bright_image->Cols()!=original_image->Cols()))
       bright_image->Resize(original_image->Cols(), original_image->Rows());
   //bright_lut = new LUT();
}

//-------------------------------------------------------------------------
// This function applies a transform previosly programmed into LookUpTable
// to the image or portion of image;
void
Brightness::ApplyLUT(LUT& lut, int col, int row, int width, int height)
{
   Assert((col <= original_image->Cols())&&
         ((col+width)<=original_image->Cols())&&
         (row <= original_image->Rows())&&
         ((row+height)<=original_image->Rows()),VEMsg(AnsiString
         ("Brightness::ApplyLUT:the portion goes out of image")));
   for(register int c(col); c<col+width; c++)
      for(register int r(row); r<row+height; r++)
        bright_image->Data(c,r) =
           (unsigned char)lut[original_image->Data(c,r)];
}

//---------------------------------------------------------------------------
void
Brightness::AdjImageBrightness(short brightness_factor, int col, int row,
                               int width, int height)
{
   //LUT bright_lut;
   register int new_value;
   for(register int index(0); index<256; index++)
   {
      new_value = index + brightness_factor;
      new_value = (new_value < 0  ) ? 0   : new_value;
      new_value = (new_value > 255) ? 255 : new_value;
      bright_lut[index] = new_value;
   }
   ApplyLUT(bright_lut, col, row, width, height);
}
