/*
   edge_detector.h

   hlavikov soubor tdy pro edge detection

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef edge_detectorH
#define edge_detectorH
//---------------------------------------------------------------------------
#include "image_grey.h"
#include "convolution.h"
#include "kernel.h"

class EdgeDetector
{
private:
   const GreyImage* original_image;
   GreyImage* edge_det_image;
public:
   // constructors
   EdgeDetector();
   EdgeDetector(const GreyImage& _original_image,
                  GreyImage& _edge_image);
   ~EdgeDetector();
   // member functions
   void SobelEdgeDet_1(int col, int row, int width, int height,
                     int treshold, bool overlay);
   // Real Sobel Filter
   void HorizontalSobel();
   void VerticalSobel();
   void PureMagnitudeSobel();
   void MagnitudeSobel();
   void PhaseSobel();
}; // class EdgeDetector

int max(unsigned value1, unsigned value2);
#endif
