/*
   frame_image.h

   hlavikov soubor tdy pro aritmetick a logick operace

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef frame_imageH
#define frame_imageH
//---------------------------------------------------------------------------
// Frame Processing Functions
#include "image_grey.h"

enum BitFunction
{
   AND, OR, XOR, ADD, SUB, MULT, DIV, MIN, MAX, AVE, OVERLAY,
   InvAND, InvOR, InvXOR, PLUS, MINUS, MULTIP, fDIV
};

//---------------------------------------------------------------------------

class FrameImage
{
private:
   const GreyImage* s_image;
   const GreyImage* d_image;
         GreyImage* r_image;
public:
   // constructors
   __fastcall FrameImage();
   __fastcall FrameImage(const GreyImage& _s_image, const GreyImage& _d_image,
                               GreyImage& _r_image);
   __fastcall ~FrameImage() {}
   // member functions
   void __fastcall ApplicationFunction(int s_col, int s_row,
      int s_width, int s_height, int d_col, int d_row, BitFunction combine_type,
      short scale, int constant, int method_type, int min_level_range,
      int max_level_range, bool proc_type);
   void __fastcall  CombineImages(int s_col, int s_row, int s_width,
                                 int s_height, int d_col, int d_row,
                                 BitFunction combine_type, short scale,
                                 int constant, int method_type, int min_level_range,
                                 int max_level_range);
   void __fastcall  WeightImages(int s_col, int s_row, int s_width,
                                 int s_height, int d_col, int d_row,
                                 int percent_of_s);
   int maxi, mini;
                             
}; //class FrameImage
int max(int value1, int value2);
int min(int value1, int value2);
int fnot(int value1);
#endif
