/*
   freq_mask.h

   hlavikov soubor operac pro definici masky

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef freq_maskH
#define freq_maskH
//---------------------------------------------------------------------------

class FreqMask
{
private:
   TImage* Image;
   bool allow;
   bool down;
   bool rect;
   TPoint P1, P2;
   TPoint PP1, PP2;
   void Draw(TPoint p1, TPoint p2);
   TPoint CountPP(TPoint p1);
public:
   FreqMask();
   FreqMask(TImage* _Image);

   bool& Allow() { return allow;}
   bool& Down()  { return down; }
   bool& Rect()  { return rect; }

   TPoint Point1() { return P1; }
   TPoint Point2() { return P2; }

   void Clear();

   void MouseDown(TMouseButton Button, int X, int Y);
   void MouseUp(TMouseButton Button, int X, int Y);
   void MouseMove(int X, int Y);
};

#endif
