/*
   geometric_image.cpp

   definin soubor tdy pro nkter geometrick operace s obrazem

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "geometric_image.h"
#include <math.h>

//---------------------------------------------------------------------------
#pragma package(smart_init)

// constructors
//---------------------------------------------------------------------------
__fastcall
GeometricImage::GeometricImage(int _cols, int _rows)
:GreyImage(_cols,_rows)
{
}

//---------------------------------------------------------------------------
void
GeometricImage::PerformScale(GreyImage& _scaled_image, int s_col, int s_row,
                     int s_width, int s_height, double scale_h,
                     double scale_v, int d_col, int d_row,
                     bool interpolate)
{
   scale = new Scale(*this, _scaled_image);
   scale -> PerformScale(s_col, s_row, s_width, s_height, scale_h, scale_v,
                       d_col, d_row, interpolate);
   delete scale;
}

//---------------------------------------------------------------------------
void
GeometricImage::ChangeSize(GreyImage& _sized_image, int s_col, int s_row,
                   int s_width, int s_height, int d_col, int d_row,
                   int d_width, int d_height, bool interpolate)
{
   scale = new Scale(*this, _sized_image);
   scale -> ChangeSize(s_col, s_row, s_width, s_height, d_col, d_row, d_width,
                     d_height, interpolate);
   delete scale;
}

//---------------------------------------------------------------------------
void
GeometricImage::PerformRotation(GreyImage& _rotated_image,int col, int row,
                       int width, int height, double angle, bool interpolate)
{
   rotate = new Rotate(*this, _rotated_image);
   rotate -> PerformRotation(col, row, width, height, angle, interpolate, clBlack);
   delete rotate;
}

//---------------------------------------------------------------------------
void
GeometricImage::PerformTranslation(GreyImage& _translated_image, int s_col,
                           int s_row, int s_width, int s_height, int d_col,
                           int d_row, bool erase_flag)
{
   trans = new Translate(*this, _translated_image);
   trans -> PerformTranslation(s_col, s_row, s_width, s_height, d_col, d_row,
                               erase_flag);
   delete trans;
}

//---------------------------------------------------------------------------
void
GeometricImage::MirrorImage(GreyImage& _mirror_image, int s_col, int s_row,
                    int s_width, int s_height, int d_col, int d_row,
                    MirrorType which_mirror)
{
   trans = new Translate(*this, _mirror_image);
   trans -> MirrorImage(s_col, s_row, s_width, s_height, d_col, d_row,
                               which_mirror);
   delete trans;
}
/*void
GeometricImage::SinDistortion(GreyImage& _distorted_image, double omega, int amp)
{
   if((_distorted_image.Rows()!=this->Rows())||
      (_distorted_image.Cols()!=this->Cols()))
       _distorted_image.Resize(this->Cols(), this->Rows());
   int data;
   for(int r(0); r<this->Rows(); r++)
      for(int c(0); c<this->Cols(); c++){
          data = this->Data(c,r) +  amp*sin(omega*c);
          data = (data>255) ? 255 : data;
          data = (data<0)   ? 0   : data;
          _distorted_image.Data(c,r) = (unsigned char)data;
      }
} */


   

