/*
   image_color.h

   hlavikov soubor tdy pro zkladn tdu 8bitovch obraz.

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef image_colorH
#define image_colorH
//---------------------------------------------------------------------------
#include <fstream.h>
#include <algorithm>
#include <numeric>
#include "image.h"
#include "image_grey.h"
#include "image_const.h"
#include "image_float.h"

// basic class for greyscale images

class ColorImage : public Image<unsigned int>
{
private:
public:
   // constructors
   ColorImage()
     :Image<unsigned int>()  {}
   ColorImage(int _cols, int _rows)
     :Image<unsigned int>(_cols,_rows) {}
   // destructors
   virtual ~ColorImage() {}
   int       Rows()       {return rows;}
   int       Cols()       {return cols;}
   unsigned int& Data(int col, int row)
       { return data[col + cols*row];}
   // fce
   void __fastcall SplitToRGB(GreyImage* R_component, GreyImage* G_component,
                   GreyImage* B_component);
   void __fastcall CombineFromRGB(GreyImage* R_component,
                   GreyImage* G_component, GreyImage* B_component);

   void __fastcall GreyScale(int type_conversion, GreyImage* Y);

   void __fastcall HSVtoRGB(FloatImage* H, FloatImage* S, FloatImage* V);
   void __fastcall RGBtoHSV(FloatImage* H, FloatImage* S, FloatImage* V);

   void __fastcall HSLtoRGB(FloatImage* H, FloatImage* S, FloatImage* L);
   void __fastcall RGBtoHSL(FloatImage* H, FloatImage* S, FloatImage* L);
   float Hue_2_RGB(float v1, float v2, float vH); // use function CombineFromHSL

   void __fastcall CMYtoRGB(FloatImage* C, FloatImage* M, FloatImage* Y);
   void __fastcall RGBtoCMY(FloatImage* C, FloatImage* M, FloatImage* Y);

   void __fastcall CMYKtoRGB(FloatImage* C, FloatImage* M, FloatImage* Y, FloatImage* K);
   void __fastcall RGBtoCMYK(FloatImage* C, FloatImage* M, FloatImage* Y, FloatImage* K);
}; // class ColorImage

#endif
