/*
   MATLAB.cpp

   definin soubor pomocn tdy pro obraz

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "matlab.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
__fastcall VMatlab::VMatlab(AnsiString _file_path)
   :VInOut(_file_path)
{
      image = new GreyImage();
      suffix = "mlb";
      CheckSuffix();
      MatlabToGreyImage();
}
//---------------------------------------------------------------------------
// destructor
__fastcall VMatlab::~VMatlab()
{
}
//---------------------------------------------------------------------------
void
__fastcall VMatlab::MatlabToGreyImage()
{
   unsigned long index = 0;
   TFileStream* fstream = new TFileStream(file_path, fmOpenRead);
   unsigned long size = fstream->Size;
   char* buff = new char[size];
   fstream->Read(buff,size);
   delete (fstream);
   int cols = CharToInt(buff, index, size);
   int rows = CharToInt(buff, index, size);
   image->Resize(cols, rows);
   for(register int r(0); r<image->Rows(); r++)
      for(register int c(0); c<image->Cols(); c++){
          image->Data(c,r) =
               (unsigned char)CharToInt(buff, index, size);
      }
   delete [] buff;   
}
//---------------------------------------------------------------------------
void
__fastcall VMatlab::SaveToFile(AnsiString _save_file_name)
{
   short int data;
   ofstream o_file(_save_file_name.c_str(),ios::binary);
   Assert(o_file!=0,VEMsg(AnsiString("Can't open file\n" + _save_file_name)));
   o_file << image->Cols() << " " << image->Rows()<< endl;
   for(register int r(0); r<image->Rows(); r++)
      for(register int c(0); c<image->Cols(); c++){
         data = image->Data(c,r);
         o_file << setw(4) << data;
      }
   o_file.close();
}
//---------------------------------------------------------------------------
inline int
__fastcall VMatlab::CharToInt(char* buff, unsigned long& index,
                   unsigned long size)
{
   while(isdigit(buff[index])==0){
      index++;
      if(index>size)
         return (-1);
   }
   int number=0;
   int i=0;
   while(isdigit(buff[index])){
      index++;
      if(index>size)
         return (-1);
      i++;
   }
   int ind = index, ii=1;
   while(i!=0){
      number += (buff[--ind]-48)*ii;
      ii*=10;
      i--;
   }
   return number;
}
//---------------------------------------------------------------------------
void
__fastcall VMatlab::Assign(BMPHandler* _handler)
{
   _handler->Set(*image);
}
