/*
   morpholog.cpp

   definin soubor zkladn tdy morpholog pro morfologick operace.

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "morpholog.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
Morpholog::Morpholog()
: orig_image(NULL), morph_image(NULL), mask(NULL)
{
}
//---------------------------------------------------------------------------
Morpholog::Morpholog(GreyImage* _orig_image, GreyImage* _morph_image,
                     VMask* _mask)
: orig_image(_orig_image), morph_image(_morph_image), mask(_mask)//,
{
   if((morph_image->Cols()!=orig_image->Cols())||
      (morph_image->Rows()!=orig_image->Rows()))
      morph_image->Resize(orig_image->Cols(), orig_image->Rows());
   for(int c(0); c< morph_image->Cols(); c++)
      for(int r(0); r< morph_image->Rows(); r++)
          morph_image->Data(c,r) = 0;
}
//---------------------------------------------------------------------------
Morpholog::~Morpholog()
{
}
//---------------------------------------------------------------------------
void
Morpholog::NewMask(VMask* init)
{
   mask = init;
}   
