/*
   morpholog.h

   hlavikov soubor zkladn tdy morpholog pro morfologick operace.

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef morphologH
#define morphologH
//---------------------------------------------------------------------------
#include "..\Headers\vmask.h"
#include "morpholog_exception.h"
#include "..\Headers\image_grey.h"
//---------------------------------------------------------------------------
// main class for morphological operations
class   Morpholog
{
protected:
   GreyImage* orig_image;
   GreyImage* morph_image;
   VMask* mask;
public:
   // constructor
   Morpholog();
   Morpholog(GreyImage* _orig_image, GreyImage* _morph_image,
             VMask* mask);
   virtual ~Morpholog();
   void NewMask(VMask* init);
   // member function
   virtual void Dilation()=0;
   virtual void Erosion()=0;
   virtual void Close()=0;
   virtual void Open()=0;
   virtual void Outline(){}
   virtual void ConditionalDilatation(){}
   // only for binary
   virtual void Skeleton(){}
   // only for greylavel
   virtual void TopHat() {}
};



#endif
