/*
   scale_color.h

   hlavikov soubor pro zmnu velikosti barevnho obrazu

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef scale_colorH
#define scale_colorH
//---------------------------------------------------------------------------
#include "image_grey.h"
#include "image_color.h"
#include "scale.h"

class Scale_color
{
private:
   const ColorImage* original_image;
         ColorImage* scaled_image;
public:
   // constructors
   Scale_color();
   Scale_color(const ColorImage& _original_image, ColorImage& _scaled_image);
   // constructor for a new image with new size - reduces a useless calling
   // of function Resize
   Scale_color(const ColorImage& _original_image, ColorImage& _scaled_image,
         int new_size);
   ~Scale_color();
   // variable
   GreyImage* red_image;
   GreyImage* green_image;
   GreyImage* blue_image;

   GreyImage* scaled_red_image;
   GreyImage* scaled_green_image;
   GreyImage* scaled_blue_image;

   short staleR,scaleG,scaleB;
}; // class Scale_color
#endif
