/*
   size_bmp_g.cpp

   definin soubor pomocn tdy pro BMP.

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "size_bmp_g.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)

// Two parametr constructor
SizeBMP_G::SizeBMP_G(int _width, int _height)
:width(_width), height(_height)
{
    NumPart p_height(height);
    height_h = p_height.Part_h();
    height_l = p_height.Part_l();

    NumPart p_width(width);
    width_h = p_width.Part_h();
    width_l = p_width.Part_l();
    int rest;
    if((rest=width%4)!=0){
       size_file=(double)(width+4-rest)*height+1078;
       size_color_file=(double)3*(width+4-rest)*height+54;
       size_bmp=(double)(width+4-rest)*height;
    }
    else{
       size_file=(double)(width)*height+1078;
       size_color_file=(double)3*(width)*height+54;
       size_bmp=(double)(width)*height;
    }
    NumPart p_size_file(size_file);
    size_file_hh = p_size_file.Part_hh();
    size_file_h  = p_size_file.Part_h ();
    size_file_l  = p_size_file.Part_l();

    NumPart p_size_color_file(size_color_file);
    size_color_file_hh = p_size_color_file.Part_hh();
    size_color_file_h  = p_size_color_file.Part_h ();
    size_color_file_l  = p_size_color_file.Part_l();

    NumPart p_size_bmp(size_bmp);
    size_bmp_hh = p_size_bmp.Part_hh();
    size_bmp_h  = p_size_bmp.Part_h ();
    size_bmp_l  = p_size_bmp.Part_l();

}
