/*
   translate.h

   hlavikov soubor - pesun

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef translateH
#define translateH
//---------------------------------------------------------------------------
#include "image_grey.h"

enum MirrorType {HorizMirror, VertMirror};

class Translate
{
private:
   const GreyImage* original_image;
   GreyImage* translated_image;
public:
   // constructors
   Translate();
   Translate(const GreyImage& _original_image, GreyImage& _translated_image);
   ~Translate(){}
   // member function
   void PerformTranslation(int s_col, int s_row, int s_width, int s_height,
                           int d_col, int d_row, bool erase_flag);
   void MirrorImage(int s_col, int s_row, int s_width, int s_height,
                    int d_col, int d_row, MirrorType which_mirror);
}; // class Translate
#endif
