/*
   MORPHMaskUnit.cpp

   definin soubor okna pro zvolen MIPS masky

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "MORPHMaskUnit.h"
#include "MORPHUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMORPHMaskForm *MORPHMaskForm;
//---------------------------------------------------------------------------
__fastcall TMORPHMaskForm::TMORPHMaskForm(TComponent* Owner)
        : TForm(Owner)
{
   Top = MORPHForm->Top +20;
   Left = MORPHForm->Left +20;
   SetVisualComp(MORPHForm->GetMaskOptions());
}
//---------------------------------------------------------------------------
void __fastcall TMORPHMaskForm::SizeRadioGroupClick(TObject *Sender)
{
   switch(SizeRadioGroup->ItemIndex){
      case(0):
         mask_options.Size() = size3x3;
         break;
      case(1):
         mask_options.Size() = size5x5;
         break;
   }
}
//---------------------------------------------------------------------------

void __fastcall TMORPHMaskForm::ShapeRadioGroupClick(TObject *Sender)
{
   switch(ShapeRadioGroup->ItemIndex){
      case(0):
         mask_options.Shape() = full;
         break;
      case(1):
         mask_options.Shape() = round;
         break;
      case(2):
         mask_options.Shape() = cross;
         break;
      case(3):
         mask_options.Shape() = vertical;
         break;
      case(4):
         mask_options.Shape() = horizontal;
         break;
   }
}
//---------------------------------------------------------------------------
void __fastcall TMORPHMaskForm::SetVisualComp(MaskOptions init)
{
   switch(init.Size()){
      case(0):
         SizeRadioGroup->ItemIndex = 0;
         break;
      case(1):
         SizeRadioGroup->ItemIndex = 1;
         break;
   }
   switch(init.Shape()){
      case(0):
         ShapeRadioGroup->ItemIndex = 0;
         break;
      case(1):
         ShapeRadioGroup->ItemIndex = 1;
         break;
      case(2):
         ShapeRadioGroup->ItemIndex = 2;
         break;
      case(3):
         ShapeRadioGroup->ItemIndex = 3;
         break;
      case(4):
         ShapeRadioGroup->ItemIndex = 4;
         break;
   }
}
//---------------------------------------------------------------------------
void __fastcall TMORPHMaskForm::OKBitBtnClick(TObject *Sender)
{
   MORPHForm->GetMaskOptions() = mask_options;
}
//---------------------------------------------------------------------------

