/*
   MORPHNewSizeMaskUnit.cpp

   definin soubor okna pro zvolen velikosti morfologick masky

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "MORPHNewSizeMaskUnit.h"
#include "MORPHUsersMaskUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMORPHNewSizeMaskForm *MORPHNewSizeMaskForm;
//---------------------------------------------------------------------------
__fastcall TMORPHNewSizeMaskForm::TMORPHNewSizeMaskForm(TComponent* Owner)
        : TForm(Owner)
{
   Top = MORPHUsersMaskForm->Top + 20;
   Left = MORPHUsersMaskForm->Left + 20;
}
//---------------------------------------------------------------------------
void __fastcall TMORPHNewSizeMaskForm::FormClose(TObject *Sender,
      TCloseAction &Action)
{
   Release();
}
//---------------------------------------------------------------------------
void __fastcall TMORPHNewSizeMaskForm::BitBtn1Click(TObject *Sender)
{
  try{
      int new_cols = ColsEdit->Text.ToDouble();
      int new_rows = RowsEdit->Text.ToDouble();
      if(!((new_cols>=1)&&(new_cols<=15)&&(new_rows>=1)&&(new_rows<=15)))
         throw Exception("Number of rows and columns must be between 0 and 15");
      MORPHUsersMaskForm->SetNewSizeMask(new_cols, new_rows);
      Close();
   }catch(EConvertError &E){
      Application->MessageBox(E.Message.c_str(),
         "User's Mask",MB_ICONQUESTION|MB_OK);
   }catch(Exception &E){
      Application->MessageBox(E.Message.c_str(),
         "User's Mask",MB_ICONQUESTION|MB_OK);
   }

}
//---------------------------------------------------------------------------
