/*
   MORPHThreshUnit.cpp

   definin soubor okna pro transformaci edotnovho obrazu na binrn.

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "MORPHThreshUnit.h"
#include "MORPHUnit.h"
#include "PictureUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMORPHThreshForm *MORPHThreshForm;
//---------------------------------------------------------------------------
__fastcall TMORPHThreshForm::TMORPHThreshForm(TComponent* Owner)
        : TForm(Owner), brightness(NULL),lut_base(NULL)
{
   Top = PictureForm->Top+30;
   Left = PictureForm->Left + PictureForm->Width - 30 - Width;

   handler = new BMPHandler(*(PictureForm->GetBMPHandler()));
   hist_image = new GreyImage();
   orig_image = new GreyImage();
   handler->Set(*hist_image);
   handler->Set(*orig_image);
   height_with_thresh = Height;
   ThresholdRadioGroup->ItemIndex = 0;
}
//---------------------------------------------------------------------------
__fastcall TMORPHThreshForm::~TMORPHThreshForm()
{
   delete (handler);
   delete (orig_image);
   delete (hist_image);
   delete (brightness);
   delete (lut_base);
}

void __fastcall TMORPHThreshForm::ThresholdRadioGroupClick(TObject *Sender)
{
    switch(ThresholdRadioGroup->ItemIndex){
       case(0) :
          Height = height_with_thresh*0.4545;
          delete (brightness);
          brightness = new Brightness(*orig_image, *hist_image);
          for(int i(0); i<256; i++){
             if(i<128)
                lutable[i] = 0;
             else
                lutable[i] = 255;
          }
          brightness->ApplyLUT(lutable, 0, 0,
                orig_image->Cols(),orig_image->Rows());
          PictureForm->GetBMPHandler()->Assign(*hist_image);
          PictureForm->GetBMPHandler()->Show(PictureForm->Image);
          break;
       case(1) :
          brightness = new Brightness(*orig_image, *hist_image);
          lut_base = new LUTThreshold(ThresholdImage, ThresholdPanel);
          lut_base->DrawFrame();
          lut_base->DrawChart();
          Height = height_with_thresh ;//363
          break;
    }
}
//---------------------------------------------------------------------------


void __fastcall TMORPHThreshForm::ThresholdImageMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
   lut_base->OnMouseUp(Button, X, Y);
}
//---------------------------------------------------------------------------

void __fastcall TMORPHThreshForm::ThresholdImageMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
   lut_base->OnMouseDown(Button, X, Y);
}
//---------------------------------------------------------------------------

void __fastcall TMORPHThreshForm::ThresholdImageMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
   lut_base->OnMouseMove(X, Y);
   if(lut_base->Down()==true){
      LUTTimer->Enabled = true;
      LUTTimer->Tag = 1;
   }
   else{
      LUTTimer->Enabled = false;
   }
}
//---------------------------------------------------------------------------

void __fastcall TMORPHThreshForm::LUTTimerTimer(TObject *Sender)
{
   if(LUTTimer->Tag==1){
      brightness->ApplyLUT(lut_base->GetLUT(), 0, 0,
                orig_image->Cols(),orig_image->Rows());
      PictureForm->GetBMPHandler()->Assign(*hist_image);
      PictureForm->GetBMPHandler()->Show(PictureForm->Image);
      LUTTimer->Tag = 0;
   }
}
//---------------------------------------------------------------------------

void __fastcall TMORPHThreshForm::BitBtn2Click(TObject *Sender)
{
   PictureForm->GetBMPHandler()->Assign(*orig_image);
   PictureForm->GetBMPHandler()->Show(PictureForm->Image);
}
//---------------------------------------------------------------------------



void __fastcall TMORPHThreshForm::FormClose(TObject *Sender,
      TCloseAction &Action)
{
   Release();        
}
//---------------------------------------------------------------------------

