/*
   MORPHThreshUnit.h

   hlavikov soubor okna pro transformaci edotnovho obrazu na binrn.

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef MORPHThreshUnitH
#define MORPHThreshUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
#include "..\Headers\bmp_handler.h"
#include "..\Headers\lut_base.h"
#include "..\Headers\lut_threshold.h"
#include "..\Headers\image_grey.h"
#include "..\Headers\brightness.h"
#include "..\Headers\lut.h"
//---------------------------------------------------------------------------
class TMORPHThreshForm : public TForm
{
__published:	// IDE-managed Components
        TPanel *Panel1;
        TRadioGroup *ThresholdRadioGroup;
        TPanel *ThresholdPanel;
        TBevel *Bevel1;
        TImage *ThresholdImage;
        TBitBtn *BitBtn1;
        TBitBtn *BitBtn2;
        TTimer *LUTTimer;
        void __fastcall ThresholdRadioGroupClick(TObject *Sender);
        void __fastcall ThresholdImageMouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall ThresholdImageMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall ThresholdImageMouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
        void __fastcall LUTTimerTimer(TObject *Sender);
        void __fastcall BitBtn2Click(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
private:	// User declarations
        BMPHandler* handler;
        Brightness* brightness;
        GreyImage* hist_image, *orig_image;
        LUTBase* lut_base;
        LUT lutable;
        int height, height_with_thresh;
public:		// User declarations
        __fastcall TMORPHThreshForm(TComponent* Owner);
        __fastcall ~TMORPHThreshForm();
};
//---------------------------------------------------------------------------
extern PACKAGE TMORPHThreshForm *MORPHThreshForm;
//---------------------------------------------------------------------------
#endif
