/*
   MORPHUnit.h

   hlavikov soubor hlavnho okna morfologie.

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef MORPHUnitH
#define MORPHUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ToolWin.hpp>
#include <ImgList.hpp>
#include <Menus.hpp>
#include "..\Headers\bmp_handler.h"
#include <Buttons.hpp>
#include <Graphics.hpp>
#include "..\Headers\vmask.h"
#include "..\Headers\mask_options.h"
#include "..\Headers\morpholog_binary.h"
#include "..\Headers\morpholog_grey.h"
#include "..\Headers\list_image.h"

//---------------------------------------------------------------------------
class TMORPHForm : public TForm
{
__published:	// IDE-managed Components
        TBevel *Bevel1;
        TPanel *Panel1;
        TPanel *Panel2;
        TStatusBar *StatusBar;
        TProgressBar *ProgressBar;
        TMainMenu *MainMenu1;
        TRadioGroup *FiltersRadioGroup;
        TBitBtn *PerformBitBtn;
        TBitBtn *OKBitBtn;
        TBitBtn *CancelBitBtn;
        TMenuItem *MMask;
        TMenuItem *MIPSMask;
        TMenuItem *MEdit;
        TMenuItem *MUndo;
        TMenuItem *MUsersMask;
        void __fastcall CancelBitBtnClick(TObject *Sender);
        void __fastcall PerformBitBtnClick(TObject *Sender);
        void __fastcall MIPSMaskClick(TObject *Sender);
        void __fastcall MUndoClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall MUsersMaskClick(TObject *Sender);
        void __fastcall OKBitBtnClick(TObject *Sender);
private:	// User declarations
        MaskOptions mask_options;
        GreyImage* original_image,* before_image, * after_image;
        GreyImage** image;
        Morpholog* morpholog;
        VMask* mask;
        BMPHandler* handler;
        ListI<GreyImage>* list;
        bool __fastcall OnlyBinaryValues(GreyImage* image);
        void __fastcall AssignStatusBar(MaskOptions init);
public:		// User declarations
        __fastcall TMORPHForm(TComponent* Owner);
        __fastcall ~TMORPHForm();
        MaskOptions& GetMaskOptions() { return mask_options; }
        VMask& GetMask() { return *mask;}
};
//---------------------------------------------------------------------------
extern PACKAGE TMORPHForm *MORPHForm;
//---------------------------------------------------------------------------
#endif
