/*
   MORPHUserMaskUnit.h

   hlavikov soubor okna vytvoen nov masky.

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef MORPHUsersMaskUnitH
#define MORPHUsersMaskUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include "..\Headers\vmask.h"

const int box_top = 32;
const int box_left = 40;
const int diff_left = 30;
const int diff_top = 30; 

const int buttons_differ = 103;
const int absolute_differ = 43;
//---------------------------------------------------------------------------
class TMORPHUsersMaskForm : public TForm
{
__published:	// IDE-managed Components
        TBevel *Bevel1;
        TPanel *Panel;
        TBitBtn *OKButton;
        TBitBtn *CancelBitBtn;
        TBitBtn *Set1BitBtn;
        TMainMenu *MainMenu1;
        TMenuItem *MMask;
        TMenuItem *MSize;
        TMenuItem *M3x3;
        TMenuItem *M5x5;
        TMenuItem *MAnother;
        TBitBtn *ResetBitBtn;
        TMenuItem *N7x71;
        void __fastcall M3x3Click(TObject *Sender);
        void __fastcall M5x5Click(TObject *Sender);
        void __fastcall FormResize(TObject *Sender);
        void __fastcall MAnotherClick(TObject *Sender);
        void __fastcall Set1BitBtnClick(TObject *Sender);
        void __fastcall ResetBitBtnClick(TObject *Sender);
        void __fastcall OKButtonClick(TObject *Sender);
        void __fastcall N7x71Click(TObject *Sender);
private:	// User declarations
        TCheckBox** box;
        VMask* mask;
        int rows_num, cols_num;
        int form_width, form_height;
        void SetSize(int _cols, int _rows);
        void DeleteBox();
public:		// User declarations
        __fastcall TMORPHUsersMaskForm(TComponent* Owner);
        __fastcall ~TMORPHUsersMaskForm();
        void __fastcall SetNewSizeMask(int _c, int _r);
};
//---------------------------------------------------------------------------
extern PACKAGE TMORPHUsersMaskForm *MORPHUsersMaskForm;
//---------------------------------------------------------------------------
#endif
