/*
   morpholog_binary.h

   hlavikov soubor tdy BinMorpholog pro morfologick operace nad
   binrnmi obrazy.

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef morpholog_binaryH
#define morpholog_binaryH
//---------------------------------------------------------------------------
#include "morpholog.h"
#include "MORPHUnit.h"
// class for binary morphological operation - descendant from an abstract
// class Morholog

class BinMorpholog : public Morpholog
{
public:
   // constructors
   BinMorpholog()
     :Morpholog() {}
   BinMorpholog(GreyImage* _orig_image, GreyImage* _morph_image,
                VMask* _mask)
     :Morpholog(_orig_image, _morph_image, _mask){}
   ~BinMorpholog(){}
   // memeber function
   void Dilation();
   void Erosion();
   void Close();
   void Open();
   void Outline();
   void Skeleton();
   void ConditionalDilatation();
}; // class BinMorpholog
#endif
