/*
   morpholog_grey.h

   hlavikov soubor tdy GreyMorpholog pro morfologick operace nad
   edotnovmi obrazy.

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef morpholog_greyH
#define morpholog_greyH
//---------------------------------------------------------------------------
#include "morpholog.h"
#include "MORPHUnit.h"
// class for greylevel morphological operation - descendant from an abstract
// class Morholog

class GreyMorpholog : public Morpholog
{
public:
   // constructors
   GreyMorpholog()
     :Morpholog() {}
   GreyMorpholog(GreyImage* _orig_image, GreyImage* _morph_image,
                 VMask* _mask)
     :Morpholog(_orig_image, _morph_image, _mask){}
   ~GreyMorpholog(){}
   // memeber function
   void Dilation();
   void Erosion();
   void Close();
   void Open();
   void Outline();
   void ConditionalDilatation();
   // only greylavel
   void TopHat();
}; // class GreyMorpholog
//---------------------------------------------------------------------------
#endif
