/*
   NoiseUnit.h

   hlavikov soubor hlavnho okna pro generaci umu

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef NoiseUnitH
#define NoiseUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "..\Headers\bmp_handler.h"
#include "noise.h"
#include "..\Headers\noise_options.h"
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
//---------------------------------------------------------------------------
class TNoiseForm : public TForm
{
__published:	// IDE-managed Components
        TBevel *Bevel1;
        TPanel *Panel1;
        TBitBtn *BitBtn1;
        TBitBtn *BitBtn2;
        TRadioGroup *NoiseRadioGroup;
        TGroupBox *GroupBox1;
        TEdit *Edit1;
        TLabel *Label1;
        TLabel *Label2;
        TEdit *Edit2;
        TStatusBar *StatusBar;
        TGroupBox *GroupBox2;
        TBitBtn *PerformBitBtn;
        TBitBtn *ResetBitBtn;
        TProgressBar *ProgressBar;
        void __fastcall PerformBitBtnClick(TObject *Sender);
        void __fastcall NoiseRadioGroupClick(TObject *Sender);
        void __fastcall ResetBitBtnClick(TObject *Sender);
        void __fastcall BitBtn2Click(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall BitBtn1Click(TObject *Sender);
private:	// User declarations
        BMPHandler* handler;
        GreyImage* orig_image, *image;
        Noise* noise;
        NoiseOptions noise_options;
        void __fastcall Perform();
        bool changed;
public:		// User declarations
        __fastcall TNoiseForm(TComponent* Owner);
        __fastcall ~TNoiseForm();
};
//---------------------------------------------------------------------------
extern PACKAGE TNoiseForm *NoiseForm;
//---------------------------------------------------------------------------
#endif
