/*
   PictureUnit.h

   hlavikov soubor hlavnho okna programu

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef PictureUnitH
#define PictureUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include "Headers\in_out.h"
#include <ComCtrls.hpp>
#include <Dialogs.hpp>
#include "Headers\asci.h"
#include "Headers\sgi.h"
#include "Headers\dig.h"
#include "Headers\bmp_handler.h"
#include "Headers\bmp_handler_color.h"
#include "Headers\bmp.h"
#include "Headers\list_image.h"
#include "Headers\image_grey.h"
#include "Headers\image_color.h"
#include "Headers\image.h"
#include "Headers\image_const.h"
#include "Headers\image_float.h"
#include "Headers\size_bmp_g.h"
#include "Headers\num_part.h"
#include "Headers\assert.h"
#include "Headers\vpoint.h"
#include "Headers\nonlinear_filter.h"
#include "Headers\edge_detector.h"
#include <Dialogs.hpp>
#include <ComCtrls.hpp>
#include <Buttons.hpp>
//---------------------------------------------------------------------------
#define MAX_COLS 1024
#define MAX_ROWS 1024
const AnsiString AppName("MIPS 2.0 - Microscopy Image Processing Software");

//enum ImageType { bmp, txt, sgi, dig };
enum ImageType { bmp };

//static AnsiString extention[4] = {".bmp", ".txt", ".sgi", ".dig"};
static AnsiString extention[4] = {".bmp"};

class TPictureForm : public TForm
{
__published:	// IDE-managed Components
        TMainMenu *MainMenu1;
        TMenuItem *MFile;
        TMenuItem *Open1;
        TMenuItem *MSave;
        TMenuItem *MSaveAs;
        TMenuItem *Exit1;
        TMenuItem *MEdit;
        TMenuItem *MUndo1;
        TMenuItem *MCut1;
        TMenuItem *MResize1;
        TMenuItem *MRotate1;
        TMenuItem *Horizontally1;
        TMenuItem *Vertically1;
        TMenuItem *N3;
        TMenuItem *RotateLeft1;
        TMenuItem *RotateRight1;
        TMenuItem *Rotate1;
        TMenuItem *RotateFreely1;
        TMenuItem *MView;
        TMenuItem *MActualView1;
        TMenuItem *MZoomIn1;
        TMenuItem *MZoomOut1;
        TMenuItem *MImage;
        TMenuItem *MNoise1;
        TMenuItem *MHistogram1;
        TMenuItem *MConvolution1;
        TMenuItem *LUT1;
        TMenuItem *DFT1;
        TMenuItem *MLogicArith1;
        TMenuItem *MObject1;
        TMenuItem *MMorpholog1;
        TMenuItem *MMorphBinary1;
        TMenuItem *MMorphGreylevel1;
        TMenuItem *MNonlinearFiltres1;
        TMenuItem *MMaximum;
        TMenuItem *MMedian;
        TMenuItem *MMinimum;
        TMenuItem *MHarmonicMean;
        TMenuItem *MMidpoint;
        TMenuItem *MGeometricMean;
        TMenuItem *N4;
        TMenuItem *SizeMedian;
        TMenuItem *MBitFields1;
        TMenuItem *MBit1;
        TMenuItem *MBit2;
        TMenuItem *MBit3;
        TMenuItem *MBit4;
        TMenuItem *MBit5;
        TMenuItem *MBit6;
        TMenuItem *MBit7;
        TMenuItem *MBit8;
        TMenuItem *MSobelFilters1;
        TMenuItem *MVerticalSobel;
        TMenuItem *MHorizontalSobel;
        TMenuItem *MEdgeMagnitude;
        TMenuItem *MEdgeMagnitudePure;
        TMenuItem *MEdgePhase;
        TOpenDialog *OpenDialog;
        TMenuItem *MTranslate;
        TSaveDialog *SaveDialog;
        TMenuItem *MFFTSize;
        TMenuItem *MProfile;
        TMenuItem *MContrast;
        TMenuItem *MColor;
        TMenuItem *MAbout;
        TMenuItem *MViewHistogram;
        TMenuItem *MEqualizationHistogram;
        TMenuItem *Stretching1;
        TMenuItem *HistogramAdjustment1;
        TMenuItem *Licence1;
        TMenuItem *AboutMIPS1;
        TMenuItem *MAveraging;
        TMenuItem *N1;
        TMenuItem *MPseudoColor;
        TMenuItem *Profile1;
        TMenuItem *MBrightness;
        TMenuItem *MSplitToRGB;
        TMenuItem *MCharacteristics;
        TMenuItem *Centroid1;
        TMenuItem *MFlatField;
        TMenuItem *MStatistics;
        TMenuItem *MShowMoreImage;
        TMenuItem *N2;
        TMenuItem *N5;
        TMenuItem *N2Images1;
        TMenuItem *N4Images1;
        TMenuItem *N6Images1;
        TMenuItem *MGreyScale;
        TMenuItem *MAdjust;
        TMenuItem *N6;
        TMenuItem *MHSV;
        TMenuItem *MHSL;
        TMenuItem *RGB1;
        TMenuItem *CMYK1;
        TMenuItem *MMagnifyingGlass;
        TMenuItem *Profile3;
        TMenuItem *MCorrection;
        TMenuItem *MNonUniformIllumination;
        TMenuItem *Profile2;
        TMenuItem *N7;
        TMenuItem *N8;
        TMenuItem *PSNR1;
        TMenuItem *Specification1;
        TMenuItem *DFT11;
        TMenuItem *DFT12;
        TStatusBar *StatusBar1;
        TPanel *Panel1;
        TScrollBar *ScrollBarVertical;
        TScrollBar *ScrollBarHorizontal;
        TPanel *MainPanel;
        TPanel *Panel;
        TImage *Image;
        TMenuItem *GammaAdjustment1;
        TMenuItem *N9;
        void __fastcall Open1Click(TObject *Sender);
        void __fastcall ImageMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
        void __fastcall FormMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
        void __fastcall MCut1Click(TObject *Sender);
        void __fastcall MUndo1Click(TObject *Sender);
        void __fastcall MTranslateClick(TObject *Sender);
        void __fastcall ImageMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall ImageMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
        void __fastcall MObject1Click(TObject *Sender);
        void __fastcall RotateFreely1Click(TObject *Sender);
        void __fastcall MResize1Click(TObject *Sender);
        void __fastcall MSaveClick(TObject *Sender);
        void __fastcall MSaveAsClick(TObject *Sender);
        void __fastcall Horizontally1Click(TObject *Sender);
        void __fastcall Vertically1Click(TObject *Sender);
        void __fastcall RotateLeft1Click(TObject *Sender);
        void __fastcall RotateRight1Click(TObject *Sender);
        void __fastcall Rotate1Click(TObject *Sender);
        void __fastcall MActualView1Click(TObject *Sender);
        void __fastcall MZoomIn1Click(TObject *Sender);
        void __fastcall MZoomOut1Click(TObject *Sender);
        void __fastcall MConvolution1Click(TObject *Sender);
        void __fastcall MNoise1Click(TObject *Sender);
        void __fastcall LUT1Click(TObject *Sender);
        void __fastcall MFFTSizeClick(TObject *Sender);
        void __fastcall MContrastClick(TObject *Sender);
        void __fastcall MVerticalSobelClick(TObject *Sender);
        void __fastcall MBit1Click(TObject *Sender);
        void __fastcall MMaximumClick(TObject *Sender);
        void __fastcall SizeMedianClick(TObject *Sender);
        void __fastcall MMorphBinary1Click(TObject *Sender);
        void __fastcall MMorphGreylevel1Click(TObject *Sender);
        void __fastcall MLogicArith1Click(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall Exit1Click(TObject *Sender);
        void __fastcall MViewHistogramClick(TObject *Sender);
        void __fastcall AboutMIPS1Click(TObject *Sender);
        void __fastcall Licence1Click(TObject *Sender);
        void __fastcall MAveragingClick(TObject *Sender);
        void __fastcall MPseudoColorClick(TObject *Sender);
        void __fastcall MBrightnessClick(TObject *Sender);
        void __fastcall Profile1Click(TObject *Sender);
        void __fastcall MSplitToRGBClick(TObject *Sender);
        void __fastcall Centroid1Click(TObject *Sender);
        void __fastcall MFlatFieldClick(TObject *Sender);
        void __fastcall MStatisticsClick(TObject *Sender);
        void __fastcall MEqualizationHistogramClick(TObject *Sender);
        void __fastcall Stretching1Click(TObject *Sender);
        void __fastcall N2Images1Click(TObject *Sender);
        void __fastcall N4Images1Click(TObject *Sender);
        void __fastcall N6Images1Click(TObject *Sender);
        void __fastcall MGreyScaleClick(TObject *Sender);
        void __fastcall MHSVClick(TObject *Sender);
        void __fastcall MHSLClick(TObject *Sender);
        void __fastcall RGB1Click(TObject *Sender);
        void __fastcall CMYK1Click(TObject *Sender);
        void __fastcall MMagnifyingGlassClick(TObject *Sender);
        void __fastcall Profile3Click(TObject *Sender);
        void __fastcall MNonUniformIlluminationClick(TObject *Sender);
        void __fastcall Profile2Click(TObject *Sender);
        void __fastcall PSNR1Click(TObject *Sender);
        void __fastcall Specification1Click(TObject *Sender);
        void __fastcall DFT11Click(TObject *Sender);
        void __fastcall DFT12Click(TObject *Sender);
        void __fastcall FormResize(TObject *Sender);
        void __fastcall MainPanelMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
        void __fastcall ScrollBarHorizontalChange(TObject *Sender);
        void __fastcall ScrollBarVerticalChange(TObject *Sender);
        void __fastcall GammaAdjustment1Click(TObject *Sender);
        void __fastcall HistogramAdjustment1Click(TObject *Sender);
        void __fastcall ImageClick(TObject *Sender);
private:	// User declarations
        BMPHandler* handler;
        BMPHandler* other_handler;
        BMPHandlerColor* color_handler;
        ListI<GreyImage>* list;
        ListI<ColorImage>* color_list;
        NonlinearFilter* nonlinear_filter;
        GreyImage* image;
        VInOut* file;
        ColorImage* color_image;
        int nf_cols, nf_rows;
        int filter_index;
        int RGB_component; // if 0 -> is off, R=1,G=2, B=3
        int pos_x, pos_y, diff_x, diff_y; // for distance measurning
        bool measuring; // for distance measurning
        AnsiString ext, file_name;
        bool profile, show_profile;
        double scale_const;
        int morph_kind; // ==0 binary, ==1 greylevel
        bool __fastcall IfFileExistsOverWrite(AnsiString file_path);
        bool __fastcall CheckSize(int cols, int rows);
        int min_height, min_width;
        int undo_level, undo_level_color;
        bool get_other_handler;
public:		// User declarations
        __fastcall TPictureForm(TComponent* Owner);
        __fastcall ~TPictureForm();
        void   __fastcall InitialPicture(AnsiString _file_path,
                                         ImageType _image_type);
        void   __fastcall InitialColorPicture(AnsiString _file_path,
                                         ImageType _image_type);
        void   __fastcall AssignImage(GreyImage* image);
        void   __fastcall AssignColorImage(ColorImage* color_image);
        void   __fastcall AssignList(GreyImage* image);
        void   __fastcall AssignColorList(ColorImage* color_image);
        BMPHandler* __fastcall GetBMPHandler();
        BMPHandlerColor* __fastcall GetBMPHandlerColor() { return color_handler; }
        void   __fastcall AssignBMPHandler(GreyImage* image) {handler->Assign(*image);}
        int GetMorphKind() { return morph_kind; }
        void __fastcall ChangeColorPalette(Graphics::TBitmap* _bitmap);
        void __fastcall ShowProfileOff();
        void __fastcall CreateGreyImage(GreyImage* image);
        void __fastcall CreateColorImage(ColorImage* color_image);
        void __fastcall ChangeTypeOfRGB(int _RGB_component) {RGB_component = _RGB_component;}
        void __fastcall SizeAdaptation();
        void __fastcall OtherHandler(bool type) {get_other_handler = type;}
        void __fastcall ChangeOtherHandler(GreyImage* image) {other_handler->CreateBitmapAndAssign(image);}
};
//---------------------------------------------------------------------------
extern PACKAGE TPictureForm *PictureForm;
//---------------------------------------------------------------------------
#endif
