/*
   ColorMapEditorUnit.h

   hlavikov soubor okna pro definici barevn palety pro pseudobarevn
   obohacen obrazu

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef ColormapEditorUnitH
#define ColormapEditorUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include "Headers\bmp_handler.h"
#include "Headers\image_grey.h"
#include "Headers\geometric_image.h"
#include "Headers\pseudo_color.h"
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>
#include <ComCtrls.hpp>
//---------------------------------------------------------------------------
class TColorMapForm : public TForm
{
__published:	// IDE-managed Components
        TPanel *Panel1;
        TBitBtn *BitBtn1;
        TBitBtn *BitBtn2;
        TColorDialog *ColorDialog;
        TPanel *Panel6;
        TPanel *Panel4;
        TButton *Button1;
        TEdit *Edit1;
        TEdit *Edit2;
        TCheckBox *CheckBox1;
        TPanel *Panel7;
        TLabel *Label1;
        TLabel *Label2;
        TLabel *Label3;
        TLabel *Label4;
        TPanel *Panel2;
        TButton *Button2;
        TButton *Perform_Button;
        TButton *Reset_Button;
        TImage *PaletteImage;
        TLabel *Label5;
        TLabel *Label6;
        TLabel *Label7;
        TStatusBar *StatusBar1;
        TLabel *Label8;
        TLabel *Label9;
        TLabel *Label10;
        TLabel *Label11;
        TLabel *Label12;
        TLabel *Label13;
        void __fastcall BitBtn1Click(TObject *Sender);
        void __fastcall BitBtn2Click(TObject *Sender);
        void __fastcall Reset_ButtonClick(TObject *Sender);
        void __fastcall CheckBox1Click(TObject *Sender);
        void __fastcall Button1Click(TObject *Sender);
        void __fastcall Button2Click(TObject *Sender);
        void __fastcall Perform_ButtonClick(TObject *Sender);
        void __fastcall Edit1Change(TObject *Sender);
        void __fastcall Edit2Change(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
private:	// User declarations
        int start_level, end_level;
        int palette[3][256];
        TMemoryStream* stream;
        PseudoColor* pseudo;
public:		// User declarations
        __fastcall TColorMapForm(TComponent* Owner);
        __fastcall ~TColorMapForm();
};
//---------------------------------------------------------------------------
extern PACKAGE TColorMapForm *ColorMapForm;
//---------------------------------------------------------------------------
#endif
