/*
   PseudoUnit.cpp

   definin soubor okna pro pseudobarevn obohacen obrazu

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "PseudoUnit.h"
#include "PictureUnit.h"
#include "ColorMapEditorUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TPseudoColorsForm *PseudoColorsForm;
//---------------------------------------------------------------------------
// default constructor
__fastcall TPseudoColorsForm::TPseudoColorsForm(TComponent* Owner)
        : TForm(Owner)
{
   Top = PictureForm->Top+30;
   Left = PictureForm->Left + PictureForm->Width - 30 - Width;
   return_image = true;

   original_image = new GreyImage();
   sized_image = new GreyImage();

   pseudocolor_handler = new BMPHandler(*(PictureForm->GetBMPHandler()));
   pseudocolor_handler->Set(*original_image);

   Scale scale(*original_image, *sized_image, Original_Image->Width);

   if (sized_image->Cols() > sized_image->Rows()){
     PseudoColor_Image->Top=PseudoColor_Image->Top + (sized_image->Cols()-sized_image->Rows())/2;
   }else if (sized_image->Rows() > sized_image->Cols()){
     PseudoColor_Image->Left=PseudoColor_Image->Left + (sized_image->Rows()-sized_image->Cols())/2;
   }

   pseudocolor_handler->Assign(*sized_image);
   pseudocolor_handler->Show(Original_Image);
   pseudocolor_handler->Show(PseudoColor_Image);

   pseudo = new PseudoColor();
   stream = new TMemoryStream;
   bitmap = NULL;
   pseudo->ChangePalette(custom_palette, GREY);
   pseudo->ChangePalette(palette, GREY);
   StatusBar1->SimpleText = "Select the type of colormap and click to Perform button.";
}
//---------------------------------------------------------------------------
__fastcall TPseudoColorsForm::~TPseudoColorsForm()
{
}
//---------------------------------------------------------------------------
// close window and show original image in the main window
void __fastcall TPseudoColorsForm::BitBtn1Click(TObject *Sender)
{
   Close();
}
//---------------------------------------------------------------------------
// use palette
void __fastcall TPseudoColorsForm::Perform(TObject *Sender)
{
   delete stream; stream = new TMemoryStream;
   if (ComboBox1->ItemIndex != 7){
      pseudo->Transform(sized_image, stream, palette);
   }else{
      pseudo->Transform(sized_image, stream, custom_palette);
   }
   PseudoColor_Image->Picture->Bitmap->LoadFromStream(stream);
   CheckBox1->Enabled = true;
   if (CheckBox1->Checked == true){
      return_image = true;
      delete stream; stream = new TMemoryStream;
      if (ComboBox1->ItemIndex != 7){
         pseudo->Transform(original_image, stream, palette);
      }else{
         pseudo->Transform(original_image, stream, custom_palette);
      }
      PictureForm->Image->Picture->Bitmap->LoadFromStream(stream);
   }
   StatusBar1->SimpleText = "You can change the type of colormap.";
   PaletteImage->ShowHint = true;
}
//---------------------------------------------------------------------------
// show in main windows? YES/NO
void __fastcall TPseudoColorsForm::CheckBox1Click(TObject *Sender)
{
   delete stream;
   stream = new TMemoryStream;
   if (ComboBox1->ItemIndex != 7){
      pseudo->Transform(sized_image, stream, palette);
   }else{
      pseudo->Transform(sized_image, stream, custom_palette);
   }
   PseudoColor_Image->Picture->Bitmap->LoadFromStream(stream);
   CheckBox1->Enabled = true;
   if (CheckBox1->Checked == true){
      return_image = true;
      delete stream; stream = new TMemoryStream;
      if (ComboBox1->ItemIndex != 7){
         pseudo->Transform(original_image, stream, palette);
      }else{
         pseudo->Transform(original_image, stream, custom_palette);
      }
      PictureForm->Image->Picture->Bitmap->LoadFromStream(stream);
   }else{
      PictureForm->AssignImage(original_image);
   }
}
//---------------------------------------------------------------------------
// use proper palette
void __fastcall TPseudoColorsForm::ComboBox1Change(TObject *Sender)
{
   delete stream; stream = new TMemoryStream;
   switch(ComboBox1->ItemIndex){
         case(0):
           pseudo->ChangePalette(palette, GREY);
           break;
         case(1):
           pseudo->ChangePalette(palette, BONE);
           break;
         case(2):
           pseudo->ChangePalette(palette, COPPER);
           break;
         case(3):
           pseudo->ChangePalette(palette, HOT);
           break;
         case(4):
           pseudo->ChangePalette(palette, JET);
           break;
         case(5):
           pseudo->ChangePalette(palette, HSV);
           break;
         case(6):
           pseudo->ChangePalette(palette, FLAG);
           break;
         case(7):
           Application->CreateForm(__classid(TColorMapForm), &ColorMapForm);
           ColorMapForm->ShowModal();
           break;
   }

   // show colormap
   if (ComboBox1->ItemIndex != 7){
      pseudo->CreateImageFromPalette(palette, stream);
   }else{
      pseudo->CreateImageFromPalette(custom_palette, stream);
   }

   PaletteImage->Picture->Bitmap->LoadFromStream(stream);
   PaletteImage->ShowHint = true;

   Perform(Sender);
   BitBtn2->Enabled = true;

}
//---------------------------------------------------------------------------
// show original image in the main window
void __fastcall TPseudoColorsForm::FormClose(TObject *Sender,
      TCloseAction &Action)
{
   if (return_image == true){
      PictureForm->AssignImage(original_image);
   }
   if (bitmap!=NULL) {delete bitmap;}
   //delete (original_image);
   //delete (sized_image);
   //delete (pseudocolor_image);
   //delete (pseudocolor_handler);
   //delete (pseudo);
   //delete (stream);
}
//---------------------------------------------------------------------------
// OK button
void __fastcall TPseudoColorsForm::BitBtn2Click(TObject *Sender)
{
   return_image = false;
   delete stream;
   stream = new TMemoryStream;
   if (ComboBox1->ItemIndex != 7){
      pseudo->Transform(original_image, stream, palette);
   }else{
      pseudo->Transform(original_image, stream, custom_palette);
   }
   if (bitmap!=NULL) {delete bitmap;}
   bitmap = new Graphics::TBitmap();
   bitmap->LoadFromStream(stream);
   
   PictureForm->ChangeColorPalette(bitmap);
   Close();
}
//---------------------------------------------------------------------------


