/*
   PseudoUnit.h

   hlavikov soubor okna pro pseudobarevn obohacen obrazu

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef PseudoUnitH
#define PseudoUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include "Headers\bmp.h"
#include "Headers\bmp_handler.h"
#include "Headers\image_grey.h"
#include "Headers\geometric_image.h"
#include "Headers\pseudo_color.h"
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <Dialogs.hpp>
//---------------------------------------------------------------------------
class TPseudoColorsForm : public TForm
{
__published:	// IDE-managed Components
        TPanel *Panel1;
        TPanel *Panel2;
        TPanel *Panel3;
        TBitBtn *BitBtn1;
        TImage *Original_Image;
        TImage *PseudoColor_Image;
        TStatusBar *StatusBar1;
        TPanel *Panel4;
        TCheckBox *CheckBox1;
        TComboBox *ComboBox1;
        TLabel *Label1;
        TImage *PaletteImage;
        TLabel *Label2;
        TLabel *Label3;
        TBitBtn *BitBtn2;
        void __fastcall BitBtn1Click(TObject *Sender);
        void __fastcall Perform(TObject *Sender);
        void __fastcall CheckBox1Click(TObject *Sender);
        void __fastcall ComboBox1Change(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall BitBtn2Click(TObject *Sender);

private:	// User declarations
        int palette[3][256];
        bool return_image;
        TMemoryStream* stream;
        PseudoColor* pseudo;
        BMPHandler* pseudocolor_handler;
        GreyImage* sized_image;
        GreyImage* original_image;
        Graphics::TBitmap* bitmap;

public:		// User declarations
        int custom_palette[3][256];
        __fastcall TPseudoColorsForm(TComponent* Owner);
        __fastcall ~TPseudoColorsForm();

};
//---------------------------------------------------------------------------
extern PACKAGE TPseudoColorsForm *PseudoColorsForm;
//---------------------------------------------------------------------------
#endif
