/*
   ResizeUnit.h

   hlavikov soubor okna pro zmnu velikosti okna

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef Resi\zeUnitH
#define ResizeUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include "..\Headers\bmp_handler.h"
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include "..\Headers\scale.h"

const int LARGER_SIZE_OF_PAPER = 800;
const int MAX_WIDTH = 1024;
const int MAX_HEIGHT = 1024;
//---------------------------------------------------------------------------
class TResizeForm : public TForm
{
__published:	// IDE-managed Components
        TBevel *Bevel1;
        TPanel *Panel1;
        TGroupBox *GroupBox1;
        TGroupBox *GroupBox2;
        TBitBtn *BitBtn1;
        TBitBtn *BitBtn2;
        TPanel *ResizePanel;
        TImage *Image;
        TEdit *WidthEdit;
        TRadioButton *StandardRadioButton;
        TComboBox *StandardComboBox;
        TRadioButton *UserRadioButton;
        TUpDown *WidthUpDown;
        TEdit *HeightEdit;
        TUpDown *HeightUpDown;
        TComboBox *UnitComboBox;
        TLabel *Label1;
        TLabel *Label2;
        TLabel *Label3;
        TLabel *HeightLabel;
        TLabel *WidthLabel;
        TCheckBox *RatioCheckBox;
        void __fastcall WidthEditClick(TObject *Sender);
        void __fastcall HeightEditClick(TObject *Sender);
        void __fastcall UnitComboBoxClick(TObject *Sender);
        void __fastcall StandardComboBoxClick(TObject *Sender);
        void __fastcall WidthEditChange(TObject *Sender);
        void __fastcall WidthUpDownClick(TObject *Sender,
          TUDBtnType Button);
        void __fastcall HeightUpDownClick(TObject *Sender, TUDBtnType Button);
        void __fastcall HeightEditChange(TObject *Sender);
        void __fastcall UnitComboBoxChange(TObject *Sender);
        void __fastcall StandardComboBoxChange(TObject *Sender);
        void __fastcall StandardRadioButtonClick(TObject *Sender);
        void __fastcall BitBtn1Click(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall StandardComboBoxEnter(TObject *Sender);
        void __fastcall RatioCheckBoxClick(TObject *Sender);
private:	// User declarations
        BMPHandler* handler;
        GreyImage* original_image, *resized_image, *proc_image;
        Scale* scale;
        int width, height;
        void __fastcall SetSize(int new_cols, int new_rows);
        void __fastcall SetStandardSize();
        // this function resize original image in to a reasonable size
        // for resize processing
        void __fastcall SetProcSize();
public:		// User declarations
        __fastcall TResizeForm(TComponent* Owner);
        __fastcall ~TResizeForm();
};
//---------------------------------------------------------------------------
extern PACKAGE TResizeForm *ResizeForm;
//---------------------------------------------------------------------------
#endif
  