/*
   RotateUnit.h

   hlavikov soubor okna pro rotaci

   MIPS 2.0 - Microscopy Image Processing Software
   Gerla Vclav, 2005

*/
//---------------------------------------------------------------------------
#ifndef RotateUnitH
#define RotateUnitH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
#include "..\Headers\bmp_handler.h"
#include "..\Headers\Rotate.h"
#include "..\Headers\image_grey.h"
#include "..\Headers\translate.h"
//---------------------------------------------------------------------------
class TRotateForm : public TForm
{
__published:	// IDE-managed Components
        TPanel *Panel1;
        TBitBtn *LeftB;
        TBitBtn *RightB;
        TUpDown *RotateUpDown;
        TBitBtn *CancelBitBtn;
        TBitBtn *OKBitBtn;
        TBitBtn *FlipVBitBtn;
        TBitBtn *FlipHB;
        TColorDialog *ColorDialog;
        TEdit *RotateE;
        TBitBtn *ResetBitBtn;
        TLabel *Label1;
        TLabel *Label2;
        TLabel *Label3;
        TPanel *Panel2;
        TImage *Image1;
        void __fastcall RotateUpDownClick(TObject *Sender,
          TUDBtnType Button);
        void __fastcall LeftBClick(TObject *Sender);
        void __fastcall RightBClick(TObject *Sender);
        void __fastcall FlipHBClick(TObject *Sender);
        void __fastcall CancelBitBtnClick(TObject *Sender);
        void __fastcall FlipVBitBtnClick(TObject *Sender);
        void __fastcall ResetBitBtnClick(TObject *Sender);
        void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall Image1DblClick(TObject *Sender);
        void __fastcall OKBitBtnClick(TObject *Sender);
private:	// User declarations
        BMPHandler* rotated_handler;
        GreyImage* original_image, *old_image;
        GreyImage* rotated_image;
        Rotate* rotate;
        TColor color;
public:		// User declarations
        __fastcall TRotateForm(TComponent* Owner);
        __fastcall ~TRotateForm();
};
//---------------------------------------------------------------------------
extern PACKAGE TRotateForm *RotateForm;
//---------------------------------------------------------------------------
#endif
